Package: biomaRt
Title: Interface to BioMart databases (i.e. Ensembl)
Version: 2.68.0
Authors@R: c(
    person("Steffen", "Durinck", , "biomartdev@gmail.com", role = "aut"),
    person("Wolfgang", "Huber", role = "aut"),
    person("Sean", "Davis", , "sdavis2@mail.nih.gov", role = "ctb"),
    person("Francois", "Pepin", role = "ctb"),
    person("Vince S", "Buffalo", role = "ctb"),
    person("Mike", "Smith", , "grimbough@gmail.com", role = "ctb",
           comment = c(ORCID = "0000-0002-7800-3848")),
    person("Hugo", "Gruson", , "hugo.gruson@embl.de", role = c("ctb", "cre"),
           comment = c(ORCID = "0000-0002-4094-1476")),
    person("German Network for Bioinformatics Infrastructure - de.NBI", role = "fnd")
  )
Description: In recent years a wealth of biological data has become
    available in public data repositories. Easy access to these valuable
    data resources and firm integration with data analysis is needed for
    comprehensive bioinformatics data analysis.  biomaRt provides an
    interface to a growing collection of databases implementing the
    BioMart software suite
    (<https://www.ensembl.org/info/data/biomart/index.html>). The package
    enables retrieval of large amounts of data in a uniform way without
    the need to know the underlying database schemas or write complex SQL
    queries.  The most prominent examples of BioMart databases are
    maintained by Ensembl, which provides biomaRt users direct access to a
    diverse set of data and enables a wide range of powerful online
    queries from gene annotation to database mining.
License: Artistic-2.0
URL: https://github.com/Huber-group-EMBL/biomaRt,
        https://huber-group-embl.github.io/biomaRt/
BugReports: https://github.com/Huber-group-EMBL/biomaRt/issues
Depends: methods, R (>= 4.5.0)
Imports: AnnotationDbi, BiocFileCache, curl, httr2, progress, stringr,
        utils, xml2
Suggests: BiocStyle, httptest2, knitr, mockery, rmarkdown, testthat (>=
        3.0.0), withr
VignetteBuilder: knitr
biocViews: Annotation
Config/Needs/website: xfun
Config/testthat/edition: 3
Encoding: UTF-8
LazyLoad: yes
NeedsCompilation: no
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
Collate: 'biomaRt-package.R' 'biomaRtClasses.R' 'methods-Mart.R'
        'biomaRt.R' 'caching.R' 'ensembl.R' 'ensembl_wrappers.R'
        'ensembl_ssl_settings.R' 'utilityFunctions.R'
        'non-biomart-utils.R' 'exportFASTA.R' 'NP2009code.R'
git_url: https://git.bioconductor.org/packages/biomaRt
git_branch: RELEASE_3_23
git_last_commit: ff93209
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
Packaged: 2026-04-28 20:57:08 UTC; biocbuild
Author: Steffen Durinck [aut],
  Wolfgang Huber [aut],
  Sean Davis [ctb],
  Francois Pepin [ctb],
  Vince S Buffalo [ctb],
  Mike Smith [ctb] (ORCID: <https://orcid.org/0000-0002-7800-3848>),
  Hugo Gruson [ctb, cre] (ORCID: <https://orcid.org/0000-0002-4094-1476>),
  German Network for Bioinformatics Infrastructure - de.NBI [fnd]
Maintainer: Hugo Gruson <hugo.gruson@embl.de>

=============
Biomart 0.4.1
=============

Python API that consumes the biomart webservice.

What it will do:
----------------

* Show all databases of a biomart server
* Show all datasets of a biomart database
* Show attributes and filters of a biomart dataset
* Run your query formatted as a Python dict.

What it won't do:
-----------------

* Process and return the results as JSON,XML,etc. It will only return the Biomart response as TSV format.

Usage
-----

Import Biomart module
::
  
  from biomart import BiomartServer

Connect to a Biomart Server
::
  
  server = BiomartServer( "http://www.biomart.org/biomart" )
  
  # if you are behind a proxy
  import os
  server.http_proxy = os.environ.get('http_proxy', 'http://my_http_proxy.org')

Interact with the biomart server
::
  
  # show server databases
  print server.show_databases()
  
  # show server datasets
  print server.show_datasets()
  
  # use the 'uniprot' dataset
  uniprot = server.datasets['uniprot']
  
  # run a search with the default filters and attributes - equivalent to hitting "Results" on the web interface.
  # this will return a lot of data.
  response = uniprot.search()
  response = uniprot.search( header = 1 ) # if you need the columns header
  
  # response format is TSV
  for line in response.iter_lines():
    print line.split("\t")
  
  # run a count with the default filters and attributes - equivalent to hitting "Count" on the web interface
  response = uniprot.count()
  print response.text
  
  # show all available filters and attributes of the 'uniprot' dataset
  print uniprot.show_filters()
  print uniprot.show_attributes()
  
  # run a search with custom filters and default attributes.
  response = uniprot.search({
    'filters': {
        'accession': 'Q9FMA1'
    }
  }, header = 1 )
  
  response = uniprot.search({
    'filters': {
        'accession': ['Q9FMA1', 'Q8LFJ9']  # ID-list specified accessions
    }
  }, header = 1 )
  
  # run a search with custom filters and attributes
  response = uniprot.search({
    'filters': {
        'accession': ['Q9FMA1', 'Q8LFJ9']
    },
    'attributes': [
        'accession', 'protein_name'
    ]
  })


Shortcut function: connect directly to a biomart dataset
::
  
  from biomart import BiomartDataset
  
  interpro = BiomartDataset( "http://www.biomart.org/biomart", name = 'entry' )
  
  response = interpro.search({
    'filters': { 'entry_id': 'IPR027603' },
    'attributes': [ 'entry_name', 'abstract' ]
  })

# biomaRt <img src="man/figures/logo.svg" align="right" width="120" />

The package provides an R interface to datasets that provide access via the
BioMart software suite.

## Current Status

| GitHub Actions        | BioC           | Test Coverage |
| ------------- |-------------| -----|
| [![R-CMD-check](https://github.com/Huber-group-EMBL/biomaRt/actions/workflows/main.yml/badge.svg)](https://github.com/Huber-group-EMBL/biomaRt/actions/workflows/main.yml) | [![BioC Status](https://bioconductor.org/shields/build/devel/bioc/biomaRt.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/biomaRt/) | [![Codecov](http://img.shields.io/codecov/c/github/grimbough/biomaRt.svg)](https://codecov.io/gh/grimbough/biomaRt) |

## Contact

For bug reports, please register an [issue](https://github.com/grimbough/biomaRt/issues) here on Github. For usage queries please post a question on the [Bioconductor Support Forum](https://support.bioconductor.org/p/new/post/?tag_val=biomaRt).

## Funding

Funding for continued development and maintenance of this package is provided by the German Network for Bioinformatics Infrastructure

<a href="https://www.denbi.de"><img src="https://tess.elixir-europe.org/system/content_providers/images/000/000/063/original/deNBI_Logo_rgb.jpg" width="400" align="left"></a>

structure(list(method = "POST", url = "https://www.ensembl.org/biomart/martservice?redirect=no", 
    status_code = 200L, headers = structure(list(Date = "Fri, 12 Jan 2024 15:37:37 GMT", 
        Server = "Apache", `X-Frame-Options` = "SAMEORIGIN", 
        `Content-Security-Policy` = "frame-ancestors 'self'", 
        `Transfer-Encoding` = "chunked", `Content-Type` = "text/plain; charset=utf-8"), class = "httr2_headers"), 
    body = charToRaw("ENSG00000000003\n"), request = structure(list(
        url = "https://www.ensembl.org/biomart/martservice?redirect=no", 
        method = NULL, headers = list(), body = list(data = list(
            query = structure("%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22UTF-8%22%3F%3E%0A%3C%21DOCTYPE%20Query%3E%0A%3CQuery%20%20virtualSchemaName%20%3D%20%22default%22%20formatter%20%3D%20%22TSV%22%20header%20%3D%20%220%22%20uniqueRows%20%3D%20%220%22%20count%20%3D%20%22%22%20datasetConfigVersion%20%3D%20%220.6%22%20%3E%0A%09%3CDataset%20name%20%3D%20%22hsapiens_gene_ensembl%22%20interface%20%3D%20%22default%22%20%3E%0A%09%09%3CFilter%20name%20%3D%20%22ensembl_gene_id%22%20value%20%3D%20%22ENSG00000000003%22%2F%3E%0A%09%09%3CAttribute%20name%20%3D%20%22ensembl_gene_id%22%20%2F%3E%0A%09%3C%2FDataset%3E%0A%3C%2FQuery%3E", class = "AsIs")), 
            type = "form", content_type = "application/x-www-form-urlencoded", 
            params = list()), fields = list(), options = list(
            timeout_ms = 10000), policies = list()), class = "httr2_request"), 
    cache = new.env(parent = emptyenv())), class = "httr2_response")

###############################
#                             #
# Ensembl specific functions   #
###############################

checkWrapperArgs <- function(id, type, mart) {
  if (missing(type)) {
    stop(
      "Specify the type of identifier you are using, see ?getGene for details. Valid values for the type argument can be found with the listFilters function."
    )
  }
  if (!type %in% listFilters(mart)[, 1]) {
    stop(
      "Invalid identifier type:",
      type,
      " see ?getGene for details. Use the listFilters function to get the valid value for the type argument."
    )
  }
  if (missing(id)) {
    stop(
      "No identifiers specified.  Use the id argument to specify a vector of identifiers for which you want to retrieve the annotation."
    )
  }
}


#' Retrieves gene annotation information given a vector of identifiers
#'
#' This function retrieves gene annotations from Ensembl given a vector of
#' identifiers.  Annotation includes chromosome name, band, start position, end
#' position, gene description and gene symbol.  A wide variety of identifiers
#' is available in Ensembl, these can be found with the listFilters function.
#'
#'
#' @param id vector of gene identifiers one wants to annotate
#' @param type type of identifier, possible values can be obtained by the
#' listFilters function.  Examples are entrezgene_id, hgnc_symbol (for hugo
#' gene symbol), ensembl_gene_id, unigene, agilentprobe, affy_hg_u133_plus_2,
#' refseq_dna, etc.
#' @param mart object of class Mart, containing connections to the BioMart
#' databases.  You can create such an object using the function [useMart()].
#' @author Steffen Durinck
#' @keywords methods
#'
#' @examplesIf interactive()
#' mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")
#'
#' # example using affy id
#' g <- getGene(id = "1939_at", type = "affy_hg_u95av2", mart = mart)
#' show(g)
#'
#' # example using Entrez Gene id
#' g <- getGene(id = "100", type = "entrezgene_id", mart = mart)
#' show(g)
#'
#' @export
getGene <- function(id, type, mart) {
  martCheck(mart, c("ensembl", "ENSEMBL_MART_ENSEMBL"))
  checkWrapperArgs(id, type, mart)
  symbolAttrib <- switch(
    strsplit(martDataset(mart), "_", fixed = TRUE, useBytes = TRUE)[[1]][1],
    hsapiens = "hgnc_symbol",
    mmusculus = "mgi_symbol",
    "external_gene_id"
  )
  typeAttrib <- switch(type, affy_hg_u133a_2 = "affy_hg_u133a_v2", type)
  attrib <- c(
    typeAttrib,
    symbolAttrib,
    "description",
    "chromosome_name",
    "band",
    "strand",
    "start_position",
    "end_position",
    "ensembl_gene_id"
  )
  table <- getBM(attributes = attrib, filters = type, values = id, mart = mart)
  return(table)
}

.checkSequenceArgs <- function(
  seqType,
  type,
  id,
  chromosome,
  upstream,
  downstream
) {
  validSeqTypes <- c(
    "cdna",
    "peptide",
    "3utr",
    "5utr",
    "gene_exon",
    "transcript_exon",
    "transcript_exon_intron",
    "gene_exon_intron",
    "coding",
    "coding_transcript_flank",
    "coding_gene_flank",
    "transcript_flank",
    "gene_flank"
  )
  if (missing(seqType) || !seqType %in% validSeqTypes) {
    stop(
      "Please specify the type of sequence that needs to be retrieved when using biomaRt in web service mode\n.",
      "Valid options are: ",
      paste(validSeqTypes, collapse = ", "),
      call. = FALSE
    )
  }

  if (missing(type)) {
    stop(
      "Please specify the type argument.\n",
      "If you use chromosomal coordinates to retrieve sequences ",
      "then the type argument will specify the type of gene identifiers that you will retrieve with the sequences.\n",
      "If you use a vector of identifiers to retrieve the sequences ",
      "the type argument specifies the type of identifiers you are using."
    )
  }

  ## must use one and only one of 'id' and 'chromosome'
  if (missing(id) && missing(chromosome)) {
    stop(
      "You must provide either the 'id' or 'chromosome' argument.",
      call. = FALSE
    )
  }
  if (!missing(chromosome) && !missing(id)) {
    stop(
      "You must provide only one of the 'id' and 'chromosome' arguments.",
      call. = FALSE
    )
  }

  if (
    grepl(pattern = "flank", x = seqType, fixed = TRUE) &&
      (missing(upstream) && missing(downstream))
  ) {
    stop(
      "You must provide either the 'upstream' or 'downstream' ",
      "argument when requesting flanking sequences.",
      call. = FALSE
    )
  }
}

.getSequenceFromCoords <- function(
  chromosome,
  start,
  end,
  type,
  seqType,
  upstream,
  downstream,
  mart,
  useCache = TRUE,
  verbose = FALSE
) {
  if (missing(start) || missing(end)) {
    stop("You must specify both a start and end position.")
  }

  start <- as.integer(start)
  end <- as.integer(end)

  if (!missing(upstream) && !missing(downstream)) {
    stop(
      "getSequence() only allows specifying either the 'upstream' or 'downstream' argument but not both."
    )
  }

  filters <- list("chromosome_name" = chromosome, "start" = start, "end" = end)

  if (!missing(upstream)) {
    filters[["upstream_flank"]] <- upstream
  } else if (!missing(downstream)) {
    filters[["downstream_flank"]] <- downstream
  }

  sequence <- getBM(
    attributes = c(seqType, type),
    filters = filters,
    mart = mart,
    checkFilters = FALSE,
    verbose = verbose,
    useCache = useCache
  )
  return(sequence)
}

.getSequenceFromId <- function(
  id,
  type,
  seqType,
  upstream,
  downstream,
  mart,
  useCache = TRUE,
  verbose = FALSE
) {
  if (missing(type)) {
    stop(
      "Type argument is missing. ",
      "This will be used to retrieve an identifier along with the sequence so one knows which gene it is from. ",
      "Use the listFilters() function to select a valid type argument."
    )
  }
  if (!type %in% listFilters(mart, what = "name")) {
    stop(
      "Invalid 'type' argument.  Use the listFilters() function to select a valid type argument."
    )
  }

  if (missing(upstream) && missing(downstream)) {
    filters <- list(id)
    names(filters) <- type
  } else if (!missing(upstream) && missing(downstream)) {
    filters <- list(id, upstream)
    names(filters) <- c(type, "upstream_flank")
  } else if (!missing(downstream) && missing(upstream)) {
    filters <- list(id, downstream)
    names(filters) <- c(type, "downstream_flank")
  } else {
    stop(
      "Currently getSequence only allows the user to specify either an upstream of a downstream argument but not both."
    )
  }

  if (type %in% listAttributes(mart, page = "sequences", what = "name")) {
    sequence <- getBM(
      attributes = c(seqType, type),
      filters = filters,
      mart = mart,
      checkFilters = FALSE,
      verbose = verbose,
      useCache = useCache
    )
  } else {
    mapping_id <- getBM(
      attributes = c(type, "ensembl_gene_id"),
      filters = type,
      values = id,
      mart = mart,
      useCache = useCache
    )

    filters[[1]] <- mapping_id$ensembl_gene_id
    names(filters)[1] <- "ensembl_gene_id"

    mapping_seq <- getBM(
      attributes = c(seqType, "ensembl_gene_id"),
      filters = filters,
      mart = mart,
      checkFilters = FALSE,
      verbose = verbose,
      useCache = useCache
    )

    ## merge data.frames and keep rows for any id that doesn't have a match
    sequence <- merge(
      mapping_seq,
      mapping_id,
      by = "ensembl_gene_id",
      all.y = TRUE
    )
    # nolint next: scalar_in_linter.
    sequence <- sequence[, !names(sequence) %in% "ensembl_gene_id"]
  }
  return(sequence)
}


#' Retrieves sequences
#'
#' This function retrieves sequences given the chromosome, start and end
#' position or a list of identifiers. Using getSequence in web service mode
#' (default) generates 5' to 3' sequences of the requested type on the correct
#' strand.
#'
#' The type of sequence returned can be specified by the seqType argument which
#' takes the following values:
#' * 'cdna': for nucleotide sequences
#' * 'peptide': for protein sequences
#' * '3utr': for 3' UTR sequences
#' * '5utr': for 5' UTR sequences
#' * 'gene_exon': for exon sequences only
#' * 'transcript_exon_intron': gives the full unspliced transcript, that is
#'   exons + introns
#' * 'gene_exon_intron' gives the exons + introns of a gene;'coding' gives the
#'   coding sequence only
#' * 'coding_transcript_flank': gives the flanking region of the transcript
#'   including the UTRs, this must be accompanied with a given value for the
#'   upstream or downstream attribute
#' * 'coding_gene_flank': gives the flanking region of the gene including
#'   the UTRs, this must be accompanied with a given value for the upstream or
#'   downstream attribute
#' * 'transcript_flank': gives the flanking region of the transcript excluding
#'   the UTRs, this must be accompanied with a given value for the upstream or
#'   downstream attribute
#' * 'gene_flank': gives the flanking region of the gene excluding the UTRs,
#'   this must be accompanied with a given value for the upstream or downstream
#'   attribute
#'
#' @param chromosome Chromosome name
#' @param start start position of sequence on chromosome
#' @param end end position of sequence on chromosome
#' @param id An identifier or vector of identifiers.
#' @param type The type of identifier used.  Supported types are hugo, ensembl,
#' embl, entrezgene, refseq, ensemblTrans and unigene. Alternatively one can
#' also use a filter to specify the type. Possible filters are given by the
#' [listFilters()] function.
#' @param seqType Type of sequence that you want to retrieve.  Allowed seqTypes
#' are given in the details section.
#' @param upstream To add the upstream sequence of a specified number of
#' basepairs to the output.
#' @param downstream To add the downstream sequence of a specified number of
#' basepairs to the output.
#' @param mart object of class Mart created using the [useEnsembl()]
#' function
#' @param useCache If `useCache = TRUE` then biomaRt will try to store
#' succesful query results on disk, and will load these if a query is run
#' again, rather than contacting the Ensembl server.
#' @param verbose If `verbose = TRUE`` then the XML query that was send to the
#' webservice will be displayed.
#' @author Steffen Durinck, Mike Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' mart <- useEnsembl("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")
#'
#' seq <- getSequence(
#'   id = "BRCA1",
#'   type = "hgnc_symbol",
#'   seqType = "peptide",
#'   mart = mart
#' )
#' show(seq)
#'
#' seq <- getSequence(
#'   id = "1939_at",
#'   type = "affy_hg_u95av2",
#'   seqType = "gene_flank",
#'   upstream = 20,
#'   mart = mart
#' )
#' show(seq)
#'
#' @export
getSequence <- function(
  chromosome,
  start,
  end,
  id,
  type,
  seqType,
  upstream,
  downstream,
  mart,
  useCache = TRUE,
  verbose = FALSE
) {
  martCheck(mart, c("ensembl", "ENSEMBL_MART_ENSEMBL"))

  .checkSequenceArgs(seqType, type, chromosome, id, upstream, downstream)

  if (!missing(chromosome)) {
    sequence <- .getSequenceFromCoords(
      chromosome,
      start,
      end,
      type,
      seqType,
      upstream,
      downstream,
      mart,
      useCache = useCache,
      verbose = verbose
    )
  }

  if (!missing(id)) {
    sequence <- .getSequenceFromId(
      id,
      type,
      seqType,
      upstream,
      downstream,
      mart,
      useCache = useCache,
      verbose = verbose
    )
  }
  return(sequence)
}

test_that("getGene() recognizes new ensembl name as ensembl", {
  # see https://github.com/Huber-group-EMBL/biomaRt/issues/122
  mart <- useMart("ensembl", dataset = "hsapiens_gene_ensembl")

  expect_no_error(
    g <- getGene(id = "1939_at", type = "affy_hg_u95av2", mart = mart)
  )
  expect_identical(nrow(g), 1L)
})

library(biomaRt)

## example Mart object
ex_mart <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  host = "www.ensembl.org",
  attributes = data.frame(
    name = c("ensembl_gene_id", "gene_exon_intron", "hgnc_symbol"),
    page = c("sequences", "sequences", "feature_page")
  ),
  filters = data.frame(
    name = c("ensembl_gene_id", "hgnc_symbol", "gene_exon_intron"),
    description = c(
      "Ensembl ID",
      "HGNC Symbol",
      "Gene seq including exons and introns"
    ),
    type = c("id_list", "id_list", "text")
  )
)

test_that("useEnsembl() error handling is OK", {
  expect_error(useEnsembl(), regexp = "You must provide the argument")

  expect_warning(
    useEnsembl(biomart = "genes", host = "https://ensembl.org"),
    regexp = "You cannot use the host"
  )
})

test_that("useEnsembl(host = ) is not necessary for ensembl.org", {
  # Bug report #72.
  expect_no_error(
    ensembl_mart <- useEnsembl("ensembl")
  )
  expect_s4_class(ensembl_mart, "Mart")
})

with_mock_dir(
  "all_500",
  {
    test_that("Ensembl mirror selection works", {
      expect_error(
        .chooseEnsemblMirror(mirror = NULL),
        regexp = "Unable to query any Ensembl site"
      )
    })
  },
  simplify = FALSE
)

with_mock_dir(
  "www_OK",
  {
    test_that("Ensembl mirror selection works", {
      .chooseEnsemblMirror(mirror = "useast") |>
        expect_equal("www") |>
        expect_message(regexp = "unresponsive")
    })
  },
  simplify = FALSE
)

test_that("Ensembl URLs are constructed correctly", {
  ## no arguments ##
  .constructEnsemblURL() |>
    expect_equal("https://www.ensembl.org") |>
    expect_silent()

  ## mirror ##
  .constructEnsemblURL(mirror = "INVALID_MIRROR") |>
    expect_equal("https://www.ensembl.org") |>
    expect_warning(,
      regexp = "Invalid mirror\\. Select a mirror"
    )

  expect_equal(
    .constructEnsemblURL(mirror = "useast"),
    "https://useast.ensembl.org"
  )

  ## GRCh ##
  expect_equal(.constructEnsemblURL(GRCh = 37), "https://grch37.ensembl.org")

  .constructEnsemblURL(GRCh = 38) |>
    expect_equal("https://www.ensembl.org") |>
    expect_warning(
      regexp = "Only 37 can be specified for GRCh version"
    )

  ## version ##
  expect_silent(.constructEnsemblURL(version = "100")) |>
    expect_equal("https://apr2020.archive.ensembl.org")

  expect_error(
    .constructEnsemblURL(version = "00"),
    regexp = "Specified Ensembl version is not available"
  )

  ## combinations ##
  expect_error(
    .constructEnsemblURL(version = "100", GRCh = 37),
    regexp = "version or GRCh arguments cannot be used together"
  )

  .constructEnsemblURL(mirror = "asia", version = 100) |>
    expect_equal("https://apr2020.archive.ensembl.org") |>
    expect_warning(
      regexp = "version or GRCh arguments cannot be used together with the mirror argument"
    )

  .constructEnsemblURL(mirror = "useast", GRCh = 37) |>
    expect_equal("https://grch37.ensembl.org") |>
    expect_warning(
      regexp = "version or GRCh arguments cannot be used together with the mirror argument"
    )
})

test_that("sequence correct code is used to get sequence based on ID type", {
  skip_if_not_installed("mockery")

  m <- mockery::mock(
    data.frame(hgnc_symbol = "STAT1", ensembl_gene_id = "ENSG00000115415"),
    data.frame(
      gene_exon_intron = "ACGTACGT",
      ensembl_gene_id = "ENSG00000115415"
    ),
    data.frame(
      gene_exon_intron = "ACGTACGT",
      ensembl_gene_id = "ENSG00000115415"
    )
  )

  mockery::stub(.getSequenceFromId, "getBM", m)

  expect_s3_class(
    hgnc <- .getSequenceFromId(
      id = "STAT1",
      type = "hgnc_symbol",
      seqType = "gene_exon_intron",
      mart = ex_mart
    ),
    "data.frame"
  )
  expect_s3_class(
    ens_id <- .getSequenceFromId(
      id = "ENSG00000115415",
      type = "ensembl_gene_id",
      seqType = "gene_exon_intron",
      mart = ex_mart
    ),
    "data.frame"
  )
  expect_identical(hgnc$gene_exon_intron, ens_id$gene_exon_intron)
})

test_that("correct settings are applied for getSequence using coordinates.", {
  skip_if_not_installed("mockery")

  m <- mockery::mock(TRUE, cycle = TRUE)
  mockery::stub(.getSequenceFromCoords, "getBM", m)

  expect_true(.getSequenceFromCoords(
    chromosome = 1,
    start = 1,
    end = 2,
    type = "ensembl_gene_id",
    seqType = "gene_exon_intron",
    mart = ex_mart
  ))
  expect_true(.getSequenceFromCoords(
    chromosome = 1,
    start = 1,
    end = 2,
    upstream = 50,
    type = "ensembl_gene_id",
    seqType = "gene_exon_intron",
    mart = ex_mart
  ))
  expect_true(.getSequenceFromCoords(
    chromosome = 1,
    start = 1,
    end = 2,
    downstream = 50,
    type = "ensembl_gene_id",
    seqType = "gene_exon_intron",
    mart = ex_mart
  ))

  expect_length(mockery::mock_args(m)[[1]]$filters, 3L)
  expect_true("upstream_flank" %in% names(mockery::mock_args(m)[[2]]$filters))
  expect_true("downstream_flank" %in% names(mockery::mock_args(m)[[3]]$filters))
})

test_that("getSequence deploys correct sub-function", {
  skip_if_not_installed("mockery")

  mockery::stub(getSequence, ".getSequenceFromCoords", TRUE)
  mockery::stub(getSequence, ".getSequenceFromId", FALSE)

  expect_true(getSequence(
    chromosome = 1,
    start = 1,
    end = 2,
    type = "ensembl_gene_id",
    seqType = "gene_exon_intron",
    mart = ex_mart
  ))
  expect_false(getSequence(
    id = "STAT1",
    type = "hgnc_symbol",
    seqType = "gene_exon_intron",
    mart = ex_mart
  ))
})

#' Deprecated and defunct functions in package \pkg{biomaRt}
#'
#' These functions have been removed from biomaRt and replaced with
#' alternatives.
#'
#'
#' The following functions are defunct and no longer work; use the replacement
#' indicated below:
#'
#' * filterOptions: [listFilterOptions()]
#' * listFilterValues: [listFilterOptions()]
#' * searchFilterValues: [searchFilterOptions()]
#'
#' @name biomaRt-deprecated
#' @aliases filterOptions searchFilterValues listFilterValues
NULL

#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @import methods
## usethis namespace: end
NULL

###########################################################
## Functions for caching
###########################################################

.createHash <- function(
  mart,
  attributes,
  filters,
  values,
  uniqueRows = TRUE,
  bmHeader = FALSE
) {
  ## if we are using the current version Ensembl URL
  ## swap for the archive version so we can check when it is outdated
  host <- martHost(mart)
  if (grepl("(www|useast|asia)\\.ensembl\\.org", host)) {
    archives <- .listEnsemblArchives(http_config = martHTTPConfig(mart))
    host <- archives[which(archives$current_release == "*"), "url"]
  }

  attributes <- paste(sort(attributes), collapse = "")
  ## need to keep the filters and values in the same order
  ## so create a single index for reordering both
  idx <- order(filters)
  filters <- paste(filters[idx], collapse = "")
  if (is.list(values)) {
    values <- values[idx]
    values <- unlist(lapply(values, sort))
  } else {
    values <- sort(values)
  }
  values <- paste(values, collapse = "")

  combined <- paste(
    c(
      host,
      mart@biomart,
      mart@dataset,
      attributes,
      filters,
      values,
      uniqueRows,
      bmHeader
    ),
    collapse = "_"
  )
  paste0("biomaRt_", tools::md5sum(bytes = charToRaw(combined)))
}

#' @param bfc Object of class BiocFileCache, created by a call to
#' [BiocFileCache::BiocFileCache()]
#' @param hash unique hash representing a query.
#' @importFrom BiocFileCache bfcadd bfcquery bfcupdate
#' @noRd
.addToCache <- function(bfc, result, hash, update = FALSE) {
  if (!dir.exists(.biomartCacheLocation())) {
    dir.create(.biomartCacheLocation())
  }

  ## write our file to the biomart cache location directly
  tf <- tempfile(tmpdir = .biomartCacheLocation())
  saveRDS(result, file = tf)

  ## check once more that there isn't an entry with this hash
  ## if its free add our new file
  ## if there's a clash don't add anything and tidy up
  if (!.checkInCache(bfc, hash = hash)) {
    bfcadd(bfc, rname = hash, fpath = tf, action = "asis")
    return(invisible(TRUE))
  }
  if (!update) {
    file.remove(tf)
    return(invisible(FALSE))
  }
  existing_record <- bfcquery(
    bfc,
    query = hash,
    field = "rname",
    exact = TRUE
  )
  bfcupdate(bfc, rids = existing_record$rid, rpath = tf, ask = FALSE)
  ## deleted the old file
  file.remove(existing_record$rpath)

  return(invisible(TRUE))
}

#' @param bfc Object of class BiocFileCache, created by a call to
#'   [BiocFileCache::BiocFileCache()]
#' @param hash unique hash representing a query.
#' @noRd
#' @importFrom BiocFileCache bfcquery
.readFromCache <- function(bfc, hash) {
  cache_hits <- bfcquery(bfc, hash, field = "rname")
  if (nrow(cache_hits) > 1) {
    stop(
      "Multiple cache results found.",
      "\nPlease clear your cache by running biomartCacheClear()"
    )
  } else {
    rid <- cache_hits$rid
    result <- readRDS(bfc[[rid]])
    return(result)
  }
}

#' @param bfc Object of class BiocFileCache, created by a call to
#'   [BiocFileCache::BiocFileCache()]
#' @param hash unique hash representing a query.
#'
#' This function returns `TRUE` if a record with the requested hash already
#' exists in the file cache, otherwise returns `FALSE`.
#' @keywords Internal
#' @noRd
#' @importFrom BiocFileCache bfcquery
.checkInCache <- function(bfc, hash, verbose = FALSE) {
  res <- bfcquery(bfc, query = hash, field = "rname")
  as.logical(nrow(res))
}

#' @param bfc Object of class BiocFileCache, created by a call to
#' [BiocFileCache::BiocFileCache()]
#' @param hash unique hash representing a query.
#'
#' This function checks if a cache entry is a valid RDS file.
#' Returns `TRUE` if the cache entry is valid, `FALSE` otherwise.
#' In the case of an invalid file the cache entry and file are
#' deleted.
#' @importFrom BiocFileCache bfcquery bfcremove
#' @keywords Internal
#' @noRd
.checkValidCache <- function(bfc, hash) {
  res <- bfcquery(bfc, query = hash, field = "rname")
  if (nrow(res) == 0) {
    return(FALSE)
  } else {
    ## check this is a valid RDS file
    ## remove the cache entry if it's not a valid RDS
    test <- tryCatch(is.list(infoRDS(res$rpath[1])), error = function(e) {
      return(FALSE)
    })
    if (!test) {
      bfcremove(bfc, res$rid[1])
    }
    return(test)
  }
}

.biomartCacheLocation <- function() {
  Sys.getenv(
    x = "BIOMART_CACHE",
    unset = tools::R_user_dir(package = "biomaRt", which = "cache")
  )
}

#' \pkg{biomaRt} result caching
#'
#' \pkg{biomaRt} makes use of a results cache to speedup execution of queries
#' that have been run before. These functions provide details on the status of
#' this cache, and allow it to be deleted.
#'
#'
#' @aliases biomartCacheInfo biomartCacheClear
#' @return These functions do not return anything and are called for their side
#' effects. [biomartCacheInfo()] prints the location of the cache, along
#' with the number of files and their total size on disk.
#' [biomartCacheClear()] will delete the current contents of the cache.
#' @author Mike Smith
#' @keywords IO
#'
#' @name biomartCache
#' @importFrom BiocFileCache removebfc
#' @export
biomartCacheClear <- function() {
  cache <- .biomartCacheLocation()
  bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
  removebfc(bfc, ask = FALSE)
}

#' @rdname biomartCache
#' @importFrom BiocFileCache bfcinfo
#' @export
biomartCacheInfo <- function() {
  cache <- .biomartCacheLocation()

  if (file.exists(cache)) {
    bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
    files <- bfcinfo(bfc)$rpath
    total_size <- sum(file.size(files))
    size_obj <- structure(total_size, class = "object_size")

    message(
      "biomaRt cache\n",
      "- Location: ",
      cache,
      "\n",
      "- No. of files: ",
      length(files),
      "\n",
      "- Total size: ",
      format(size_obj, units = "auto")
    )
  } else {
    message("biomaRt cache uninitialized\n", "- Location: ", cache)
  }
  return(invisible(cache))
}

#' Determine if a cached version exists and if it's less than one week old.
#'
#' @param bfc BiocFileCache object created by [BiocFileCache()]
#' @param cacheEntry The name of entry in the cache.
#' @param numDays The number of days an entry should be considered valid. Entries
#' older than this will be deleted.
#' @keywords Internal
#' @noRd
#' @importFrom BiocFileCache bfcquery bfcremove
.useCache <- function(bfc, cacheEntry, numDays = 7L) {
  use_cached_version <- FALSE
  if (.checkInCache(bfc, hash = cacheEntry)) {
    cache_entry <- bfcquery(x = bfc, query = cacheEntry)
    is_outdated <- Sys.Date() - as.Date(cache_entry$create_time) >= numDays
    if (nrow(cache_entry) == 1 && !is_outdated) {
      use_cached_version <- TRUE
    } else {
      bfcremove(bfc, cache_entry$rid)
    }
  }
  return(use_cached_version)
}

library(biomaRt)

cache <- withr::local_tempfile(pattern = "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

go <- c("GO:0051330", "GO:0000080", "GO:0000114", "GO:0000082")
chrom <- c(17, 20, "Y")
attributes <- "hgnc_symbol"
filters <- c("go", "chromosome_name")
values <- list(go, chrom)
fake_mart <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  # To avoid hitting ensembl.org with .listEnsemblArchives() in .createHash()
  host = "example.com"
)

test_that("Hashing is order insensitive", {
  expect_identical(
    .createHash(fake_mart, attributes, filters, values),
    .createHash(fake_mart, rev(attributes), rev(filters), rev(values))
  )
})


test_that("Environment variable for cache location is used", {
  expect_message(biomartCacheInfo(), regexp = "biomart_cache_test")
})

## create an example hash and dataframe to test code with
hash <- .createHash(fake_mart, attributes, filters, values)
result <- data.frame(
  name = c("affy_hg_u133a_2", "chromosome_name", "transcript_tsl"),
  description = c(
    "AFFY HG U133A 2 probe ID(s) [e.g. 211600_at]",
    "Chromosome/scaffold name",
    "Transcript Support Level (TSL)"
  ),
  type = c("id_list", "text", "boolean"),
  options = c("[]", "[1,2,3,4,CHR_HG1_PATCH]", "[only,excluded]")
)
bfc <- BiocFileCache::BiocFileCache(biomartCacheInfo(), ask = FALSE)

test_that("Entries can be added to the cache", {
  expect_true(.addToCache(bfc = bfc, result = result, hash = hash))
})

test_that("We find cache for previous query", {
  expect_true(.checkInCache(bfc, hash = hash))
  expect_identical(result, .readFromCache(bfc, hash = hash))
})

## add an invalid file.  We are only expecting .rds files, and this is a
## text file
tf <- tempfile()
writeLines(LETTERS, con = tf)
BiocFileCache::bfcadd(bfc, rname = "invalid-file", fpath = tf)
prev_count <- BiocFileCache::bfccount(bfc)

test_that("invalid cache entry detected", {
  expect_false(.checkValidCache(bfc, hash = "invalid-file"))
  expect_equal(BiocFileCache::bfccount(bfc), prev_count - 1)
})


## check we can't write multiple entries with the same hash
test_that("we can't create multiple entries with the same hash", {
  expect_true(.addToCache(bfc = bfc, result = 1:100, hash = "testing"))
  expect_false(.addToCache(bfc = bfc, result = 1:100, hash = "testing"))
})


test_that("Cache details are printed", {
  expect_message(biomartCacheInfo(), regexp = "biomaRt cache")
})

test_that("Cache can be cleared", {
  cache_file <- biomartCacheInfo()
  expect_true(file.exists(cache_file))
  expect_silent(biomartCacheClear())
  expect_false(file.exists(cache_file))
})

cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)
bfc <- BiocFileCache::BiocFileCache(biomartCacheInfo(), ask = FALSE)

test_that("We can manually set SSL settings", {
  ## empty list
  settings <- list()
  expect_true(setEnsemblSSL(settings = settings))
  expect_identical(settings, .getEnsemblSSL())

  ## one element
  settings <- list("foo" = "A")
  expect_true(setEnsemblSSL(settings = settings))
  expect_identical(settings, .getEnsemblSSL())

  ## add element
  settings <- list("baa" = "B")
  expect_true(setEnsemblSSL(settings = settings))
  expect_identical(list("foo" = "A", "baa" = "B"), .getEnsemblSSL())

  ## update existing element
  settings <- list("baa" = "C")
  expect_true(setEnsemblSSL(settings = settings))
  expect_identical(list("foo" = "A", "baa" = "C"), .getEnsemblSSL())

  ## remove these entries from the cache so they aren't used in later tests
  biomartCacheClear()
})

#' Exports getSequence results to FASTA format
#'
#' @param sequences A data.frame that was the output of the [getSequence()]
#' function
#' @param file File to which you want to write the data
#'
#' @author Steffen Durinck
#' @author Hugo Gruson
#'
#' @keywords methods
#'
#' @examplesIf interactive()
#' mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")
#'
#' seq <- getSequence(
#'   id = "BRCA1",
#'   type = "hgnc_symbol",
#'   seqType = "cdna",
#'   mart = mart
#' )
#' exportFASTA(seq, file = "test.fasta")
#'
#' @export
exportFASTA <- function(sequences, file) {
  if (missing(sequences) || !is.data.frame(sequences)) {
    stop(
      "No data.frame given to write FASTA.  The data.frame should be the output of the getSequence function."
    )
  }
  if (missing(file)) {
    stop("Please provide filename to write to")
  }
  if (ncol(sequences) == 2) {
    writeLines(
      sprintf(">%s\n%s", sequences[, 2], sequences[, 1]),
      file,
      sep = "\n\n"
    )
  } else {
    writeLines(
      sprintf(
        ">chromosome_%s_start_%s_end_%s\n%s",
        sequences[, 1],
        sequences[, 2],
        sequences[, 3],
        sequences[, 4]
      ),
      file,
      sep = "\n\n"
    )
  }
}

test_that("exportFASTA() on gene-sequence data.frame", {
  test_df <- data.frame(
    sequence = c(strrep("ATCG", 10), strrep("GCTA", 10)),
    gene = c("gene1", "gene2")
  )

  expect_snapshot(exportFASTA(test_df, stdout()))
})

test_that("exportFASTA() on 4 columns data", {
  test_df <- data.frame(
    chromosome = c("chr1", "chr1"),
    start = c(1, 55),
    end = c(1, 55) + 40,
    sequence = c(strrep("ATCG", 10), strrep("GCTA", 10))
  )

  expect_snapshot(exportFASTA(test_df, stdout()))
})

#' @exportClass Mart
#' @importFrom methods prototype representation setClass
Mart <- setClass(
  "Mart",
  representation(
    biomart = "character",
    host = "character",
    vschema = "character",
    version = "character",
    dataset = "character",
    filters = "data.frame",
    attributes = "data.frame",
    http_config = "list"
  ),
  prototype(
    dataset = "",
    vschema = "default",
    version = "",
    http_config = list()
  )
)

## location of Ensembl specific functions

.checkArchiveList <- function(http_config = list()) {
  ## determine if a cached version exists and if it's less than one week old
  cache <- .biomartCacheLocation()
  bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
  cache_entry <- "ensembl-archive-html"
  use_cached_version <- .useCache(
    bfc = bfc,
    cacheEntry = cache_entry,
    numDays = 7L
  )

  if (use_cached_version) {
    archive_html <- .readFromCache(bfc, cache_entry)
  } else {
    archive_html <- .getArchiveList(http_config = http_config)
    .addToCache(bfc, archive_html, hash = cache_entry)
  }

  return(archive_html)
}

#' @importFrom httr2 req_error req_options req_perform req_retry req_timeout request resp_body_string resp_status req_user_agent
.getArchiveList <- function(http_config = list()) {
  mirrors <- c("www", "asia", "useast")

  while (length(mirrors) > 0) {
    url <- paste0(
      "https://",
      mirrors[1],
      ".ensembl.org/info/website/archives/index.html?redirect=no"
    )

    html_request <- request(url) |>
      req_user_agent(
        .biomaRt_user_agent()
      ) |>
      req_timeout(10) |>
      req_options(!!!http_config) |>
      req_retry(max_tries = 3) |>
      req_error(is_error = \(resp) FALSE)

    html <- req_perform(html_request)

    ## this is TRUE if there's an HTTP error or we get the Ensembl error page
    if (
      identical(resp_status(html), 200L) &&
        !grepl(
          "The Ensembl web service you requested is temporarily unavailable",
          resp_body_string(html),
          fixed = TRUE
        )
    ) {
      return(resp_body_string(html))
    }
    mirrors <- mirrors[-1]
  }
  stop("Unable to contact any Ensembl mirror")
}

.currentEnsemblVersion <- function() {
  archives <- listEnsemblArchives()
  current <- archives[archives$current_release == "*", ]
  return(current)
}

## scrapes the ensembl website for the list of current archives and returns
## a data frame containing the versions and their URL

#' Lists the available archived versions of Ensembl
#'
#' Returns a table containing the available archived versions of Ensembl, along
#' with the dates they were created and the URL used to access them.
#'
#' @author Mike Smith
#' @keywords methods
#'
#' @examples
#' listEnsemblArchives()
#'
#' @export
listEnsemblArchives <- function() {
  .listEnsemblArchives(http_config = list())
}

#' @importFrom stringr str_extract_all str_match
.listEnsemblArchives <- function(http_config) {
  html <- .checkArchiveList(http_config)
  html <- xml2::read_html(html)

  archive_box <- as.character(
    xml2::xml_find_first(
      x = html,
      xpath = "//div[contains(@class,'archive-box')]"
    )
  )

  archives <- strsplit(archive_box, split = "<li>", fixed = TRUE)[[1]][-1]

  extracted <- str_extract_all(
    string = archives,
    pattern = "Ensembl [A-Za-z0-9 ]{2,6}|https?://.*ensembl\\.org|[A-Z][a-z]{2} [0-9]{4}"
  )

  ## split the version number into a separate column
  extracted <- lapply(extracted, FUN = function(x) {
    version <- str_match(x[2], pattern = ".+ ([a-zA-Z0-9]+)$")[2]
    return(c(x, version))
  })

  current <- ifelse(
    stringr::str_detect(archives, stringr::fixed("- this site")),
    "*",
    ""
  )

  tab <- do.call("rbind", extracted)
  tab <- cbind(tab, current)

  dframe <- data.frame(
    "name" = as.character(tab[, 2]),
    "date" = as.character(tab[, 3]),
    "url" = stringr::str_replace(
      tolower(as.character(tab[, 1])),
      stringr::fixed("http://"),
      "https://"
    ),
    "version" = as.character(tab[, 4]),
    "current_release" = as.character(tab[, 5]),
    stringsAsFactors = FALSE
  )
  return(dframe)
}

.listEnsembl <- function(
  mart = NULL,
  version = NULL,
  GRCh = NULL,
  mirror = NULL,
  verbose = FALSE
) {
  if (is.null(version)) {
    version_num <- getCurrentEnsemblRelease()
  } else {
    version_num <- version
  }

  ## determine if a cached version exists and if it's less than one week old
  cache <- .biomartCacheLocation()
  bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
  use_cached_version <- .useCache(
    bfc = bfc,
    cacheEntry = paste0("ensembl-marts-", version_num),
    numDays = 7L
  )

  if (use_cached_version) {
    marts <- .readFromCache(bfc, paste0("ensembl-marts-", version_num))
  } else {
    host <- .constructEnsemblURL(
      mirror = mirror,
      version = version,
      GRCh = GRCh
    )
    port <- ifelse(startsWith(host, "http://")[1], yes = 80, no = 443)
    ensemblRedirect <- is.null(mirror)

    http_config <- .getEnsemblSSL()

    marts <- .listMarts(
      mart = mart,
      host = host,
      verbose = verbose,
      http_config = http_config,
      port = port,
      ensemblRedirect = ensemblRedirect
    )

    .addToCache(bfc, marts, hash = paste0("ensembl-marts-", version_num))
  }

  return(marts)
}


#' lists the available BioMart databases hosted by Ensembl
#'
#' This function returns a list of BioMart databases hosted by Ensembl.  To
#' establish a connection use the [useEnsembl()] function.
#'
#' @param mart mart object created with the useEnsembl function.  This is
#' optional, as you usually use [listMarts()] to see which marts
#' there are to connect to.
#' @param version Ensembl version to connect to when wanting to connect to an
#' archived Ensembl version
#' @param GRCh GRCh version to connect to if not the current GRCh38, currently
#' this can only be 37
#' @param mirror Specify an Ensembl mirror to connect to.  The valid options
#' here are 'www', 'useast', 'asia'.  If no mirror is specified the primary
#' site at www.ensembl.org will be used.
#' @param verbose Give detailed output of what the method is doing, for
#' debugging purposes
#' @param includeHosts If this option is set to `TRUE` a more detailed
#' output is produced, including the URL used to access the corresponding mart.
#' @param host Host to connect to. Use this argument to specify and archive
#' site for [listEnsemblGenomes()] to work with.
#' @author Steffen Durinck, Mike L. Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' listEnsembl()
#'
#' ## list the default Ensembl Genomes marts
#' listEnsemblGenomes()
#'
#' ## list only the marts available in the Ensmbl Plants 56 archive
#' listEnsemblGenomes(host = "https://eg56-plants.ensembl.org/")
#'
#' @export
listEnsembl <- function(
  mart = NULL,
  version = NULL,
  GRCh = NULL,
  mirror = NULL,
  verbose = FALSE
) {
  marts <- .listEnsembl(
    mart = mart,
    version = version,
    GRCh = GRCh,
    mirror = mirror,
    verbose = verbose
  )

  sel <- which(marts$biomart == "ENSEMBL_MART_ENSEMBL")
  if (length(sel) > 0) {
    marts$biomart[sel] <- "genes"
  }
  sel <- which(marts$biomart == "ENSEMBL_MART_SNP")
  if (length(sel) > 0) {
    marts$biomart[sel] <- "snps"
  }
  sel <- which(marts$biomart == "ENSEMBL_MART_FUNCGEN")
  if (length(sel) > 0) {
    marts$biomart[sel] <- "regulation"
  }
  sel <- which(marts$biomart == "ENSEMBL_MART_VEGA")
  if (length(sel) > 0) {
    marts$biomart[sel] <- "vega"
  }
  sel <- which(marts$biomart == "ENSEMBL_MART_MOUSE")
  if (length(sel) > 0) {
    marts$biomart[sel] <- "mouse_strains"
  }
  return(marts)
}

## creates an Ensembl URL based on the arguments provided to useEnsembl.
## If there are conflicting options, order of precedence is:
## GRCh, version, mirror
## Default return value is https://www.ensembl.org
.constructEnsemblURL <- function(mirror = NULL, version = NULL, GRCh = NULL) {
  host <- NULL

  if (!is.null(mirror) && (!is.null(version) || !is.null(GRCh))) {
    warning(
      "version or GRCh arguments cannot be used together with the mirror argument.\n",
      "We will ignore the mirror argument and connect to the main Ensembl site.",
      call. = FALSE
    )
    mirror <- NULL
  }

  if (!is.null(version) && !is.null(GRCh)) {
    stop(
      "version or GRCh arguments cannot be used together.\n",
      "Please specify only the 'version' or 'GRCh' argument.",
      call. = FALSE
    )
  }

  if (!is.null(version)) {
    archives <- .listEnsemblArchives(http_config = list())
    idx <- match(version, archives[, "version"], nomatch = NA)
    if (is.na(idx)) {
      stop(
        "Specified Ensembl version is not available.\n",
        "Use listEnsemblArchives() to view available versions.",
        call. = FALSE
      )
    }
    host <- archives[idx, "url"]
  }

  if (!is.null(GRCh)) {
    if (GRCh == 37) {
      host <- paste0("https://grch", GRCh, ".ensembl.org")
    } else {
      warning(
        "Only 37 can be specified for GRCh version. Using the current version.",
        call. = FALSE
      )
    }
  }

  if (!is.null(mirror)) {
    if (mirror %in% c("www", "useast", "asia")) {
      host <- paste0("https://", mirror, ".ensembl.org")
    } else {
      warning(
        "Invalid mirror. Select a mirror from [www, useast, asia].\n",
        "Default when no mirror is specified is to use ",
        "www.ensembl.org which may be automatically redirected."
      )
      host <- "https://www.ensembl.org"
    }
  }

  if (is.null(host)) {
    host <- "https://www.ensembl.org"
  }

  return(host)
}


#' Connects to the selected BioMart database and dataset hosted by Ensembl
#'
#' A first step in using the biomaRt package is to select a BioMart database
#' and dataset to use.  The [useEnsembl()] function enables one to connect
#' to a specified BioMart database and dataset hosted by Ensembl without having
#' to specify the Ensembl URL.  To know which BioMart databases are available
#' see the [listEnsembl()] and [listEnsemblGenomes()]
#' functions.  To know which datasets are available within a BioMart database,
#' first select the BioMart database using [useEnsembl()] and then use the
#' [listDatasets()] function on the selected Mart object.
#'
#' The `mirror` argument can be considered as a "preferred choice" when
#' connecting to Ensembl.  If the argument is provided then connectivity to
#' that mirror will be tested.  If it responds positively then the requested
#' mirror will be used.  If the response is a failure each of the remaining
#' mirrors will be selected at random and tested until a working server is
#' found.  Once identified that Ensembl server will be associated with the
#' returned `Mart` object and will be used for all queries.
#'
#' @param biomart BioMart database name you want to connect to. Possible
#' database names can be retrieved with the function [listEnsembl()]
#' @param dataset Dataset you want to use.  To see the different datasets
#' available within a biomaRt you can e.g. do: mart = useEnsembl('genes'),
#' followed by listDatasets(mart).
#' @param host Host to connect to.  Only needs to be specified if different
#' from www.ensembl.org.  For [useEnsemblGenomes()] this argument can be
#' used to specify an archive site.
#' @param version Ensembl version to connect to when wanting to connect to an
#' archived Ensembl version
#' @param GRCh GRCh version to connect to if not the current GRCh38, currently
#' this can only be 37
#' @param mirror Specify an Ensembl mirror to connect to.  The valid options
#' here are 'www', 'useast', 'asia'.  If no mirror is specified the primary
#' site at www.ensembl.org will be used.  Mirrors are not available for the
#' Ensembl Genomes databases.
#' @param verbose Give detailed output of what the method is doing while in
#' use, for debugging
#' @author Steffen Durinck & Mike Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' mart <- useEnsembl("ENSEMBL_MART_ENSEMBL")
#'
#' ## using the US East mirror
#' us_mart <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL", mirror = "useast")
#'
#' ## using the Arabidopsis thaliana genes dataset in Ensembl Plants
#' plants_mart <- useEnsemblGenomes(
#'   biomart = "plants_mart",
#'   dataset = "athaliana_eg_gene"
#' )
#'
#' ## using the Cucumis melo genes dataset in the Ensembl Plants 56 archive
#' plants_mart <- useEnsemblGenomes(
#'   biomart = "plants_mart",
#'   dataset = "cmelo_eg_gene",
#'   host = "https://feb2023-plants.ensembl.org/"
#' )
#'
#' @export
useEnsembl <- function(
  biomart,
  dataset,
  host,
  version = NULL,
  GRCh = NULL,
  mirror = NULL,
  verbose = FALSE
) {
  if (missing(biomart)) {
    stop(
      "You must provide the argument 'biomart'\n",
      "Available Ensembl Marts can be viewed with ",
      "the function listEnsembl()"
    )
  }

  biomart <- switch(
    tolower(biomart),
    "ensembl" = "ENSEMBL_MART_ENSEMBL",
    "genes" = "ENSEMBL_MART_ENSEMBL",
    "snp" = "ENSEMBL_MART_SNP",
    "snps" = "ENSEMBL_MART_SNP",
    "regulation" = "ENSEMBL_MART_FUNCGEN",
    "mouse_strains" = "ENSEMBL_MART_MOUSE",
    "vega" = "ENSEMBL_MART_VEGA",
    biomart
  )

  ## test https connection and store required settings
  http_config <- .getEnsemblSSL()

  ## a crude check to ensure the sub-domain is included.  Otherwise queries will fail
  if (!missing(host)) {
    no_subdomain <- grepl(
      x = host,
      pattern = "https?://ensembl",
      fixed = FALSE
    )
  } else {
    no_subdomain <- FALSE
  }

  ## create the host URL & turn off redirection if a mirror is specified
  if (missing(host) || no_subdomain) {
    if (no_subdomain) {
      warning(
        "You cannot use the host 'ensembl.org'.\n",
        "Please provide a subdomain e.g. www.ensembl.org or use one of the 'mirror', 'version', 'GRCh' arguments"
      )
    }

    if (is.null(version) && is.null(GRCh)) {
      mirror <- .chooseEnsemblMirror(mirror = mirror, http_config = http_config)
    }
    host <- .constructEnsemblURL(
      version = version,
      GRCh = GRCh,
      mirror = mirror
    )
    ensemblRedirect <- is.null(mirror)
  } else {
    ensemblRedirect <- FALSE
  }

  ## choose the port based on whether we use https or not
  port <- ifelse(startsWith(host, "http://"), yes = 80, no = 443)

  if (grepl(x = host, pattern = "www|useast|asia")) {
    marts <- .listEnsembl(version = version, GRCh = GRCh, mirror = mirror)
  } else {
    marts <- .listMarts(
      host = host,
      port = port,
      http_config = http_config,
      ensemblRedirect = FALSE
    )
  }

  mindex <- NA
  if (!missing(biomart)) {
    mindex <- match(biomart, marts$biomart)
  }
  if (is.na(mindex)) {
    stop(
      "Incorrect BioMart name, use the listMarts function to see which BioMart databases are available"
    )
  }

  ## adding option to force use of specified host with ensembl
  redirect <- ifelse(
    !ensemblRedirect && grepl(x = host, pattern = "ensembl.org"),
    "?redirect=no",
    ""
  )

  mart <- Mart(
    biomart = biomart,
    vschema = "default",
    host = paste0(host, ":", port, "/biomart/martservice", redirect),
    http_config = http_config
  )

  if (grepl("archive", martHost(mart), fixed = TRUE)) {
    ## hack to work around redirection of most recent mirror URL
    archives <- .listEnsemblArchives(http_config = http_config)
    current_release <- archives[archives$current_release == "*", "url"]
    if (grepl(martHost(mart), pattern = current_release)) {
      martHost(mart) <- stringr::str_replace(
        martHost(mart),
        pattern = current_release,
        "https://www.ensembl.org"
      )
      martHost(mart) <- stringr::str_replace(
        martHost(mart),
        pattern = stringr::fixed(":80/"),
        ":443/"
      )
    }
  }

  if (!missing(dataset)) {
    mart <- useDataset(mart = mart, dataset = dataset, verbose = verbose)
  }
  return(mart)
}


##############################################
#' @rdname listEnsembl
#' @export
listEnsemblGenomes <- function(includeHosts = FALSE, host = NULL) {
  ## use the default websites unless an alternative is provided
  if (is.null(host)) {
    host <- c(
      "https://protists.ensembl.org/",
      "https://fungi.ensembl.org/",
      "https://metazoa.ensembl.org/",
      "https://plants.ensembl.org/"
    )
  }

  http_config <- .getEnsemblSSL()

  marts <- lapply(host, FUN = function(x) {
    as.data.frame(
      .listMarts(
        host = x,
        mart = NULL,
        http_config = http_config,
        verbose = FALSE,
        ensemblRedirect = FALSE,
        port = 443,
        includeHosts = includeHosts
      )
    )
  })

  marts <- do.call("rbind", marts)

  return(marts)
}

#' @rdname useEnsembl
#' @export
useEnsemblGenomes <- function(biomart, dataset, host = NULL) {
  if (missing(biomart)) {
    stop(
      "You must provide the argument 'biomart'\n",
      "Available Ensembl Genomes Marts can be viewed with ",
      "the function listEnsemblGenomes()"
    )
  }

  marts <- listEnsemblGenomes(includeHosts = TRUE, host = host)
  if (!biomart %in% marts$biomart) {
    stop(
      biomart,
      " is not in the list of available Marts'\n",
      "Available Ensembl Genomes Marts can be viewed with ",
      "the function listEnsemblGenomes()"
    )
  }
  martDetails <- marts[which(marts$biomart == biomart), ]

  host <- paste0("https://", martDetails$host)

  http_config <- .getEnsemblSSL()

  ens <- .useMart(
    biomart = biomart,
    dataset = dataset,
    host = host,
    verbose = FALSE,
    port = 443,
    ensemblRedirect = FALSE,
    http_config = http_config
  )

  return(ens)
}


## This function submits a small test query to identify a working Ensembl mirror.
## If no mirror argument is provided it will use "www" as its first choice.
## If the selected mirror returns a success (http 200) response it will be used
## Otherwise another mirror is selected at random and used instead.
## If all mirrors fail it will return an error
#' @importFrom httr2 req_body_form req_options req_timeout req_user_agent
#' @importFrom stringr str_match str_replace
.chooseEnsemblMirror <- function(mirror, http_config) {
  mirrors <- c("www", "asia", "useast")

  if (missing(http_config)) {
    http_config <- do.call(c, .getEnsemblSSL())
  }

  example_query <- '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE Query>
<Query  virtualSchemaName = "default" formatter = "TSV" header = "0" uniqueRows = "0" count = "" datasetConfigVersion = "0.6" >
	<Dataset name = "hsapiens_gene_ensembl" interface = "default" >
		<Filter name = "ensembl_gene_id" value = "ENSG00000000003"/>
		<Attribute name = "ensembl_gene_id" />
	</Dataset>
</Query>'

  ## create Ensembl URL and stop any redirection to a mirror
  host <- .constructEnsemblURL(mirror = mirror)
  host <- paste0(host, "/biomart/martservice?redirect=no")
  mirror <- str_match(host, pattern = "://([a-z]{3,6})\\.")[1, 2]

  req <- httr2::request(host) |>
    req_user_agent(
      .biomaRt_user_agent()
    ) |>
    req_body_form(query = example_query) |>
    req_timeout(10) |>
    req_options(!!!http_config)

  result <- tryCatch(httr2::req_perform(req), error = function(c) {
    "timeout"
  })

  tryAgain <- any(result == "timeout") || httr2::resp_status(result) == 500

  if (tryAgain) {
    ## try an alternative mirror if ensembl returns 500
    remaining_mirrors <- setdiff(mirrors, mirror)
    while ((length(remaining_mirrors) > 0) && (tryAgain)) {
      mirror <- sample(remaining_mirrors, size = 1)
      message("Ensembl site unresponsive, trying ", mirror, " mirror")
      host <- str_replace(
        host,
        pattern = "://([a-z]{3,6})\\.",
        replacement = paste0("://", mirror, ".")
      )

      req <- httr2::request(host) |>
        req_user_agent(
          .biomaRt_user_agent()
        ) |>
        req_body_form(query = example_query) |>
        req_timeout(10) |>
        req_options(!!!http_config)

      result <- tryCatch(httr2::req_perform(req), error = function(c) {
        "timeout"
      })
      tryAgain <- any(result == "timeout") || httr2::resp_status(result) == 500
      if (tryAgain) {
        remaining_mirrors <- setdiff(remaining_mirrors, mirror)
      }
    }
  }
  if (tryAgain) {
    stop("Unable to query any Ensembl site")
  }

  return(mirror)
}

with_mock_dir(
  "all_err_page",
  {
    test_that("Archive list fails if all mirrors are giving error page", {
      expect_error(
        .getArchiveList(),
        regexp = "Unable to contact any Ensembl mirror"
      )
    })
  },
  simplify = TRUE
)

with_mock_dir(
  "all_500",
  {
    test_that("Archive list fails if all mirrors don't give 200 responses", {
      expect_error(
        .getArchiveList(),
        regexp = "Unable to contact any Ensembl mirror"
      )
    })
  },
  simplify = TRUE
)

library(biomaRt)
cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

with_mock_dir(
  "all_200",
  {
    test_that("useMart returns a Mart object", {
      ## Skip on linux.  SSL problems are addressed in useEnsembl()
      # testthat::skip_on_os("linux")
      ensembl <- useMart(
        biomart = "ENSEMBL_MART_ENSEMBL",
        dataset = "hsapiens_gene_ensembl"
      )
      expect_s4_class(ensembl, "Mart")
    })
  },
  simplify = TRUE
)

test_that("show() reports missing dataset", {
  expect_output(
    object = show(Mart(biomart = "ensembl")),
    regexp = "No dataset selected"
  )
})

###############

test_that("show() reports dataset name if present", {
  expect_output(
    object = show(Mart(
      biomart = "ensembl",
      dataset = "xtropicalis_gene_ensembl"
    )),
    regexp = "Using the xtropicalis_gene_ensembl dataset"
  )
})

#############

test_that("Deprecation warning produced", {
  expect_error(useMart(
    biomart = "ensembl",
    host = "www.ensembl.org",
    ensemblRedirect = FALSE
  ))
})

test_that("Error handling works", {
  skip_if_not_installed("mockery")

  expect_error(
    useEnsemblGenomes(),
    regexp = "You must provide the argument 'biomart'"
  )

  mockery::stub(
    useEnsemblGenomes,
    "listEnsemblGenomes",
    function(includeHosts, host) {
      data.frame(
        biomart = c("protists_mart", "fungi_mart"),
        version = c("Ensembl Protists Genes 48", "Ensembl Fungi Genes 48")
      )
    }
  )
  expect_error(
    useEnsemblGenomes(biomart = "plants_mart"),
    regexp = "is not in the list of available Marts"
  )
})

test_that("return type is correct", {
  skip_if_offline("protists.ensembl.org")
  skip_if_offline("fungi.ensembl.org")
  skip_if_offline("metazoa.ensembl.org")
  skip_if_offline("plants.ensembl.org")

  expect_s4_class(useEnsemblGenomes("protists_mart", "bnatans_eg_gene"), "Mart")
})

cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

ensembl <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  # To avoid hitting ensembl.org with .listEnsemblArchives() in .createHash()
  host = "www.example.com",
  attributes = data.frame(
    name = c("chromosome_name", "ensembl_gene_id"),
    description = c("Chromosome/scaffold name", "Gene stable ID")
  ),
  filters = data.frame(
    name = c("affy_hg_u133a_2", "chromosome_name", "transcript_tsl"),
    description = c(
      "AFFY HG U133A 2 probe ID(s) [e.g. 211600_at]",
      "Chromosome/scaffold name",
      "Transcript Support Level (TSL)"
    ),
    type = c("id_list", "text", "boolean"),
    options = c("[]", "[1,2,3,4,CHR_HG1_PATCH]", "[only,excluded]")
  )
)

test_that("getBM() gives appropriate error messages", {
  expect_error(getBM(), "You must provide a valid Mart object")

  mart_with_no_dataset <- Mart(biomart = "ensembl")
  expect_error(
    getBM(mart = mart_with_no_dataset),
    "No dataset selected, please select a dataset first"
  )

  expect_error(getBM(mart = ensembl), "Argument 'attributes' must be specified")

  expect_error(
    getBM(
      mart = ensembl,
      attributes = "ensembl_gene_id",
      filters = list("chromosome_name")
    ),
    "Argument 'filters' must be a named list when sent as a list"
  )
})


test_that("getBM returns sensible things", {
  skip_if_not_installed("mockery")

  mockery::stub(
    getBM,
    ".submitQueryXML",
    "Gene stable ID\tChromosome/scaffold name\nENSG01\t13\nENSG02\t15\nENSG03\t17\n"
  )
  expect_s3_class(
    getBM(mart = ensembl, attributes = c("ensembl_gene_id", "chromosome_name")),
    "data.frame"
  )

  expect_warning(
    getBM(
      mart = ensembl,
      attributes = c("ensembl_gene_id", "chromosome_name"),
      filters = list(chromosome_name = c(1)),
      values = "1"
    ),
    "Argument 'values' should not be used when argument 'filters' is a list and will be ignored"
  )
})

test_that("getBM doesn't convert T/F alleles into TRUE/FALSE", {
  skip_if_not_installed("mockery")
  skip_if_offline("www.ensembl.org")

  # Example from https://github.com/Huber-group-EMBL/biomaRt/issues/12
  mockery::stub(
    getBM,
    ".submitQueryXML",
    "Variant name\tMinor allele (ALL)\nrs1528723\tT\n"
  )
  snp_ensembl <- useEnsembl(
    biomart = "snp",
    dataset = "hsapiens_snp",
    GRCh = 37
  )
  expect_snapshot(
    getBM(
      attributes = c("refsnp_id", "minor_allele"),
      filters = c("chr_name", "start", "end"),
      values = list(8, 35127386, 35127386),
      mart = snp_ensembl
    )
  )
})

#' Display the analysis code from the 2009 Nature protocols paper
#'
#' This function opens an editor displaying the analysis code of the Nature
#' Protocols 2009 paper
#'
#' The [edit()] function uses `getOption("editor")` to select
#' the editor. Use, for instance, `options(editor="emacs")` to set another
#' editor.
#'
#' @author Steffen Durinck, Wolfgang Huber
#' @seealso [edit()]
#' @keywords methods
#'
#' @examplesIf interactive()
#' NP2009code()
#'
#' @export
#' @importFrom utils edit
NP2009code <- function() {
  edit(file = system.file("scripts", "Integration-NP.R", package = "biomaRt"))
}

##########################
# biomaRt source code     #
##########################
#                        #
# Licence: Artistic       #
# Author: Steffen Durinck #
##########################

##############################################################
# martCheck                                                   #
#                                                            #
# This function checks if there is a valid Mart object,       #
# if a dataset is selected and                                #
# if the correct BioMart database has been selected (optional)#
##############################################################

martCheck <- function(mart, biomart = NULL) {
  if (missing(mart) || !inherits(mart, "Mart")) {
    stop(
      "You must provide a valid Mart object. To create a Mart object use the function: useMart.  Check ?useMart for more information."
    )
  }
  if (!is.null(biomart)) {
    martcheck <- martBM(mart)
    bmok <- FALSE
    for (k in seq_along(biomart)) {
      if (martcheck[1] == biomart[k]) {
        bmok <- TRUE
      }
    }
    if (!bmok) {
      stop(
        "This function only works when used with the ",
        biomart,
        " BioMart."
      )
    }
  }
  if (martDataset(mart) == "") {
    stop(
      "No dataset selected, please select a dataset first.  You can see the available datasets by using the listDatasets function see ?listDatasets for more information.  Then you should create the Mart object by using the useMart function.  See ?useMart for more information"
    )
  }
}


#' @importFrom httr2 req_options req_perform req_timeout resp_body_string req_user_agent
bmRequest <- function(request, http_config, verbose = FALSE) {
  if (verbose) {
    message("Attempting web service request:\n", request)
  }

  request <- httr2::request(request) |>
    req_user_agent(
      .biomaRt_user_agent()
    ) |>
    req_timeout(getOption("timeout", default = 60)) |>
    req_options(!!!http_config)

  result <- req_perform(request)

  result2 <- resp_body_string(result)
  if (is.na(result2)) {
    result2 <- resp_body_string(result, encoding = "Latin1")
  }
  return(result2)
}

#######################################################
# listMarts:                                           #
# list all available BioMart databases by default      #
# listMarts will check the central service to see which#
# BioMart databases are present                        #
#######################################################

#' lists the available BioMart databases
#'
#' This function returns a list of BioMart databases to which biomaRt can
#' connect.  By default the Ensembl BioMart databases are displayed. To
#' establish a connection use the [useMart()] function.
#'
#' If you receive an error message saying 'Unexpected format to the list of
#' available marts', this is often because there is a problem with the BioMart
#' server you are trying to connect to, and something other than the list of
#' available marts is being returned - often some like a 'down for
#' maintenance' page.  If you browse to the provided URL and find a page that
#' starts with '`<MartRegistry>`' this is the correct listing and you
#' should report the issue on the Bioconductor support site:
#' https://support.bioconductor.org
#'
#' @param mart mart object created with the [useMart()] function.
#' This is optional, as you usually use [listMarts()] to see which
#' marts there are to connect to.
#' @param host Host to connect to. Defaults to `www.ensembl.org`
#' @param path path to martservice that should be pasted behind the host to get
#' to web service URL
#' @param port port to use in HTTP communication
#' @param includeHosts boolean to indicate if function should return host of
#' the BioMart databases
#' @param http_config Some hosts require specific HTTP settings to be used when
#' connecting. This argument takes the output of [httr::config()] and
#' will be used when connecting to `host`.  Can be ignored if you
#' experience no problems accessing `host`.
#' @param verbose Give detailed output of what the method is doing, for
#' debugging purposes.
#' @author Steffen Durinck, Mike Smith
#' @keywords methods
#'
#' @details
#' The previously available `archive` argument is defunct.
#' A better alternative is to specify the url of the archived BioMart
#' you want to access. For Ensembl you can view the list of archives using
#' [listEnsemblArchives()].
#'
#' @examplesIf interactive()
#' listMarts()
#'
#' @export
listMarts <- function(
  mart = NULL,
  host = "https://www.ensembl.org",
  path = "/biomart/martservice",
  port,
  includeHosts = FALSE,
  http_config = list(),
  verbose = FALSE
) {
  if (missing(port)) {
    port <- ifelse(startsWith(host, "http://"), yes = 80, no = 443)
  }

  if (grepl("^https://.*ensembl.org", host) && missing(http_config)) {
    http_config <- .getEnsemblSSL()
  }

  .listMarts(
    mart = mart,
    host = host,
    path = path,
    port = port,
    includeHosts = includeHosts,
    verbose = verbose,
    http_config = http_config,
    ensemblRedirect = TRUE
  )
}

#' @importFrom methods is
.listMarts <- function(
  mart = NULL,
  host = "www.ensembl.org",
  path = "/biomart/martservice",
  port = 443,
  includeHosts = FALSE,
  verbose = FALSE,
  http_config,
  ensemblRedirect = NULL
) {
  request <- NULL
  if (is.null(mart)) {
    host <- .cleanHostURL(host)
    request <- paste0(
      host,
      ":",
      port,
      path,
      "?type=registry&requestid=biomaRt"
    )

    if (is.list(http_config)) {
      http_config <- do.call(c, http_config)
    }
  } else if (is(mart, "Mart")) {
    request <- paste0(martHost(mart), "?type=registry&requestid=biomaRt")
    http_config <- martHTTPConfig(mart)
  } else {
    stop(
      mart,
      " object needs to be of class Mart created with the useMart function.\n",
      "If you don't have a Mart object yet, use listMarts() without arguments or only specify the host argument"
    )
  }

  if (!ensemblRedirect && grepl(x = request, pattern = "ensembl.org")) {
    request <- paste0(request, "&redirect=no")
  }

  registry <- bmRequest(
    request = request,
    http_config = http_config,
    verbose = verbose
  )

  ## check this looks like the MartRegistry XML, otherwise throw an error
  if (!grepl(x = registry, pattern = "^\n*<MartRegistry>")) {
    if (grepl(x = registry, pattern = "status.ensembl.org", fixed = TRUE)) {
      stop(
        "Your query has been redirected to https://status.ensembl.org ",
        "indicating this Ensembl service is currently unavailable.",
        "\nLook at ?useEnsembl for details on how to try a mirror site.",
        call. = FALSE
      )
    } else {
      stop(
        "Unexpected format to the list of available marts.\n",
        "Please check the following URL manually, ",
        "and try ?listMarts for advice.\n",
        request,
        call. = FALSE
      )
    }
  }

  registry_xml2 <- xml2::read_xml(registry)
  registry_xml2 <- xml2::xml_children(registry_xml2)

  ## create a table with the registry information
  marts <- do.call("rbind", xml2::xml_attrs(registry_xml2))
  marts <- as.data.frame(marts[marts[, "visible"] == "1", , drop = FALSE])
  ## rename some columns
  names(marts)[names(marts) == "name"] <- "biomart"
  names(marts)[names(marts) == "displayName"] <- "version"
  names(marts)[names(marts) == "serverVirtualSchema"] <- "vschema"

  if (includeHosts) {
    return(as.list(marts))
  } else {
    return(marts[, c("biomart", "version")])
  }
}

#################################
# #                           # #
# # Generic BioMart functions # #
# #                           # #
#################################

#' Connects to the selected BioMart database and dataset
#'
#' A first step in using the biomaRt package is to select a BioMart database
#' and dataset to use.  The useMart function enables one to connect to a
#' specified BioMart database and dataset within this database.  To know which
#' BioMart databases are available see the [listMarts()] function.  To know which
#' datasets are available within a BioMart database, first select the BioMart
#' database using [useMart()] and then use the [listDatasets()] function on the
#' selected BioMart, see [listDatasets()] function.
#'
#'
#' @param biomart BioMart database name you want to connect to. Possible
#' database names can be retrieved with the function [listMarts()]
#' @param dataset Dataset you want to use.  To see the different datasets
#' available within a biomaRt you can e.g. do: mart = [useMart()]('ensembl'),
#' followed by [listDatasets()](mart).
#' @param host Host to connect to. Defaults to `www.ensembl.org`
#' @param path Path that should be pasted after to host to get access to the
#' web service URL
#' @param port port to connect to, will be pasted between host and path
#' @param version Use version name instead of biomart name to specify which
#' BioMart you want to use
#' @param verbose Give detailed output of what the method is doing while in
#' use, for debugging
#' @author Steffen Durinck, Mike L. Smith
#' @keywords methods
#'
#' @details
#' The previously available `archive` argument is defunct.
#' A better alternative is to specify the url of the archived BioMart
#' you want to access. For Ensembl you can view the list of archives using
#' [listEnsemblArchives()].
#'
#' @examplesIf interactive()
#' mart <- useMart("ENSEMBL_MART_ENSEMBL")
#' mart <- useMart(
#'   biomart = "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl"
#' )
#'
#' @export
useMart <- function(
  biomart,
  dataset,
  host = "https://www.ensembl.org",
  path = "/biomart/martservice",
  port,
  version,
  verbose = FALSE
) {
  if (missing(port)) {
    port <- ifelse(startsWith(host, "http://")[1], yes = 80, no = 443)
  }

  .useMart(
    biomart,
    dataset,
    host = host,
    path = path,
    port = port,
    version = version,
    verbose = verbose,
    http_config = list(),
    ensemblRedirect = TRUE
  )
}

.useMart <- function(
  biomart,
  dataset,
  host = "https://www.ensembl.org",
  path = "/biomart/martservice",
  port = 443,
  ensemblRedirect = NULL,
  version,
  http_config,
  verbose = FALSE
) {
  if (missing(biomart) && missing(version)) {
    stop(
      "No biomart databases specified. Specify a biomart database to use using the biomart or version argument"
    )
  }
  if (!missing(biomart) && !is.character(biomart)) {
    stop(
      "biomart argument is not a string. ",
      "The biomart argument should be a single character string"
    )
  }

  if (biomart == "ensembl" && grepl(x = host, pattern = "ensembl.org")) {
    biomart <- "ENSEMBL_MART_ENSEMBL"
  }

  reqHost <- host
  host <- .cleanHostURL(host)

  marts <- .listMarts(
    host = host,
    path = path,
    port = port,
    includeHosts = TRUE,
    http_config = http_config,
    ensemblRedirect = ensemblRedirect
  )
  mindex <- NA
  if (!missing(biomart)) {
    mindex <- match(biomart, marts$biomart)
  }
  if (!missing(version)) {
    mindex <- match(version, marts$version)
  }
  if (is.na(mindex)) {
    mindex <- match(biomart, marts$database)
  }
  if (is.na(mindex)) {
    stop(
      "Incorrect BioMart name, use the listMarts function to see which BioMart databases are available"
    )
  }

  if (
    is.na(marts$path[mindex]) ||
      is.na(marts$vschema[mindex]) ||
      is.na(marts$host[mindex]) ||
      is.na(marts$port[mindex])
  ) {
    stop(
      "The selected biomart databases is not available due to error in the BioMart central registry, please report so the BioMart registry file can be fixed."
    )
  }

  if (marts$path[mindex] == "") {
    marts$path[mindex] <- "/biomart/martservice"
  } # temporary to catch bugs in registry

  if (!missing(version)) {
    biomart <- marts$biomart[mindex]
  }
  biomart <- sub(" ", "%20", biomart, fixed = TRUE, useBytes = TRUE)

  ## adding option to force use of specified host with ensembl
  redirect <- ifelse(
    !ensemblRedirect && grepl(x = host, pattern = "ensembl.org"),
    "?redirect=no",
    ""
  )

  if (missing(http_config)) {
    http_config <- list()
  }

  mart <- Mart(
    biomart = biomart,
    vschema = marts$vschema[mindex],
    host = paste0(host, ":", port, marts$path[mindex], redirect),
    http_config = http_config
  )

  if (any(grepl("archive", martHost(mart), fixed = TRUE))) {
    ## hack to work around redirection of most recent mirror URL
    archives <- .listEnsemblArchives(
      http_config = http_config
    )
    current_release <- archives[archives$current_release == "*", "url"]
    if (grepl(martHost(mart), pattern = current_release)) {
      martHost(mart) <- stringr::str_replace(
        martHost(mart),
        pattern = current_release,
        "https://www.ensembl.org"
      )
      martHost(mart) <- stringr::str_replace(
        martHost(mart),
        pattern = stringr::fixed(":80/"),
        ":443/"
      )
    }
  }

  BioMartVersion <- bmVersion(mart, verbose = verbose)

  if (verbose) {
    writeLines(paste(
      "BioMartServer running BioMart version:",
      BioMartVersion
    ))
    writeLines(paste("Mart virtual schema:", martVSchema(mart)))
    if (!any(grepl(reqHost, martHost(mart), fixed = TRUE))) {
      writeLines(paste(
        "Requested host was redirected from",
        reqHost,
        "to",
        martHost(mart)
      ))
    }
    writeLines(paste("Mart host:", martHost(mart)))
  }
  if (!missing(dataset)) {
    mart <- useDataset(mart = mart, dataset = dataset, verbose = verbose)
  }
  return(mart)
}


#' List or search the datasets available in the selected BioMart database
#'
#' Lists or search the datasets available in the selected BioMart database
#'
#' @param mart object of class Mart created with the useMart function
#' @param verbose Give detailed output of what the method is doing, for
#' debugging purposes
#' @param pattern Character vector defining the regular expression
#' ([regex][base::regex]) to be used for the search.  If left blank the
#' default is to use ".*" which will match everything and return the same as
#' [listDatasets()].
#' @author Steffen Durinck, Mike Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' ## list the available Ensembl marts and use Ensembl Genes
#' listEnsembl()
#' ensembl <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL")
#'
#' ## list the available datasets in this Mart
#' listDatasets(mart = ensembl)
#'
#' ## the list of Ensembl datasets grows ever larger (101 as of Ensembl 93)
#' ## we can search for a term of interest to reduce the length e.g. 'sapiens'
#' searchDatasets(mart = ensembl, pattern = "sapiens")
#'
#' ## search for any dataset containing the word Rat or rat
#' searchDatasets(mart = ensembl, pattern = "(R|r)at")
#'
#' @export
listDatasets <- function(mart, verbose = FALSE) {
  .listDatasets(mart = mart, verbose = verbose, sort = TRUE)
}

#' @importFrom methods is
.listDatasets <- function(mart, verbose = FALSE, sort = FALSE) {
  if (missing(mart) || !is(mart, "Mart")) {
    stop("No Mart object given or object not of class 'Mart'")
  }

  ## we choose a separator based on whether 'redirect=no' is present
  ## should always be '?' now
  sep <- ifelse(grepl(x = martHost(mart), pattern = ".+\\?.+"), "&", "?")

  request <- paste0(
    martHost(mart),
    sep,
    "type=datasets&requestid=biomaRt&mart=",
    martBM(mart)
  )
  http_config <- martHTTPConfig(mart)

  bmResult <- bmRequest(
    request = request,
    http_config = http_config,
    verbose = verbose
  )
  txt <- scan(
    text = bmResult,
    sep = "\t",
    blank.lines.skip = TRUE,
    what = "character",
    quiet = TRUE,
    quote = "\""
  )

  ## select visible ("1") table sets
  i <- intersect(which(txt == "TableSet"), which(txt == "1") - 3L)

  res <- data.frame(
    dataset = I(txt[i + 1L]),
    description = I(txt[i + 2L]),
    version = I(txt[i + 4L])
  )

  ## sort alphabetically
  if (sort) {
    res <- res[order(res$dataset), ]
  }
  rownames(res) <- NULL

  return(res)
}

## Check version of BioMart service
#' @importFrom utils read.table
bmVersion <- function(mart, verbose = FALSE) {
  ## save some time and a HTTP request if this is Ensembl
  if (grepl(pattern = "ensembl.org", x = martHost(mart), fixed = TRUE)) {
    bmv <- "0.7"
  } else {
    ## we choose a separator based on whether 'redirect=no' is present
    sep <- ifelse(grepl(x = martHost(mart), pattern = ".+\\?.+"), "&", "?")

    request <- paste0(
      martHost(mart),
      sep,
      "type=version",
      "&requestid=biomaRt&mart=",
      martBM(mart)
    )
    http_config <- martHTTPConfig(mart)

    BioMartVersion <- bmRequest(
      request = request,
      http_config = http_config,
      verbose = verbose
    )
    bmv <- ""
    if (BioMartVersion == "\n" || BioMartVersion == "") {
      bmv <- NA
      if (verbose) {
        warning(paste(
          "BioMart version is not available from BioMart server:",
          request,
          sep = "\n"
        ))
      }
    } else {
      bmVersionParsed <- read.table(
        text = BioMartVersion,
        sep = "\t",
        header = FALSE,
        quote = "",
        comment.char = "",
        as.is = TRUE
      )
      if (verbose) {
        print(bmVersionParsed)
      }

      if (dim(bmVersionParsed)[2] >= 1) {
        bmv <- bmVersionParsed[1, 1]
      }
    }
  }
  return(bmv)
}


#' @importFrom utils read.table
.getAttrFilt <- function(mart, verbose, type) {
  ## we choose a separator based on whether 'redirect=no' is present
  sep <- ifelse(grepl(x = mart@host, pattern = ".+\\?.+"), "&", "?")

  request <- paste0(
    mart@host,
    sep,
    "type=",
    type,
    "&dataset=",
    martDataset(mart),
    "&requestid=biomaRt&mart=",
    martBM(mart),
    "&virtualSchema=",
    martVSchema(mart)
  )

  attrfilt <- bmRequest(
    request = request,
    http_config = martHTTPConfig(mart),
    verbose = verbose
  )
  attrfiltParsed <- read.table(
    text = attrfilt,
    sep = "\t",
    header = FALSE,
    quote = "",
    comment.char = "",
    as.is = TRUE
  )
  return(attrfiltParsed)
}

.getAttributes <- function(mart, verbose = FALSE) {
  attributes_table <- .getAttrFilt(
    mart = mart,
    verbose = verbose,
    type = "attributes"
  )

  if (ncol(attributes_table) < 4) {
    stop(
      "biomaRt error: looks like we're connecting to incompatible version of BioMart."
    )
  }

  colnames(attributes_table) <- c(
    "name",
    "description",
    "fullDescription",
    "page"
  )
  return(attributes_table)
}

.getFilters <- function(mart, verbose = FALSE) {
  filters_table <- .getAttrFilt(
    mart = mart,
    verbose = verbose,
    type = "filters"
  )

  if (ncol(filters_table) < 7) {
    stop(
      "biomaRt error: looks like we're connecting to incompatible version of BioMart."
    )
  }

  colnames(filters_table) <- c(
    "name",
    "description",
    "options",
    "fullDescription",
    "filters",
    "type",
    "operation"
  )
  return(filters_table)
}

## Utility function to check dataset specification
## Returns dataset name as a character assuming all checks
## have been passed.
checkDataset <- function(dataset, mart) {
  validDatasets <- .listDatasets(mart, sort = FALSE)
  ## subsetting data.frames can produce some weird classes
  ## which aren't character(), so we coerce it here
  dataset <- as.character(dataset)

  if (length(dataset) > 1) {
    stop("Please only specify a single dataset name")
  }

  if (is.na(match(dataset, validDatasets$dataset))) {
    stop(
      "The given dataset: ",
      dataset,
      ", is not valid.  Correct dataset names can be obtained with the listDatasets() function."
    )
  }

  return(dataset)
}

## Select a BioMart dataset

#' Select a dataset to use and updates Mart object
#'
#' This function selects a dataset and updates the Mart object
#'
#'
#' @param dataset Dataset you want to use.  List of possible datasets can be
#' retrieved using the function [listDatasets()]
#' @param mart Mart object created with the [useMart()] function
#' @param verbose Give detailed output of what the method is doing, for
#' debugging
#' @author Steffen Durinck
#' @keywords methods
#'
#' @examplesIf interactive()
#' mart <- useMart("ENSEMBL_MART_ENSEMBL")
#' mart <- useDataset("hsapiens_gene_ensembl", mart = mart)
#'
#' @export
useDataset <- function(dataset, mart, verbose = FALSE) {
  if (missing(mart) || !inherits(mart, "Mart")) {
    stop(
      "No valid Mart object given, specify a Mart object with the attribute mart"
    )
  }

  if (missing(dataset)) {
    stop(
      "No dataset given.  Please use the dataset argument to specify which dataset you want to use. Correct dataset names can be obtained with the listDatasets() function."
    )
  }

  dataset <- checkDataset(dataset = dataset, mart = mart)
  martDataset(mart) <- dataset

  if (verbose) {
    message("Checking attributes ...", appendLF = FALSE)
  }
  martAttributes(mart) <- .getAttributes(mart, verbose = verbose)
  if (verbose) {
    message(" ok")
    message("Checking filters ...", appendLF = FALSE)
  }
  martFilters(mart) <- .getFilters(mart, verbose = verbose)
  if (verbose) {
    message(" ok")
  }
  return(mart)
}

## listAttributes

#' lists the attributes available in the selected dataset
#'
#' Attributes are the outputs of a biomaRt query, they are the information we
#' want to retrieve.  For example if we want to retrieve all EntrezGene
#' identifiers of genes located on chromosome X, `entrezgene_id` will be
#' the attribute we use in the query.  The `listAttributes` function lists
#' the available attributes in the selected dataset.
#'
#'
#' @param mart object of class Mart created using the [useMart()] function
#' @param page Show only the attributes that belong to the specified attribute
#' page.
#' @param what vector of types of information about the attributes that need to
#' be displayed.  Can have values like name, description, fullDescription, page
#' @param pattern Character vector defining the regular expression
#' ([regex][base::regex]) to be used for the search.  If left blank the
#' default is to use ".*" which will match everything.
#' @author Steffen Durinck, Mike Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' ## list the available Ensembl marts and use Ensembl Genes
#' listEnsembl()
#' ensembl <- useEnsembl(
#'   biomart = "ENSEMBL_MART_ENSEMBL",
#'   dataset = 'hsapiens_gene_ensembl'
#' )
#'
#' ## list the available datasets in this Mart
#' listAttributes(mart = ensembl)
#'
#' ## the list of attributes is very long and gets truncated by R
#' ## we can search for a term of interest to filter this e.g. 'start'
#' searchAttributes(mart = ensembl, pattern = "start")
#'
#' ## filter the attributes to give only entries containing 'entrez' or 'hgnc'
#' searchAttributes(mart = ensembl, 'entrez|hgnc')
#'
#' @export
listAttributes <- function(
  mart,
  page,
  what = c("name", "description", "page")
) {
  martCheck(mart)
  if (!missing(page) && !page %in% attributePages(mart)) {
    stop(
      "The chosen page: ",
      page,
      " is not valid, please use the correct page name using the attributePages function"
    )
  }
  attrib <- NULL
  if (!missing(page)) {
    sel <- which(martAttributes(mart)[, "page"] == page)
    attrib <- martAttributes(mart)[sel, what]
  } else {
    attrib <- martAttributes(mart)[, what]
  }
  return(attrib)
}

## attributePages

#' Gives a summary of the attribute pages
#'
#' Attributes in BioMart databases are grouped together in attribute pages.
#' The [attributePages()] function gives a summary of the attribute categories and
#' groups present in the BioMart.  These page names can be used to display only
#' a subset of the available attributes in the [listAttributes()] function.
#'
#'
#' @param mart object of class Mart, created with the [useMart()] function.
#' @author Steffen Durinck
#' @keywords methods
#' @examplesIf interactive()
#' mart <- useMart(
#'   "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl"
#' )
#' attributePages(mart)
#'
#' @export
attributePages <- function(mart) {
  martCheck(mart)
  pages <- unique(martAttributes(mart)[, "page"])
  return(pages)
}

## listFilters

#' List or search the filters available in the selected dataset
#'
#' Filters are what we use as inputs for a biomaRt query.  For example, if we
#' want to retrieve all EntrezGene identifiers on chromosome X,
#' `chromosome` will be the filter, with corresponding value X.
#'
#'
#' @param mart object of class `Mart` created using the
#' [useMart()] function
#' @param what character vector indicating what information to display about
#' the available filters.  Valid values are `name`, `description`,
#' `options`, `fullDescription`, `filters`, `type`,
#' `operation`, `filters8`, `filters9`.
#' @param pattern Character vector defining the regular expression
#' ([regex][base::regex]) to be used for the search.  If left blank the
#' default is to use `".*"`` which will match everything.
#' @author Steffen Durinck, Mike Smith
#' @keywords methods
#'
#' @examplesIf interactive()
#' ## list the available Ensembl marts and use Ensembl Genes
#' listEnsembl()
#' ensembl <- useEnsembl(
#'   biomart = "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl"
#' )
#'
#' ## list the available datasets in this Mart
#' listFilters(mart = ensembl)
#'
#' ## the list of filters is long and not easy to read
#' ## we can search for a term of interest to reduce this e.g. 'gene'
#' searchFilters(mart = ensembl, pattern = "gene")
#'
#' ## search the available filters to find entries containing 'entrez' or 'hgnc'
#' searchFilters(mart = ensembl, 'entrez|hgnc')
#'
#' @export
listFilters <- function(mart, what = c("name", "description")) {
  martCheck(mart)
  filters <- martFilters(mart)
  badwhat <- !what %in% colnames(filters)
  if (any(badwhat)) {
    stop(sprintf(
      "The function argument 'what' contains %s: %s\nValid are: %s\n",
      if (sum(badwhat) > 1) "invalid values" else "an invalid value",
      paste(what[badwhat], collapse = ", "),
      paste(colnames(filters), collapse = ", ")
    ))
  }
  return(filters[, what])
}

#' @export
filterOptions <- function(filter, mart) {
  .Defunct(
    new = "listFilterOptions",
    msg = c(
      "filterOptions() has been made defunct and will be removed from biomaRt.",
      "\nPlease use listFilterOptions() instead."
    )
  )
}

## filterType

#' Displays the filter type
#'
#' Displays the type of the filer given a filter name.
#'
#'
#' @param filter A valid filter name. Valid filters are given by the
#' [listFilters()] function
#' @param mart object of class Mart, created using the [useMart()] function
#' @author Steffen Durinck
#' @keywords methods

#' @examplesIf interactive()
#' mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")
#' filterType("chromosome_name", mart)
#'
#' @export
filterType <- function(filter, mart) {
  if (missing(filter)) {
    stop(
      "No filter given. Please specify the filter for which you want to retrieve the filter type"
    )
  }
  if (!is.character(filter)) {
    stop("Filter argument should be of class character")
  }
  martCheck(mart)
  sel <- which(listFilters(mart, what = "name") == filter)
  if (is.null(sel)) {
    stop("Invalid filter: ", filter, sep = ": ")
  }
  type <- listFilters(mart, what = "type")[sel]
  return(type)
}

##########################################
# getBM: generic BioMart query function   #
##########################################

#' Retrieves information from the BioMart database
#'
#' This function is the main biomaRt query function.  Given a set of filters
#' and corresponding values, it retrieves the user specified attributes from
#' the BioMart database one is connected to.
#'
#'
#' @param attributes Attributes you want to retrieve.  A possible list of
#' attributes can be retrieved using the function [listAttributes()].
#' @param filters Filters (one or more) that should be used in the query.  A
#' possible list of filters can be retrieved using the function [listFilters()].
#' @param values Values of the filter, e.g. vector of affy IDs.  If multiple
#' filters are specified then the argument should be a list of vectors of which
#' the position of each vector corresponds to the position of the filters in
#' the filters argument.
#' @param mart object of class Mart, created with the [useMart()] function.
#' @param checkFilters Sometimes attributes where a value needs to be
#' specified, for example upstream_flank with value 20 for obtaining upstream
#' sequence flank regions of length 20bp, are treated as filters in BioMarts.
#' To enable such a query to work, one must specify the attribute as a filter
#' and set `checkFilters = FALSE` for the query to work.
#' @param verbose When using biomaRt in webservice mode and setting verbose to
#' TRUE, the XML query to the webservice will be printed.
#' @param uniqueRows If the result of a query contains multiple identical rows,
#' setting this argument to `TRUE` (default) will result in deleting the
#' duplicated rows in the query result at the server side.
#' @param bmHeader Boolean to indicate if the result retrieved from the BioMart
#' server should include the data headers or not, defaults to `FALSE`.  This
#' should only be switched on if the default behavior results in errors,
#' setting to on might still be able to retrieve your data in that case
#' @param quote Sometimes parsing of the results fails due to errors in the
#' Ensembl data fields such as containing a quote, in such cases you can try to
#' change the value of quote to try to still parse the results.
#' @param useCache Boolean indicating whether the results cache should be used.
#' Setting to `FALSE` will disable reading and writing of the cache.  This
#' argument is likely to disappear after the cache functionality has been
#' tested more thoroughly.
#' @return A `data.frame`. There is no implicit mapping between its rows
#' and the function arguments (e.g. `filters`, `values`), therefore
#' make sure to have the relevant identifier(s) returned by specifying them in
#' `attributes`. See Examples.
#' @author Steffen Durinck
#' @keywords methods

#' @examplesIf interactive()
#' mart <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL",
#'                    dataset = "hsapiens_gene_ensembl")
#'
#' getBM(attributes = c("affy_hg_u95av2", "hgnc_symbol", "chromosome_name", "band"),
#'       filters    = "affy_hg_u95av2",
#'       values     = c("1939_at","1503_at","1454_at"),
#'       mart       = mart)
#'
#' @importFrom progress progress_bar
#' @export
getBM <- function(
  attributes,
  filters = "",
  values = "",
  mart,
  checkFilters = TRUE,
  verbose = FALSE,
  uniqueRows = TRUE,
  bmHeader = FALSE,
  quote = "\"",
  useCache = TRUE
) {
  ## check the arguments are all valid
  martCheck(mart)
  if (missing(attributes)) {
    stop("Argument 'attributes' must be specified.")
  }

  if (is.list(filters) && !missing(values)) {
    warning(
      "Argument 'values' should not be used when argument 'filters' is a list and will be ignored."
    )
  }
  if (is.list(filters) && is.null(names(filters))) {
    stop("Argument 'filters' must be a named list when sent as a list.")
  }
  if (!is.list(filters) && all(nzchar(filters)) && missing(values)) {
    stop("Argument 'values' must be specified.")
  }
  if (length(filters) > 0 && length(values) == 0) {
    stop("Values argument contains no data.")
  }
  if (is.list(filters)) {
    values <- filters
    filters <- names(filters)
  }
  if (!is.logical(uniqueRows)) {
    stop(
      "Argument 'uniqueRows' must be a logical value, so either TRUE or FALSE"
    )
  }

  ## determine if we should use the results cache
  if (useCache) {
    cache <- .biomartCacheLocation()
    bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
  }
  hash <- .createHash(mart, attributes, filters, values, uniqueRows, bmHeader)
  if (useCache && .checkValidCache(bfc, hash)) {
    if (verbose) {
      message("Cache found")
    }
    result <- .readFromCache(bfc, hash)
    return(result)
  }
  ## force the query to return the 'descriptive text' header names with the result
  ## we use these later to match and order attribute/column names
  xmlQuery <- paste0(
    '<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE Query><Query virtualSchemaName = "',
    martVSchema(mart),
    '" uniqueRows="',
    as.numeric(uniqueRows),
    '" count="0" datasetConfigVersion="0.6" header="1"',
    ' formatter="TSV" requestid="biomaRt"><Dataset name="',
    martDataset(mart),
    '">'
  )

  # checking the Attributes
  invalid <- !attributes %in% listAttributes(mart, what = "name")
  if (any(invalid)) {
    stop(
      "Invalid attribute(s):",
      paste(attributes[invalid], collapse = ", "),
      "\nPlease use the function 'listAttributes' to get valid attribute names"
    )
  }

  # attribute are ok lets add them to the query
  attributeXML <- paste0(
    '<Attribute name = "',
    attributes,
    '"/>',
    collapse = ""
  )

  # checking the filters
  if (filters[1] != "" && checkFilters) {
    invalid <- !filters %in% listFilters(mart, what = "name")
    if (any(invalid)) {
      stop(
        "Invalid filters(s): ",
        paste(filters[invalid], collapse = ", "),
        "\nPlease use the function 'listFilters' to get valid filter names"
      )
    }
  }

  ## filterXML is a list containing filters with reduced numbers of values
  ## to meet the 500 value limit in BioMart queries
  filterXmlList <- .generateFilterXML(filters, values, mart)

  resultList <- list()
  if (length(filterXmlList) > 1) {
    pb <- progress_bar$new(
      total = length(filterXmlList),
      width = getOption("width") - 10,
      format = "Batch submitting query [:bar] :percent eta: :eta"
    )
    pb$tick(0)
    on.exit(pb$terminate())
  }

  ## we submit a query for each chunk of the filter list
  for (i in seq_along(filterXmlList)) {
    if (i > 1) {
      pb$tick()
    }

    filterXML <- filterXmlList[[i]]
    fullXmlQuery <- paste0(
      xmlQuery,
      attributeXML,
      filterXML,
      "</Dataset></Query>"
    )

    if (verbose) {
      message(fullXmlQuery)
    }

    ## we choose a separator based on whether '?redirect=no' is present
    sep <- ifelse(
      grepl(x = martHost(mart), pattern = ".+\\?.+"),
      "&",
      "?"
    )

    ## create a unique name for this chunk & see if it has been run before
    chunk_hash <- tools::md5sum(
      bytes = charToRaw(paste(martHost(mart), fullXmlQuery))
    )
    tf <- file.path(
      tempdir(),
      paste0("biomaRt_tmp_", chunk_hash, ".rds")
    )
    if (file.exists(tf)) {
      result <- readRDS(tf)
    } else {
      postRes <- .submitQueryXML(
        host = martHost(mart),
        query = fullXmlQuery,
        http_config = martHTTPConfig(mart)
      )
      result <- .processResults(
        postRes,
        mart = mart,
        hostURLsep = sep,
        fullXmlQuery = fullXmlQuery,
        quote = quote,
        numAttributes = length(attributes)
      )
      saveRDS(result, file = tf)
    }
    resultList[[i]] <- .setResultColNames(
      result,
      mart = mart,
      attributes = attributes,
      bmHeader = bmHeader
    )
  }
  ## collate results
  result <- do.call("rbind", resultList)

  if (useCache) {
    .addToCache(bfc = bfc, result = result, hash = hash)
  }

  ## remove any temp chunk files
  file.remove(list.files(
    tempdir(),
    pattern = "^biomaRt.*rds$",
    full.names = TRUE
  ))
  return(result)
}

###################################
# getLDS: Multiple dataset linking #
###################################

#' Retrieves information from two linked datasets
#'
#' This function is the main biomaRt query function that links 2 datasets and
#' retrieves information from these linked BioMart datasets.  In Ensembl this
#' translates to homology mapping.
#'
#'
#' @param attributes Attributes you want to retrieve of primary dataset.  A
#' possible list of attributes can be retrieved using the function
#' [listAttributes()].
#' @param filters Filters that should be used in the query. These filters will
#' be applied to primary dataset.  A possible list of filters can be retrieved
#' using the function [listFilters()].
#' @param values Values of the filter, e.g. list of affy IDs
#' @param mart object of class Mart created with the [useMart()] function.
#' @param attributesL Attributes of linked dataset that needs to be retrieved
#' @param filtersL Filters to be applied to the linked dataset
#' @param valuesL Values for the linked dataset filters
#' @param martL Mart object representing linked dataset
#' @param verbose When using \pkg{biomaRt} in webservice mode and setting
#' verbose to `TRUE`, the XML query to the webservice will be printed.
#' Alternatively in MySQL mode the MySQL query will be printed.
#' @param uniqueRows Logical to indicate if the BioMart web service should
#' return unique rows only or not.  Has the value of either `TRUE` or `FALSE`
#' @param bmHeader Boolean to indicate if the result retrieved from the BioMart
#' server should include the data headers or not, defaults to `TRUE`.  This
#' should only be switched off if the default behavior results in errors,
#' setting to off might still be able to retrieve your data in that case
#' @author Steffen Durinck
#' @keywords methods
#'
#' @examplesIf interactive()
#' human <- useMart(
#'   "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl",
#'   host = "https://dec2021.archive.ensembl.org"
#' )
#' mouse <- useMart(
#'   "ENSEMBL_MART_ENSEMBL",
#'   dataset = "mmusculus_gene_ensembl",
#'   host = "https://dec2021.archive.ensembl.org"
#' )
#' getLDS(
#'   attributes = c("hgnc_symbol","chromosome_name", "start_position"),
#'   filters = "hgnc_symbol",
#'   values = "TP53",
#'   mart = human,
#'   attributesL = c("chromosome_name","start_position"),
#'   martL = mouse
#' )
#' @export
#' @importFrom methods is
#' @importFrom utils head read.table
getLDS <- function(
  attributes,
  filters = "",
  values = "",
  mart,
  attributesL,
  filtersL = "",
  valuesL = "",
  martL,
  verbose = FALSE,
  uniqueRows = TRUE,
  bmHeader = TRUE
) {
  martCheck(mart)
  martCheck(martL)

  if (martHost(mart) != martHost(martL)) {
    stop("Both datasets must be located on the same host.")
  }

  if (martBM(mart) != martBM(martL)) {
    stop(
      "Both datasets must be located in the same Mart.\n",
      "You are trying to combine datasets in ",
      martBM(mart),
      " and ",
      martBM(martL)
    )
  }

  invalid <- !attributes %in% listAttributes(mart, what = "name")
  if (any(invalid)) {
    stop(
      "Invalid attribute(s): ",
      paste(attributes[invalid], collapse = ", "),
      "\nPlease use the function 'listAttributes' to get valid attribute names"
    )
  }

  invalid <- !attributesL %in% listAttributes(martL, what = "name")
  if (any(invalid)) {
    stop(
      "Invalid attribute(s): ",
      paste(attributesL[invalid], collapse = ", "),
      "\nPlease use the function 'listAttributes' to get valid attribute names"
    )
  }

  if (nzchar(filters[1])) {
    invalid <- !filters %in% listFilters(mart, what = "name")
    if (any(invalid)) {
      stop(
        "Invalid filters(s): ",
        paste(filters[invalid], collapse = ", "),
        "\nPlease use the function 'listFilters' to get valid filter names"
      )
    }
  }
  if (nzchar(filtersL[1])) {
    invalid <- !filtersL %in% listFilters(martL, what = "name")
    if (any(invalid)) {
      stop(
        "Invalid filters(s): ",
        paste(filtersL[invalid], collapse = ", "),
        "\nPlease use the function 'listFilters' to get valid filter names"
      )
    }
  }

  xmlQuery <- sprintf(
    '<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE Query><Query virtualSchemaName = "%s" uniqueRows = "%s" count = "0" datasetConfigVersion = "0.6" header="%s" formatter = "TSV" requestid="biomaRt"> <Dataset name = "%s">',
    martVSchema(mart),
    as.numeric(uniqueRows),
    as.numeric(bmHeader),
    martDataset(mart)
  )

  attributeXML <- paste0(
    '<Attribute name = "',
    attributes,
    '"/>',
    collapse = ""
  )

  ## ignore the chunk size here
  filterXML <- .generateFilterXML(
    filters = filters,
    values = values,
    mart = mart,
    maxChunkSize = Inf
  )

  xmlQuery <- paste0(xmlQuery, attributeXML, filterXML, "</Dataset>")

  xmlQuery <- paste0(xmlQuery, '<Dataset name = "', martDataset(martL), '" >')
  linkedAttributeXML <- paste0(
    '<Attribute name = "',
    attributesL,
    '"/>',
    collapse = ""
  )
  linkedFilterXML <- .generateFilterXML(
    filters = filtersL,
    values = valuesL,
    mart = mart,
    maxChunkSize = Inf
  )

  xmlQuery <- paste0(
    xmlQuery,
    linkedAttributeXML,
    linkedFilterXML,
    "</Dataset></Query>"
  )

  if (verbose) {
    message(xmlQuery)
  }

  ## we choose a separator based on whether '?redirect=no' is present
  sep <- ifelse(grepl(x = martHost(mart), pattern = ".+\\?.+"), "&", "?")
  ## POST query
  postRes <- .submitQueryXML(
    host = paste0(martHost(mart), sep),
    query = xmlQuery,
    http_config = martHTTPConfig(mart)
  )

  if (any(startsWith(postRes, "Query ERROR"))) {
    stop(postRes)
  }

  if (postRes != "") {
    result <- read.table(
      text = postRes,
      sep = "\t",
      header = bmHeader,
      quote = "\"",
      comment.char = "",
      as.is = TRUE,
      check.names = TRUE
    )

    if (nrow(result) > 0 && all(is.na(result[, ncol(result)]))) {
      result <- result[, -ncol(result), drop = FALSE]
    }

    res_attributes <- c(attributes, attributesL)
    if (!is.data.frame(result) || ncol(result) != length(res_attributes)) {
      print(head(result))
      stop(
        "The query to the BioMart webservice returned an invalid result: ",
        "the number of columns in the result table does not equal the number of attributes in the query. \n",
        "Please report this on the support site at https://support.bioconductor.org"
      )
    }
    if (!bmHeader) {
      # assumes order of results same as order of attibutes in input
      colnames(result) <- res_attributes
    }
  } else {
    warning("getLDS returns NULL.")
    result <- NULL
  }
  return(result)
}

library(biomaRt)
cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

with_mock_dir(
  "all_200",
  {
    test_that("listMarts returns a data.frame", {
      ensembl_marts <- listMarts(host = "https://www.ensembl.org")
      expect_s3_class(ensembl_marts, class = "data.frame")
      expect_identical(colnames(ensembl_marts), c("biomart", "version"))
    })
  },
  simplify = TRUE
)

test_that("Error when old URL is used", {
  expect_error(listMarts(host = "www.biomart.org"))
})

library(biomaRt)
cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

test_that("martCheck() catches bad input", {
  expect_error(biomaRt:::martCheck())
  expect_error(biomaRt:::martCheck("INVALID_OBJECT"))

  ensembl <- Mart(biomart = "ensembl")

  expect_error(
    biomaRt:::martCheck(ensembl),
    regexp = "No dataset selected, please select a dataset first"
  )

  ensembl <- Mart(biomart = "ensembl", dataset = "hsapiens_gene_ensembl")
  expect_error(
    biomaRt:::martCheck(ensembl, biomart = "Not_real_mart"),
    regexp = "This function only works when used with"
  )
})

library(biomaRt)
cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

plants <- Mart(
  biomart = "plants_mart",
  dataset = "athaliana_eg_gene",
  host = "https://plants.ensembl.org"
)

mouse <- Mart(
  biomart = "mouse_genes",
  dataset = "mmusculus_gene_ensembl",
  host = "https://www.ensembl.org"
)

mouse_strains <- Mart(
  biomart = "mouse_strains",
  dataset = "mmc57bl6nj_gene_ensembl",
  host = "https://www.ensembl.org"
)

test_that("Error with separate hosts", {
  expect_error(
    getLDS(
      attributes = "ensembl_gene_id",
      mart = mouse,
      attributesL = "ensembl_gene_id",
      martL = plants
    ),
    regexp = "Both datasets must be located on the same host"
  )
})

test_that("We get an error with different Marts on the same host", {
  expect_error(
    getLDS(
      attributes = "ensembl_gene_id",
      mart = mouse,
      attributesL = "ensembl_gene_id",
      martL = mouse_strains
    ),
    regexp = "Both datasets must be located in the same Mart"
  )
})

structure(
  list(
    method = "POST",
    url = "https://asia.ensembl.org/info/website/archives/index.html?redirect=no",
    status_code = 500L,
    headers = structure(
      list(
        Date = "Fri, 12 Jan 2024 15:37:37 GMT",
        Server = "Apache",
        `X-Frame-Options` = "SAMEORIGIN",
        `Content-Security-Policy` = "frame-ancestors 'self'",
        `Transfer-Encoding` = "chunked",
        `Content-Type` = "text/plain; charset=utf-8"
      ),
      class = "httr2_headers"
    ),
    body = charToRaw("ENSG00000000003\n"),
    request = structure(
      list(
        url = "https://asia.ensembl.org/info/website/archives/index.html?redirect=no",
        method = NULL,
        headers = list(),
        body = list(
          data = list(
            query = structure(
              "%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22UTF-8%22%3F%3E%0A%3C%21DOCTYPE%20Query%3E%0A%3CQuery%20%20virtualSchemaName%20%3D%20%22default%22%20formatter%20%3D%20%22TSV%22%20header%20%3D%20%220%22%20uniqueRows%20%3D%20%220%22%20count%20%3D%20%22%22%20datasetConfigVersion%20%3D%20%220.6%22%20%3E%0A%09%3CDataset%20name%20%3D%20%22hsapiens_gene_ensembl%22%20interface%20%3D%20%22default%22%20%3E%0A%09%09%3CFilter%20name%20%3D%20%22ensembl_gene_id%22%20value%20%3D%20%22ENSG00000000003%22%2F%3E%0A%09%09%3CAttribute%20name%20%3D%20%22ensembl_gene_id%22%20%2F%3E%0A%09%3C%2FDataset%3E%0A%3C%2FQuery%3E",
              class = "AsIs"
            )
          ),
          type = "form",
          content_type = "application/x-www-form-urlencoded",
          params = list()
        ),
        fields = list(),
        options = list(
          timeout_ms = 10000
        ),
        policies = list()
      ),
      class = "httr2_request"
    ),
    cache = new.env(parent = emptyenv())
  ),
  class = "httr2_response"
)

#' Class Mart
#'
#' Represents a Mart class, containing connections to different BioMarts
#'
#' @param object An object of class `Mart`
#'
#' @aliases Mart-class show,Mart-method
#' @section Methods: \describe{`show` Print summary of the object}
#' @author Steffen Durinck
#' @keywords methods
#' @rdname Mart-class
#' @importFrom methods setMethod signature
#' @export
setMethod("show", signature(object = "Mart"), function(object) {
  dbase <- ifelse(
    nzchar(object@biomart),
    yes = paste("  Using the", object@biomart, "BioMart database"),
    no = "  No database selected."
  )

  dset <- ifelse(
    nzchar(object@dataset),
    yes = paste("  Using the", object@dataset, "dataset"),
    no = "  No dataset selected."
  )

  res <- paste("Object of class 'Mart':", dbase, dset, sep = "\n")
  cat(res)
})

#' @importFrom methods setGeneric
setGeneric("martBM", function(obj, ...) standardGeneric("martBM"))
#' @importFrom methods setMethod signature
setMethod("martBM", signature("Mart"), function(obj) obj@biomart)
#' @importFrom methods setGeneric
setGeneric("martBM<-", function(obj, value) standardGeneric("martBM<-"))
#' @importFrom methods setReplaceMethod
setReplaceMethod("martBM", "Mart", function(obj, value) {
  obj@biomart <- value
  obj
})


#' @importFrom methods setGeneric
setGeneric("martAttributes", function(obj, ...) standardGeneric("martAttributes"))
#' @importFrom methods setMethod signature
setMethod("martAttributes", signature("Mart"), function(obj) obj@attributes)
#' @importFrom methods setGeneric
setGeneric("martAttributes<-", function(obj, value) standardGeneric("martAttributes<-"))
#' @importFrom methods setReplaceMethod
setReplaceMethod("martAttributes", "Mart", function(obj, value) {
  obj@attributes <- value
  obj
})


#' @importFrom methods setGeneric
setGeneric("martFilters", function(obj, ...) standardGeneric("martFilters"))
#' @importFrom methods setMethod signature
setMethod("martFilters", signature("Mart"), function(obj) obj@filters)
#' @importFrom methods setGeneric
setGeneric("martFilters<-", function(obj, value) standardGeneric("martFilters<-"))
#' @importFrom methods setReplaceMethod
setReplaceMethod("martFilters", "Mart", function(obj, value) {
  obj@filters <- value
  obj
})


#' @importFrom methods setGeneric
setGeneric("martDataset", function(obj, ...) standardGeneric("martDataset"))
#' @importFrom methods setMethod signature
setMethod("martDataset", signature("Mart"), function(obj) obj@dataset)
#' @importFrom methods setGeneric
setGeneric("martDataset<-", function(obj, value) standardGeneric("martDataset<-"))
#' @importFrom methods setReplaceMethod
setReplaceMethod("martDataset", "Mart", function(obj, value) {
  obj@dataset <- value
  obj
})

#' @importFrom methods setGeneric
setGeneric("martHost", function(obj, ...) standardGeneric("martHost"))
#' @importFrom methods setMethod signature
setMethod("martHost", signature("Mart"), function(obj) obj@host)
#' @importFrom methods setGeneric
setGeneric("martHost<-", function(obj, value) standardGeneric("martHost<-"))
#' @importFrom methods setReplaceMethod
setReplaceMethod("martHost", "Mart", function(obj, value) {
  obj@host <- value
  obj
})

#' @importFrom methods setGeneric
setGeneric("martVSchema", function(obj, ...) standardGeneric("martVSchema"))
#' @importFrom methods setMethod signature
setMethod("martVSchema", signature("Mart"), function(obj) obj@vschema)

#' @importFrom methods setGeneric
setGeneric("martHTTPConfig", function(obj) standardGeneric("martHTTPConfig"))
#' @importFrom methods setMethod signature
setMethod("martHTTPConfig", signature("Mart"), function(obj) {
  config <- do.call(c, obj@http_config)
  if (is.null(config)) {
    config <- list()
  }
  return(config)
})

#####################################################################
## new wrappers to enable keys, columns, select and keytypes

#' Retrieve information from the BioMart databases
#'
#' `select`, `columns` and `keys` are used together to extract
#' data from a `Mart` object.  These functions work much the same as the
#' classic biomaRt functions such as [getBM()] etc. and are provide here to
#' make this easier for people who are comfortable using these methods from
#' other Annotation packages.  Examples of other objects in other packages
#' where you can use these methods include (but are not limited to):
#' `ChipDb`, `OrgDb` `GODb`, `InparanoidDb` and
#' `ReactomeDb`.
#'
#' `columns` shows which kinds of data can be returned from the
#' `Mart` object.
#'
#' `keytypes` allows the user to discover which keytypes can be passed in
#' to `select` or `keys` as the `keytype` argument.
#'
#' `keys` returns keys from the `Mart` of the type specified by it's
#' `keytype` argument.
#'
#' `select` is meant to be used with these other methods and has arguments
#' that take the kinds of values that these other methods return.
#' `select` will retrieve the results as a data.frame based on parameters
#' for selected `keys` and `columns` and `keytype` arguments.
#'
#'
#' @aliases select-methods keys,Mart-method columns,Mart-method
#' keytypes,Mart-method select,Mart-method keys columns keytypes select
#' @param x the `Mart` object. The dataset of the `Mart` object must
#' already be specified for all of these methods.
#' @param keys the keys to select records for from the database.  Keys for some
#' keytypes can be extracted by using the `keys` method.
#' @param columns the columns or kinds of things that can be retrieved from the
#' database.  As with `keys`, all possible columns are returned by using
#' the `columns` method.
#' @param keytype the keytype that matches the keys used.  For the
#' `select` methods, this is used to indicate the kind of ID being used
#' with the keys argument. For the `keys` method this is used to indicate
#' which kind of keys are desired from `keys`
#' @param ... other arguments.  These include: \describe{ \item{pattern:}{the
#' pattern to match (used by keys)} \item{column:}{the column to search on.
#' This is used by keys and is for when the thing you want to pattern match is
#' different from the keytype, or when you want to simply want to get keys that
#' have a value for the thing specified by the column argument.}
#' \item{fuzzy:}{TRUE or FALSE value.  Use fuzzy matching? (this is used with
#' pattern by the keys method)} }
#' @return `keys`,`columns` and `keytypes` each return a
#' character vector or possible values.  `select` returns a data.frame.
#' @author Marc Carlson
#' @keywords methods
#'
#' @examplesIf interactive()
#' ## 1st create a Mart object and specify the dataset
#' mart <- useEnsembl(
#'   biomart = "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl"
#' )
#' ## you can list the keytypes
#' keytypes(mart)
#' ## you can list the columns
#' columns(mart)
#' ## And you can extract keys when this is supported for your keytype of interest
#' k <- keys(mart, keytype="chromosome_name")
#' head(k)
#' ## You can even do some pattern matching on the keys
#' k <- keys(mart, keytype="chromosome_name", pattern="LRG")
#' head(k)
#' ## Finally you can use select to extract records for things that you are
#' ## interested in.
#' affy <- c("202763_at", "209310_s_at", "207500_at")
#' select(mart, keys=affy, columns=c('affy_hg_u133_plus_2','entrezgene_id'),
#'   keytype='affy_hg_u133_plus_2')
#'
#' @importMethodsFrom AnnotationDbi keys keytypes columns select
#' @name select-methods

#' @rdname select-methods
#' @export
#' @importFrom methods setMethod
setMethod("keys", "Mart", function(x, keytype, ...) {
  # nolint next: undesirable_operator_linter.
  AnnotationDbi:::smartKeys(x = x, keytype = keytype, ..., FUN = .keys)
})
.keys <- function(x, keytype) {
  searchFilterOptions(mart = x, filter = keytype)
}

#' @rdname select-methods
#' @export
#' @importFrom methods setMethod
setMethod("keytypes", "Mart", function(x) listFilters(mart = x, what = "name"))
#' @rdname select-methods
#' @export
#' @importFrom methods setMethod
setMethod("columns", "Mart", function(x) {
  listAttributes(mart = x, what = "name")
})

## Arg checking is similar (but more limited) to what is done for getBM
#' @rdname select-methods
#' @export
#' @importFrom methods setMethod
setMethod("select", "Mart", function(x, keys, columns, keytype, ...) {
  if (missing(columns)) {
    stop("Argument 'columns' must be specified.")
  }
  if (!is.list(keytype) && keytype != "" && missing(keys)) {
    stop("Argument 'keys' must be specified.")
  }
  if (length(keytype) > 0 && length(keys) == 0) {
    stop("Keys argument contains no data.")
  }
  if (!is.character(keytype) || length(keytype) != 1) {
    stop("keytype should be single element character vector.")
  }
  getBM(attributes = columns, filters = keytype, values = keys, mart = x)
})

## sometimes results can be returned by getBM() in a different order to we
## asked for them, which messes up the column names.  Here we try to match
## results to known attribute names and rename accordingly.
.setResultColNames <- function(result, mart, attributes, bmHeader = FALSE) {
  ## get all available attributes and
  ## filter only for the ones we've actually asked for
  att <- listAttributes(mart, what = c("name", "description"))
  att <- att[which(att[, "name"] %in% attributes), ]
  if (
    length(which(duplicated(att[, "description"]))) >
      length(which(duplicated(att)))
  ) {
    warning(
      "Cannot unambiguously match attribute names
                Ignoring bmHeader argument and using biomart
                description field"
    )
    return(result)
  }

  resultNames <- colnames(result)
  ## match the returned column names with the attribute names
  matches <- match(resultNames, att[, 2], NA)
  if (anyNA(matches)) {
    warning(
      "Problems assigning column names.",
      "Currently using the biomart description field.",
      "You may wish to set these manually."
    )
    return(result)
  }
  ## if we want to use the attribute names we specified, do this,
  ## otherwise we use the header returned with the query
  if (!bmHeader) {
    colnames(result) <- att[matches, 1]
  }
  ## now put things in the order we actually asked for the attributes in
  result <- result[, match(att[matches, 1], attributes), drop = FALSE]

  return(result)
}

## BioMart doesn't work well if the list of values provided to a filter is
## longer than 500 values.  It returns only a subset of the requested data
## and does so silently!  This function is designed to take a list of provided
## filters, and split any longer than 'maxChunkSize'.  It operates recursively
## incase there are multiple filters that need splitting, and should ensure
## all possible groupings of filters are retained.
.splitValues <- function(valuesList, maxChunkSize = 500) {
  vLength <- lengths(valuesList[[1]])

  if (all(vLength <= maxChunkSize)) {
    return(valuesList)
  }
  ## pick the next filter to split
  vIdx <- min(which(vLength > maxChunkSize))

  nchunks <- (vLength[vIdx] %/% maxChunkSize) + 1
  splitIdx <- rep(1:nchunks, each = ceiling(vLength[vIdx] / nchunks))[
    1:vLength[vIdx]
  ]

  ## a new list we will populate with the chunks
  tmpList <- list()
  for (i in 1:nchunks) {
    for (j in seq_along(valuesList)) {
      listIdx <- ((i - 1) * length(valuesList)) + j
      tmpList[[listIdx]] <- valuesList[[j]]
      tmpList[[listIdx]][[vIdx]] <- tmpList[[listIdx]][[vIdx]][which(
        splitIdx == i
      )]
    }
  }
  ## recursively call the function to process next filter
  valuesList <- .splitValues(tmpList, maxChunkSize = maxChunkSize)
  return(valuesList)
}

## Creating the filter XML for a single chunk of values.  Returns a character
## vector containing the XML lines for all specified filters & their
## attributes spliced together into a single string.
.createFilterXMLchunk <- function(filterChunk, mart) {
  individualFilters <- vapply(
    names(filterChunk),
    FUN = function(filter, values, mart) {
      ## if the filter exists and is boolean we do this
      if (
        filter %in%
          listFilters(mart, what = "name") &&
          grepl(
            "boolean",
            filterType(filter = filter, mart = mart),
            fixed = TRUE
          )
      ) {
        if (!is.logical(values[[filter]])) {
          stop(
            "'",
            filter,
            "' is a boolean filter and needs a ",
            "corresponding logical value of TRUE or FALSE to ",
            "indicate if the query should retrieve all data that ",
            "fulfill the boolean or alternatively that all data ",
            "that not fulfill the requirement should be retrieved.",
            call. = FALSE
          )
        }
        val <- as.numeric(!values[[filter]])
        val <- paste0("\" excluded = \"", val, "\" ")
      } else {
        ## otherwise the filter isn't boolean, or doesn't exist

        if (is.numeric(values[[filter]])) {
          values[[filter]] <- as.integer(values[[filter]])
        }
        val <- paste0(values[[filter]], collapse = ",")
        ## convert " to ' to avoid truncating the query string
        val <- gsub(x = val, pattern = "\"", replacement = "'", fixed = TRUE)
        val <- paste0('" value = "', val, '" ')
      }
      filterXML <- paste0("<Filter name = \"", filter, val, "/>")
      return(filterXML)
    },
    FUN.VALUE = character(1),
    filterChunk,
    mart,
    USE.NAMES = FALSE
  )

  filterXML <- paste0(individualFilters, collapse = "")
  return(filterXML)
}

.generateFilterXML <- function(
  filters = "",
  values,
  mart,
  maxChunkSize = 5000
) {
  ## return empty string if no filter specified & this isn't ensembl
  ## specifying no filter is generally bad, as it will get 'everything'
  ## and we might encounter the time out problem
  if (filters[1] == "") {
    return("")
  }
  ## if we have multiple filters, the values must be specified as a list.
  if (length(filters) > 1 && !is.list(values)) {
    stop(
      "If using multiple filters, the 'value' has to be a list.",
      "\nFor example, a valid list for 'value' could be: list(affyid=c('1939_at','1000_at'), chromosome= '16')",
      "\nHere we select on Affymetrix identifier and chromosome, only results that pass both filters will be returned"
    )
  }
  ## it's easy to not realise you're passing a data frame here, so check
  if (is.data.frame(values) && ncol(values) == 1) {
    values <- values[, 1]
  }

  if (!is.list(values)) {
    values <- list(values)
  }
  names(values) <- filters

  values <- .splitValues(list(values), maxChunkSize = maxChunkSize)

  filterXML_list <- lapply(values, .createFilterXMLchunk, mart)

  return(filterXML_list)
}

## it seems like pretty common practice for users to copy and paste the host
## name from a browser if they're not accessing Ensembl.  Typically this will
## include the "http://" and maybe a trailing "/" and this messes up our
## paste the complete URL strategy and produces something invalid.
## This function tidies that up to catch common variants.
.cleanHostURL <- function(host) {
  if (!grepl("^https?://", x = host)) {
    host <- paste0("http://", host)
  }

  parsed_url <- httr2::url_parse(host)

  ## just supplying 'ensembl.org' is no longer handled correctly
  ## stick 'www' in front if we see this
  if (parsed_url$hostname == "ensembl.org") {
    parsed_url$hostname <- "www.ensembl.org"
  }

  ## For HTTPS on Ensembl
  if (
    grepl("ensembl", parsed_url$hostname, fixed = TRUE) &&
      parsed_url$scheme != "https"
  ) {
    parsed_url$scheme <- "https"
  }

  host <- httr2::url_build(parsed_url)

  ## strip trailing slash
  host <- gsub(pattern = "/$", replacement = "", x = host)
  return(host)
}

.createErrorMessage <- function(error_code, host = "") {
  ## if we encounter internal server error, suggest using a mirror
  if (error_code == 500) {
    err_msg <- "biomaRt has encountered an unexpected server error."
  } else if (error_code == 509) {
    err_msg <- "biomaRt has exceeded the bandwidth allowance with this server."
  } else {
    err_msg <- paste0(
      "biomaRt has encountered an unknown server error. HTTP error code: ",
      error_code,
      "\nPlease report this on the Bioconductor support site at https://support.bioconductor.org/"
    )
  }

  if (grepl("ensembl", x = host, fixed = TRUE)) {
    err_msg <- c(
      err_msg,
      "\nConsider trying one of the Ensembl mirrors (for more details look at ?useEnsembl)"
    )
  }

  return(err_msg)
}

#' @importFrom httr2 req_body_form req_options req_timeout resp_body_string resp_status req_user_agent
.submitQueryXML <- function(host, query, http_config) {
  req <- httr2::request(host) |>
    req_user_agent(
      .biomaRt_user_agent()
    ) |>
    req_body_form(query = query) |>
    req_timeout(max(getOption("timeout", default = 300), 300)) |>
    req_options(!!!http_config)

  res <- httr2::req_perform(req)

  if (httr2::resp_url(res) != host) {
    req2 <- req |>
      httr2::req_url(httr2::resp_url(res))
    res <- httr2::req_perform(req2)
  }

  if (httr2::resp_is_error(res)) {
    err_msg <- .createErrorMessage(error_code = resp_status(res), host = host)
    stop(err_msg, call. = FALSE)
  }

  ## content() prints a message about encoding not being supplied
  ## for ensembl.org - no default, so we suppress it
  return(resp_body_string(res))
}

## if parsing of TSV results fails, try this
.fetchHTMLresults <- function(host, query, http_config) {
  query <- gsub(x = query, pattern = "TSV", replacement = "HTML", fixed = TRUE)
  html_res <- .submitQueryXML(host, query, http_config)

  html <- xml2::read_html(html_res)
  table <- xml2::xml_find_first(html, ".//table")
  rows <- xml2::xml_find_all(table, ".//tr")
  cells <- lapply(rows, xml2::xml_find_all, ".//td|.//th")

  list_of_cells <- lapply(cells, FUN = xml2::xml_text)
  colnames <- list_of_cells[[1]]
  out <- as.data.frame(do.call(rbind, list_of_cells), row.names = NULL)
  out <- out[-1, ]
  colnames(out) <- colnames
  rownames(out) <- NULL
  return(out)
}

#' @param postRes Character vector of length 1 returned by server.  We expect
#' this to be a tab delimited string that comprises the whole table of results
#' including column headers.
#'
#' @noRd
#' @importFrom methods is
#' @importFrom utils read.table
.processResults <- function(
  postRes,
  mart,
  hostURLsep = "?",
  fullXmlQuery,
  quote = "\"",
  numAttributes
) {
  ## we expect only a character vector of length 1
  if (!is.character(postRes) || length(postRes) != 1L) {
    stop(
      "The query to the BioMart webservice returned an invalid result\n",
      "biomaRt expected a character string of length 1.\n",
      "Please report this on the support site at https://support.bioconductor.org"
    )
  }

  if (startsWith(postRes, "Query ERROR")) {
    stop(postRes)
  }

  ## convert the serialized table into a dataframe
  result <- tryCatch(
    read.table(
      text = postRes,
      sep = "\t",
      header = TRUE,
      quote = quote,
      comment.char = "",
      tryLogical = FALSE,
      stringsAsFactors = FALSE,
      check.names = FALSE
    ),
    error = function(e) {
      ## if the error relates to number of element, try reading HTML version
      if (!grepl(x = e, pattern = "line [0-9]+ did not have [0-9]+ elements")) {
        stop(e)
      }
      .fetchHTMLresults(
        host = paste0(martHost(mart), hostURLsep),
        query = fullXmlQuery,
        http_config = martHTTPConfig(mart)
      )
    }
  )

  if (!is.data.frame(result) || ncol(result) != numAttributes) {
    stop(
      "The query to the BioMart webservice returned an invalid result.\n",
      "The number of columns in the result table does not equal the number of attributes in the query.\n",
      "Please report this on the support site at https://support.bioconductor.org"
    )
  }

  return(result)
}

##############################################
## searching Attributes, Filters, and Datasets
##############################################

## given a data.frame, searches every column for
## the value in 'pattern'
## returns index of rows containing a match
.searchInternal <- function(pattern, data) {
  colIdx <- vapply(
    data,
    FUN = stringr::str_detect,
    FUN.VALUE = logical(length = nrow(data)),
    pattern = pattern
  )
  rowIdx <- apply(colIdx, 1, any)

  ## return either the matching rows, or NULL
  if (any(rowIdx)) {
    return(data[rowIdx, ])
  } else {
    message("No matching datasets found")
    return(NULL)
  }
}

#' @rdname listDatasets
#' @export
searchDatasets <- function(mart, pattern = ".*") {
  if (missing(mart)) {
    stop("Argument 'mart' must be specified")
  }

  datasets <- listDatasets(mart)
  res <- .searchInternal(pattern = pattern, data = datasets)

  if (is.null(res)) {
    return(invisible(NULL))
  }
  res
}

#' @rdname listAttributes
#'
#' @export
searchAttributes <- function(mart, pattern = ".*") {
  if (missing(mart)) {
    stop("Argument 'mart' must be specified")
  }

  attributes <- listAttributes(mart)
  res <- .searchInternal(pattern = pattern, data = attributes)

  if (is.null(res)) {
    return(invisible(NULL))
  }
  res
}

#' @rdname listFilters
#' @export
searchFilters <- function(mart, pattern = ".*") {
  if (missing(mart)) {
    stop("Argument 'mart' must be specified")
  }

  filters <- listFilters(mart)
  res <- .searchInternal(pattern = pattern, data = filters)

  if (is.null(res)) {
    return(invisible(NULL))
  }
  res
}


## Some filters have a predefined list of options that can be selected.
## This function lets us search those values, given a specified filter.
#' @rdname listFilterOptions
#' @export
searchFilterOptions <- function(mart, filter, pattern = ".*") {
  if (missing(mart)) {
    stop("Argument 'mart' must be specified")
  }
  if (missing(filter)) {
    stop("Argument 'filter' must be specified")
  }

  ## first get all filters & their options, then reduce to what's requested
  filters <- listFilters(mart, what = c("name", "options"))
  filters <- filters[filters$name == filter, ]
  if (nrow(filters) == 0) {
    stop("Filter '", filter, "' not found.")
  }
  options <- gsub(filters$options, pattern = "^\\[|\\]$", replacement = "")
  options <- strsplit(options, split = ",", fixed = TRUE)[[1]]

  res <- grep(x = options, pattern = pattern, ignore.case = TRUE, value = TRUE)

  if (length(res) == 0) {
    message("No matching values found")
  } else {
    res
  }
}

#' @export
searchFilterValues <- function(mart, filter, pattern) {
  .Defunct(
    new = "listFilterOptions",
    msg = "This function has been renamed searchFilterOptions()"
  )
}


#' List or search the options available for a specified filter.
#'
#' Some filters have a predefined list of values that can be used to search
#' them.  These functions give access to this list of options for a named
#' filter, so you can check in the case where your biomaRt query is not finding
#' anything.
#'
#'
#' @param mart object of class `Mart` created using the
#' [useMart()], or [useEnsembl()] functions
#' @param filter The name of the filter whose options should be listed or
#' searched.  You can list available filters via [listFilters()]
#' @param pattern Character vector defining the regular expression
#' ([regex][base::regex]) to be used for the search.  If left blank the
#' default is to use ".*" which will match everything.
#' @author Mike Smith
#' @seealso [listFilters()]
#' @keywords methods
#'
#' @examplesIf interactive()
#' ## Use the Ensembl human genes dataset
#' ensembl <- useEnsembl(
#'   biomart = "ENSEMBL_MART_ENSEMBL",
#'   dataset = "hsapiens_gene_ensembl"
#' )
#'
#' ## we can search for the name of a filter we're interested in e.g. 'phenotype'
#' ## we need to use the name of the filter in the next function
#' searchFilters(ensembl, pattern = "phenotype")
#'
#' ## list all the options available to the 'phenotype_source' filter
#' listFilterOptions(mart = ensembl, filter = "phenotype_source")
#'
#' ## search the 'phenotype_description' filter for the term 'crohn'
#' searchFilterOptions(
#'   mart = ensembl,
#'   filter = "phenotype_description",
#'   pattern = "crohn"
#' )
#'
#' @export
listFilterOptions <- function(mart, filter) {
  searchFilterOptions(mart = mart, filter = filter)
}

#' @export
listFilterValues <- function(mart, filter) {
  .Defunct(
    new = "listFilterOptions",
    msg = "This function has been renamed listFilterOptions()"
  )
}

.biomaRt_user_agent <- function() {
  paste(
    "biomaRt R package (https://github.com/Huber-group-EMBL/biomaRt) version",
    utils::packageVersion("biomaRt")
  )
}

cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)
bfc <- BiocFileCache::BiocFileCache(biomartCacheInfo(), ask = FALSE)

http_config <- do.call(c, biomaRt:::.getEnsemblSSL())

ensembl <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  host = "www.ensembl.org",
  attributes = data.frame(
    name = c("chromosome_name", "ensembl_gene_id"),
    description = c("Chromosome/scaffold name", "Gene stable ID")
  ),
  filters = data.frame(
    name = c("affy_hg_u133a_2", "chromosome_name", "transcript_tsl"),
    description = c(
      "AFFY HG U133A 2 probe ID(s) [e.g. 211600_at]",
      "Chromosome/scaffold name",
      "Transcript Support Level (TSL)"
    ),
    type = c("id_list", "text", "boolean"),
    options = c("[]", "[1,2,3,4,CHR_HG1_PATCH]", "[only,excluded]")
  )
)

## create two test data.frames
bad_result <- data.frame(
  "Not a real column" = 1:2,
  "Ensembl Gene ID" = 3:4,
  check.names = FALSE
)
good_result <- data.frame(
  "Chromosome/scaffold name" = 1:2,
  "Gene stable ID" = 3:4,
  check.names = FALSE
)

test_that("Renaming columns - synthetic data", {
  ## this should warn that we can't match one of the column names (hopefully this never happens for real)
  expect_warning(
    .setResultColNames(
      result = bad_result,
      mart = ensembl,
      attributes = c("chromosome_name", "ensembl_gene_id")
    ),
    "Problems assigning column names"
  )
  ## check the reassignment of colnames from 'description' to 'name'
  expect_equal(
    colnames(.setResultColNames(
      result = good_result,
      mart = ensembl,
      attributes = c("chromosome_name", "ensembl_gene_id")
    )),
    c("chromosome_name", "ensembl_gene_id")
  )
  ## check we reorder them if needed
  expect_equal(
    colnames(.setResultColNames(
      result = good_result,
      mart = ensembl,
      attributes = c("ensembl_gene_id", "chromosome_name")
    )),
    c("ensembl_gene_id", "chromosome_name")
  )
})

example_return <- "GO term accession\tGene name\tGO domain\nGO:0004465\tLpl\tmolecular_function\nGO:0006631\tLpl\tbiological_process\nGO:0005509\tLpl\tmolecular_function\n"

test_that("Results processing works", {
  expect_s3_class(
    result_table <- .processResults(
      postRes = example_return,
      mart = ensembl,
      fullXmlQuery = "",
      numAttributes = 3
    ),
    "data.frame"
  )
  expect_identical(ncol(result_table), 3L)

  expect_error(.processResults(
    postRes = LETTERS,
    mart = ensembl,
    fullXmlQuery = "",
    numAttributes = 3
  ))
  expect_error(.processResults(
    postRes = example_return,
    mart = ensembl,
    fullXmlQuery = "",
    numAttributes = 1
  ))
  expect_error(.processResults(
    postRes = "Query ERROR",
    mart = ensembl,
    fullXmlQuery = "",
    numAttributes = 3
  ))
})


test_that("URL formatting works", {
  ## adding http if needed
  host <- "www.myurl.org"
  expect_equal(
    object = .cleanHostURL(host = host),
    expected = "http://www.myurl.org"
  )

  ## stripping trailing slash
  host <- "http://www.myurl.org/"
  expect_equal(
    object = .cleanHostURL(host = host),
    expected = "http://www.myurl.org"
  )

  ## leave https already there
  host <- "https://www.myurl.org"
  expect_equal(
    object = .cleanHostURL(host = host),
    expected = "https://www.myurl.org"
  )

  ## add https & 'www' to ensembl.org
  host <- "ensembl.org"
  expect_equal(
    object = .cleanHostURL(host = host),
    expected = "https://www.ensembl.org"
  )
})

test_that("TSV and HTML result tables match", {
  skip_if_not_installed("mockery")

  host <- "https://www.ensembl.org:443/biomart/martservice?redirect=no"
  query <- "<?xml version='1.0' encoding='UTF-8'?><!DOCTYPE Query>
            <Query virtualSchemaName='default' uniqueRows='1' count='0' datasetConfigVersion='0.6' header='1' requestid='biomaRt' formatter='TSV'>
            <Dataset name = 'hsapiens_gene_ensembl'><Attribute name = 'ensembl_gene_id'/>
            <Attribute name = 'hgnc_symbol'/>
            <Filter name = \"ensembl_gene_id\" value = \"ENSG00000100036\" />
            </Dataset></Query>"

  mockery::stub(
    where = .fetchHTMLresults,
    what = ".submitQueryXML",
    how = '<?xml version="1.0"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
  <title></title>
  <link rel="stylesheet" type="text/css" href="/martview/martview.css" />
</head>
<body>

<table>
<tr>
  <th>Gene stable ID</th>
  <th>HGNC symbol</th>
</tr>
<tr>
  <td><a href="http://www.ensembl.org/homo_sapiens/Gene/Summary?db=core;g=ENSG00000100036" target="_blank">ENSG00000100036</a></td>
  <td><a href="https://www.genenames.org/data/gene-symbol-report/#!/hgnc_id/HGNC:17058" target="_blank">SLC35E4</a></td>
</tr>

</table>
</body>
</html>'
  )

  expect_silent(
    res_html <- .fetchHTMLresults(host, query, http_config = http_config)
  )

  expect_identical(
    res_html,
    data.frame(
      "Gene stable ID" = "ENSG00000100036",
      "HGNC symbol" = "SLC35E4",
      check.names = FALSE
    )
  )
})


test_that("http error codes are presented nicely", {
  expect_true(grepl(
    .createErrorMessage(error_code = 500, host = "test.com"),
    pattern = "biomaRt has encountered an unexpected server error"
  ))
  expect_true(grepl(
    .createErrorMessage(error_code = 509, host = "test.com"),
    pattern = "biomaRt has exceeded the bandwidth allowance with this server"
  ))

  expect_true(grepl(
    .createErrorMessage(error_code = 500, host = "www.ensembl.org")[2],
    pattern = "Consider trying one of the Ensembl mirrors"
  ))
  expect_true(grepl(
    .createErrorMessage(error_code = 509, host = "www.ensembl.org")[2],
    pattern = "Consider trying one of the Ensembl mirrors"
  ))

  ## testing an un-seen error code
  expect_true(grepl(
    .createErrorMessage(error_code = 999, host = "www.ensembl.org")[2],
    pattern = "Consider trying one of the Ensembl mirrors"
  ))
})


test_that("we can search predefined filter values", {
  expect_equal(
    length(searchFilterOptions(ensembl, filter = "chromosome_name")),
    5
  )

  expect_equal(
    length(searchFilterOptions(ensembl, "chromosome_name", "^[0-9]*$")),
    4
  )

  expect_equal(
    searchFilterOptions(ensembl, "chromosome_name", "PATCH"),
    "CHR_HG1_PATCH"
  )
})


test_that("defunct functions show errors", {
  expect_error(searchFilterValues(ensembl, filter = "chromosome_name"))
  expect_error(listFilterValues(ensembl, filter = "chromosome_name"))
})

test_that("attribute and filter tables are parsed correctly", {
  skip_if_not_installed("mockery")

  mockery::stub(
    .getAttrFilt,
    "bmRequest",
    "ensembl_gene_id\tGene stable ID\tStable ID of the Gene\tfeature_page\thtml,txt,csv,tsv,xls\thsapiens_gene_ensembl__gene__main\tstable_id_1023\n",
  )
  expect_s3_class(
    .getAttrFilt(mart = ensembl, verbose = TRUE, type = "attributes"),
    "data.frame"
  )

  mockery::stub(
    .getAttributes,
    ".getAttrFilt",
    read.table(
      text = "ensembl_gene_id\tGene stable ID\tStable ID of the Gene\tfeature_page\n",
      sep = "\t",
      header = FALSE,
      quote = "",
      comment.char = "",
      as.is = TRUE
    )
  )
  expect_s3_class(.getAttributes(mart = ensembl, verbose = TRUE), "data.frame")

  mockery::stub(
    .getFilters,
    ".getAttrFilt",
    read.table(
      text = "chromosome_name\tChromosome/scaffold name\t[]\t\tfilters\ttext\t=\tbnatans_eg_gene__gene__main\tname_1059\n\n",
      sep = "\t",
      header = FALSE,
      quote = "",
      comment.char = "",
      as.is = TRUE
    )
  )
  expect_s3_class(.getFilters(mart = ensembl, verbose = TRUE), "data.frame")
})

ensembl <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  attributes = data.frame(
    name = c("chromosome_name", "ensembl_gene_id"),
    description = c("Chromosome/scaffold name", "Gene stable ID")
  ),
  filters = data.frame(
    name = c("affy_hg_u133a_2", "chromosome_name", "transcript_tsl"),
    description = c(
      "AFFY HG U133A 2 probe ID(s) [e.g. 211600_at]",
      "Chromosome/scaffold name",
      "Transcript Support Level (TSL)"
    ),
    type = c("id_list", "text", "boolean"),
    options = c("[]", "[1,2,3,4,CHR_HG1_PATCH]", "[only,excluded]")
  )
)

test_that("AnnotationDbi style interface works", {
  expect_identical(keytypes(ensembl), martFilters(ensembl)$name)

  expect_identical(columns(ensembl), martAttributes(ensembl)$name)

  expect_identical(
    keys(ensembl, "chromosome_name"),
    listFilterOptions(ensembl, filter = "chromosome_name")
  )
})

ensembl <- Mart(
  biomart = "ensembl",
  dataset = "hsapiens_gene_ensembl",
  attributes = data.frame(
    name = c("chromosome_name", "ensembl_gene_id"),
    description = c("Chromosome/scaffold name", "Gene stable ID")
  ),
  filters = data.frame(
    name = c("affy_hg_u133a_2", "chromosome_name", "transcript_tsl"),
    description = c(
      "AFFY HG U133A 2 probe ID(s) [e.g. 211600_at]",
      "Chromosome/scaffold name",
      "Transcript Support Level (TSL)"
    ),
    type = c("id_list", "text", "boolean")
  )
)

test_that("Filter generation works", {
  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = c("affy_hg_u133a_2", "chromosome_name"),
      values = list(affyid = c("1939_at", "1000_at"), chromosome = "16"),
      mart = ensembl
    )[[1]],
    "<Filter name = \"affy_hg_u133a_2\" value = \"1939_at,1000_at\" /><Filter name = \"chromosome_name\" value = \"16\" />"
  )

  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = "chromosome_name",
      values = "16",
      mart = ensembl
    )[[1]],
    "<Filter name = \"chromosome_name\" value = \"16\" />"
  )

  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = "chromosome_name",
      values = c("16", "18"),
      mart = ensembl
    )[[1]],
    "<Filter name = \"chromosome_name\" value = \"16,18\" />"
  )

  expect_equal(biomaRt:::.generateFilterXML(filters = ""), "")
})

test_that("Boolean filter handled correctly", {
  expect_error(
    biomaRt:::.generateFilterXML(
      filters = "transcript_tsl",
      values = "16",
      mart = ensembl
    ),
    "'transcript_tsl' is a boolean filter"
  )
  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = "transcript_tsl",
      values = TRUE,
      mart = ensembl
    )[[1]],
    "<Filter name = \"transcript_tsl\" excluded = \"0\" />"
  )
})

test_that("list is required for multiple filters", {
  expect_error(.generateFilterXML(
    filters = c("affy_hg_u133a_2", "chromosome_name"),
    values = c(affyid = c("1939_at", "1000_at"), chromosome = "16"),
    mart = ensembl
  )[[1]])
})

test_that("passing a single column data.frame works", {
  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = "chromosome_name",
      values = data.frame("chr" = c("16", "18")),
      mart = ensembl
    )[[1]],
    "<Filter name = \"chromosome_name\" value = \"16,18\" />"
  )
})

test_that("numeric values to filters work", {
  expect_equal(
    biomaRt:::.generateFilterXML(
      filters = "chromosome_name",
      values = c(16, 18),
      mart = ensembl
    )[[1]],
    "<Filter name = \"chromosome_name\" value = \"16,18\" />"
  )
})

# test_that("large numbers of values are split into chunks", {
#
#     for(max_size in c(2, 10, 50, 100, 200, 500)) {
#         expect_length(biomaRt:::.generateFilterXML(filters = 'start',
#                                  values = 1:500, maxChunkSize = max_size,
#                                  mart = ensembl),
#                       ceiling(500 / max_size))
#     }
# })

library(biomaRt)
cache <- file.path(tempdir(), "biomart_cache_test")
Sys.setenv(BIOMART_CACHE = cache)

# ensembl <- useEnsembl("ensembl", mirror = "www")
ensembl <- Mart(biomart = "ensembl")

example_datasets <- data.frame(
  dataset = paste0(LETTERS[1:5], "_gene_ensembl"),
  description = paste0(letters[1:5], " genes"),
  version = as.character(1:5)
)

## Construct example mart object without contacting Ensembl
ensembl_with_dataset <- Mart(
  biomart = "ensembl",
  dataset = "xtropicalis_gene_ensembl",
  attributes = data.frame(
    name = c("A", "B", "C"),
    description = c("AttrA", "AttrB", "AttrC"),
    page = "P1"
  ),
  filters = data.frame(
    name = c("X", "Y", "Z"),
    description = c("Filt_X", "Filt_Y", "Filt_Z")
  )
)

test_that("Fail with no mart argument", {
  expect_error(searchDatasets(), "Argument 'mart' must be specified")
  expect_error(searchAttributes(), "Argument 'mart' must be specified")
  expect_error(searchFilters(), "Argument 'mart' must be specified")
})

test_that("'Long' table of results for no search term", {
  skip_if_not_installed("mockery")
  mockery::stub(searchDatasets, "listDatasets", how = example_datasets)

  expect_s3_class(x <- searchDatasets(ensembl), class = "data.frame")
  expect_equal(nrow(x), 5)
  expect_identical(example_datasets, x)
})

test_that("Return complete table of results for no search term", {
  expect_s3_class(
    x <- searchAttributes(ensembl_with_dataset),
    class = "data.frame"
  )
  expect_identical(x, martAttributes(ensembl_with_dataset))

  expect_s3_class(
    x <- searchFilters(ensembl_with_dataset),
    class = "data.frame"
  )
  expect_identical(x, martFilters(ensembl_with_dataset))
})

test_that("Message when nothing found", {
  skip_if_not_installed("mockery")

  mockery::stub(searchDatasets, "listDatasets", how = example_datasets)
  searchDatasets(ensembl, pattern = "foobaa") |>
    expect_null() |>
    expect_message("No matching")

  searchAttributes(ensembl_with_dataset, pattern = "foobaa") |>
    expect_null() |>
    expect_message("No matching")

  searchFilters(ensembl_with_dataset, pattern = "foobaa") |>
    expect_null() |>
    expect_message("No matching")
})


test_that("'Sensible' table of results for specific search term", {
  skip_if_not_installed("mockery")

  mockery::stub(searchDatasets, "listDatasets", how = example_datasets)
  expect_s3_class(
    x <- searchDatasets(ensembl, pattern = "B_"),
    class = "data.frame"
  )
  expect_equal(nrow(x), 1) ## only one dataset should be found

  expect_s3_class(
    x <- searchAttributes(ensembl_with_dataset, pattern = "Attr(A|B)"),
    class = "data.frame"
  )
  expect_equal(nrow(x), 2)

  expect_s3_class(
    x <- searchFilters(ensembl_with_dataset, pattern = "Filt_Z"),
    class = "data.frame"
  )
  expect_equal(nrow(x), 1)
})

## The Ensembl BioMart isn't always fit for purpose, and some operations can also be achieved using the
## Ensembl REST API.  This file contains some functions that may be useful to biomaRt users,
## but which don't actually interact with BioMart.

createNameToAliasMap <- function() {
  url <- "https://rest.ensembl.org/info/species?"

  req <- httr2::request(url) |>
    httr2::req_user_agent(
      .biomaRt_user_agent()
    ) |>
    httr2::req_headers("Accept" = "application/json")
  json <- httr2::req_perform(req) |>
    httr2::resp_body_json()

  names <- vapply(
    json$species,
    FUN = \(x) {
      x$name
    },
    FUN.VALUE = character(1)
  )

  aliases <- lapply(json$species, FUN = \(x) {
    all <- c(x$display_name, unlist(x$aliases), x$common_name)
    return(unique(tolower(all)))
  })

  names(aliases) <- names
  return(aliases)
}

#' @importFrom httr2 req_perform resp_body_json
pickReferenceStrain <- function(genomes_to_choose_from) {
  url <- "https://rest.ensembl.org/info/species?"

  req <- httr2::request(url) |>
    httr2::req_user_agent(
      .biomaRt_user_agent()
    ) |>
    httr2::req_headers("Accept" = "application/json")
  json <- req_perform(req) |>
    resp_body_json()

  names <- vapply(
    json$species,
    FUN = \(x) {
      x$name
    },
    FUN.VALUE = character(1)
  )

  idx <- which(names %in% genomes_to_choose_from)

  strains <- vapply(
    json$species[idx],
    FUN = \(x) {
      unique(tolower(x$strain))
    },
    FUN.VALUE = character(1)
  )

  idx2 <- which(strains == "reference")
  if (length(idx2) == 0) {
    idx2 <- grep(pattern = "reference", x = strains, fixed = TRUE)
  }

  if (length(idx2) != 1) {
    stop("unable to determine reference strain")
  }

  return(names[idx][idx2])
}

pickReferenceStrain_msg <- function(input_term) {
  message(
    "Your search term was ambiguous and multiple strains matching '",
    input_term,
    "' were found.\n",
    "Selecting the reference genome for this organism.\n",
    "Use a more specific search term if this is inappropriate."
  )
}

## Given an input string, try to identify the genome name for the organism
findGenomeName <- function(input) {
  input <- tolower(input)
  aliases <- createNameToAliasMap()

  if (input %in% names(aliases)) {
    return(input)
  }

  search <- vapply(
    aliases,
    FUN = \(x, input) {
      any(grepl(pattern = input, x = x))
    },
    input = paste0("^", input, "$"),
    FUN.VALUE = logical(1)
  )

  if (!any(search)) {
    stop("Unable to match the search term to a genome")
  }

  if (sum(search) == 1) {
    res <- names(aliases)[which(search)]
  } else {
    res <- pickReferenceStrain(
      genomes_to_choose_from = names(aliases)[which(search)]
    )
    pickReferenceStrain_msg(input)
  }
  return(res)
}

## use the Ensembl Rest API to get the current Ensembl version
getCurrentEnsemblRelease <- function() {
  req <- httr2::request("https://rest.ensembl.org/info/data/") |>
    httr2::req_user_agent(
      .biomaRt_user_agent()
    ) |>
    httr2::req_headers("Accept" = "application/json")

  version <- req |>
    httr2::req_perform() |>
    httr2::resp_body_json() |>
    unlist() |>
    as.integer()

  return(version)
}

## list files in Ensembl FTP TSV directory
## this is used to identify if there is an ensembl<->entrez mapping file
listFilesInEnsemblFTP <- function(species, release, dir) {
  ftp_dir <- sprintf(
    "ftp://ftp.ensembl.org/pub/release-%s/%s/%s/",
    release,
    dir,
    species
  )

  list_files <- curl::new_handle() |>
    curl::handle_setheaders(useragent = .biomaRt_user_agent()) |>
    curl::handle_setopt(ftp_use_epsv = TRUE, dirlistonly = TRUE)
  con <- curl::curl(url = ftp_dir, open = "r", handle = list_files)
  files <- readLines(con)
  close(con)

  return(files)
}

## helper to make sure that we *have* entrez gene IDs to map to at ensembl!
.ensemblMapsToEntrezId <- function(species, release = NULL) {
  files <- listFilesInEnsemblFTP(
    species = species,
    release = release,
    dir = "tsv"
  )
  res <- any(grepl("entrez.tsv.gz$", files))
  return(res)
}

#' @importFrom utils head tail
.shrinkDatasetName <- function(input) {
  parts <- stringr::str_split_fixed(input, pattern = "_", n = Inf)[1, ]
  short <- paste(stringr::str_sub(head(parts, -1), 1, 1), collapse = "")
  final <- paste0(short, tail(parts, 1))
  return(final)
}


#' List homologous genes between two species.
#'
#' This function simplifies the querying of the Ensembl BioMart if you're
#' trying to return the homologs for one or more gene IDs between two species.
#'
#'
#' @param ensembl_gene_ids Character vector.  This contains the Ensembl Gene
#' IDs that you want to find the homologs for.
#' @param species_from,species_to Character vectors of length 1.  These
#' arguments specify the species the input IDs belong to (`species_from`)
#' and the species you want to find the homologs in (`species_to`).  These
#' can be Ensembl genomes names e.g. "homo_sapiens" or "canis_lupus_familiaris"
#' or common names e.g. "human" or "dog".  The function will do it's best to
#' parse common names, and will report and error if no match to an Ensembl
#' genome can be made.
#' @author Mike Smith
#' @export getHomologs
#'
#' @concept non-biomart
getHomologs <- function(ensembl_gene_ids, species_from, species_to) {
  from <- findGenomeName(species_from)
  to <- findGenomeName(species_to)

  dataset_from <- paste0(
    .shrinkDatasetName(from),
    "_gene_ensembl"
  )

  homolog_attribute <- paste0(
    .shrinkDatasetName(to),
    "_homolog_ensembl_gene"
  )

  mart <- useEnsembl(biomart = "genes", dataset = dataset_from)

  q1 <- getBM(
    attributes = c("ensembl_gene_id", homolog_attribute),
    mart = mart,
    values = ensembl_gene_ids,
    filters = "ensembl_gene_id"
  )
  q1
}

.getEnsemblSSL <- function() {
  cache <- .biomartCacheLocation()
  bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)
  if (.checkInCache(bfc, hash = "ensembl-ssl-settings-httr2")) {
    return(.readFromCache(bfc, "ensembl-ssl-settings-httr2"))
  }
  return(list())
}

#' Save system specific SSL settings for contacting Ensembl
#'
#' On some systems specific SSL settings have to be applied to allow https
#' connections to the Ensembl servers.  This function allows these to be saved
#' in the biomaRt cache, so they will be retrieved each time they are needed.
#' biomaRt will try to determine them automatically, but this function can be
#' used to set them manually if required.
#'
#'
#' @param settings A named list. Each entry should be a valid curl option, as
#' found in [curl::curl_options()].
#' @author Mike Smith
#'
#' @examples
#' \dontrun{
#' ssl_settings <- list(
#'   "ssl_cipher_list" = "DEFAULT@SECLEVEL=1",
#'   "ssl_verifypeer"  = FALSE
#' )
#' setEnsemblSSL(ssl_settings)
#' }
#'
#' @importFrom utils modifyList
#' @export
setEnsemblSSL <- function(settings) {
  stopifnot(is.list(settings))

  cache <- .biomartCacheLocation()
  bfc <- BiocFileCache::BiocFileCache(cache, ask = FALSE)

  existing_config <- .getEnsemblSSL()

  if (length(settings) == 0L) {
    updated_config <- list()
  } else {
    updated_config <- modifyList(existing_config, settings)
  }

  .addToCache(
    bfc,
    updated_config,
    hash = "ensembl-ssl-settings-httr2",
    update = TRUE
  )
  return(invisible(TRUE))
}

%\VignetteIndexEntry{The biomaRt users guide}
%\VignetteDepends{biomaRt}
%\VignetteKeywords{Annotation}
%\VignettePackage{biomaRt}
\documentclass[11pt]{article}
\usepackage{hyperref}
\usepackage{url}
\usepackage[authoryear,round]{natbib}
\bibliographystyle{plainnat}

\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}

\author{Steffen Durinck\footnote{steffen@stat.berkeley.edu}, Wolfgang Huber\footnote{huber@ebi.ac.uk}}
\begin{document}
\title{The biomaRt user's guide}

\maketitle

\tableofcontents
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Introduction}

In recent years a wealth of biological data has become available in public data repositories. Easy access to these valuable data resources and firm integration with data analysis is needed for comprehensive bioinformatics data analysis.  The \Rpackage{biomaRt} package,  provides an interface to a growing collection of databases implementing the BioMart software suite (\url{http://www.biomart.org}). The package enables retrieval of large amounts of data in a uniform way without the need to know the underlying database schemas or write complex SQL queries. Examples of BioMart databases are Ensembl, Uniprot and HapMap. These major databases give biomaRt users direct access to a diverse set of data and enable a wide range of powerful online queries from R.

\section{Selecting a BioMart database and dataset}

Every analysis with \Rpackage{biomaRt} starts with selecting a BioMart database to use.  A first step is to check which BioMart web services are available.  The function \Rfunction{listMarts} will display all available BioMart web services   

<<annotate,echo=FALSE>>=
## library("annotate")
options(width=120)
@

\begin{scriptsize}
<<biomaRt>>=
library("biomaRt")
listMarts()
@
\end{scriptsize}

Note: if the function \Rfunction{useMart} runs into proxy problems you should set your proxy first before calling any biomaRt functions.  
You can do this using the Sys.putenv command:

\begin{verbatim}
Sys.putenv("http\_proxy" = "http://my.proxy.org:9999")
\end{verbatim}

The \Rfunction{useMart} function can now be used to connect to a specified BioMart database, this must be a valid name given by \Rfunction{listMarts}. In the next example we choose to query the Ensembl BioMart database.

<<ensembl1>>=
ensembl=useMart("ensembl")
@

BioMart databases can contain several datasets, for Ensembl every species is a different dataset.  In a next step we look at which datasets are available in the selected BioMart by using the function \Rfunction{listDatasets}.

\begin{scriptsize}
<<listDatasets>>=
listDatasets(ensembl)
@
\end{scriptsize}

To select a dataset we can update the \Robject{Mart} object using the function \Rfunction{useDataset}.  In the example below we choose to use the hsapiens dataset.

\begin{verbatim}
ensembl = useDataset("hsapiens_gene_ensembl",mart=ensembl)
\end{verbatim}

Or alternatively if the dataset one wants to use is known in advance, we can select a BioMart database and dataset in one step by:

<<ensembl2>>=
ensembl = useMart("ensembl",dataset="hsapiens_gene_ensembl")
@

\section{How to build a biomaRt query}

The \Rfunction{getBM} function has three arguments that need to be introduced: filters, attributes and values.
\textit{Filters} define a restriction on the query.  For example you want to restrict the output to all genes located on the human X chromosome then the filter \textit{chromosome\_name} can be used with value 'X'. The \Rfunction{listFilters} function shows you all available filters in the selected dataset.\\

<<filters>>=
filters = listFilters(ensembl)
filters[1:5,]
@ 

\textit{Attributes} define the values we are interested in to retrieve.  For example we want to retrieve the gene symbols or chromosomal coordinates.  The listAttributes function displays all available attributes in the selected dataset.\\

<<attributes>>=
attributes = listAttributes(ensembl)
attributes[1:5,]
@

The \Rfunction{getBM} function is the main query function in biomaRt.  It has four main arguments:\\
\begin{itemize}
\item attributes:  is a vector of attributes that one wants to retrieve (= the output of the query).
\item filters:  is a vector of filters that one wil use as input to the query.
\item values: a vector of values for the filters.  In case multple filters are in use, the values argument requires a list of values where each position in the list corresponds to the position of the filters in the filters argument (see examples below).
\item mart: is and object of class \Robject{Mart}, which is created by the \Rfunction{useMart} function.
\end{itemize}

Note: for some frequently used queries to Ensembl, wrapper 
functions are available: \Rfunction{getGene} and \Rfunction{getSequence}.  
These functions call the \Rfunction{getBM} function with hard coded 
filter and attribute names.

Now that we selected a BioMart database and dataset, and know about attributes, filters, and the values for filters; we can build a biomaRt query.  Let's make an easy query for the following problem:  We have a list of Affymetrix identifiers from the u133plus2 platform and we want to retrieve the corresponding EntrezGene identifiers using the Ensembl mappings.

The u133plus2 platform will be the filter for this query and as values for this filter we use our list of Affymetrix identifiers.  As output (attributes) for the query we want to retrieve the EntrezGene and u133plus2 identifiers so we get a mapping of these two identifiers as a result.  The exact names that we will have to use to specify the attributes and filters can be retrieved with the \Rfunction{listAttributes} and \Rfunction{listFilters} function respectively.  Let's now run the query:

\begin{scriptsize}
<<echo=TRUE,eval=FALSE>>=
affyids=c("202763_at","209310_s_at","207500_at")
getBM(attributes=c('affy_hg_u133_plus_2', 'entrezgene'), filters = 'affy_hg_u133_plus_2', values = affyids, mart = ensembl)
@  
\begin{verbatim}
  affy_hg_u133_plus_2 entrezgene
1         209310_s_at        837
2           207500_at        838
3           202763_at        836
\end{verbatim}
\end{scriptsize}

\section{Examples of biomaRt queries}

In the sections below a variety of example queries are described.  Every example is written as a task, and we have to come up with a biomaRt solution to the problem.

\subsection{Task 1:  Annotate a set of Affymetrix identifiers with HUGO symbol and chromosomal locations of corresponding genes}

We have a list of Affymetrix hgu133plus2 identifiers and we would like to retrieve the HUGO gene symbols, chromosome names, start and end positions and the bands of the corresponding genes.  The \Rfunction{listAttributes} and the \Rfunction{listFilters} functions give us an overview of the available attributes and filters and we look in those lists to find the corresponding attribute and filter names we need.  For this query we'll need the following attributes: hgnc\_symbol, chromsome\_name, start\_position, end\_position, band and affy\_hg\_u133\_plus\_2 (as we want these in the output to provide a mapping with our original Affymetrix input identifiers.  There is one filter in this query which is the affy\_hg\_u133\_plus\_2 filter as we use a list of Affymetrix identifiers as input.  Putting this all together in the \Rfunction{getBM} and performing the query gives: 
\begin{scriptsize}
<<echo=TRUE,eval=FALSE>>=
affyids=c("202763_at","209310_s_at","207500_at")
getBM(attributes=c('affy_hg_u133_plus_2', 'hgnc_symbol', 'chromosome_name','start_position','end_position', 'band'),
 filters = 'affy_hg_u133_plus_2', values = affyids, mart = ensembl)
@ 
\begin{verbatim}
  affy_hg_u133_plus_2 hgnc_symbol chromosome_name start_position end_position  band
1         209310_s_at       CASP4              11      104813593    104840163 q22.3
2           207500_at       CASP5              11      104864962    104893895 q22.3
3           202763_at       CASP3               4      185548850    185570663 q35.1
\end{verbatim}
\end{scriptsize}

\subsection{Task 2:  Annotate a set of EntrezGene identifiers with GO annotation}

In this task we start out with a list of EntrezGene identiers and we want to retrieve GO identifiers related to biological processes that are associated with these entrezgene identifiers.  Again we look at the output of \Rfunction{listAttributes} and \Rfunction{listFilters}  to find the filter and attributes we need.  Then we construct the following query:

\begin{scriptsize}
<<echo=TRUE,eval=FALSE>>=
entrez=c("673","837")
goids = getBM(attributes=c('entrezgene','go_id'), filters='entrezgene', values=entrez, mart=ensembl)
head(goids)
@ 
\begin{verbatim}  
   entrezgene      go_id
1         673 GO:0000186
2         673 GO:0006468
3         673 GO:0006916
4         673 GO:0007264
5         673 GO:0007268

\end{verbatim}
\end{scriptsize}


\subsection{Task 3: Retrieve all HUGO gene symbols of genes that are located on chromosomes 1,2 or Y ,\\ and are associated with one the following GO terms: \\"GO:0051330","GO:0000080","GO:0000114","GO:0000082"\\ (here we'll use more than one filter)}
The \Rfunction{getBM} function enables you to use more than one filter.  In this case  the filter argument should be a vector with the filter names.  The values should be a list, where the first element of the list corresponds to the first filter and the second list element to the second filter and so on.  The elements of this list are vectors containing the possible values for the corresponding filters.
\begin{small}
\begin{verbatim}
 go=c("GO:0051330","GO:0000080","GO:0000114"chrom=c(1,2,"Y")
 getBM(attributes= "hgnc_symbol",
        filters=c("go","chromosome_name"),
        values=list(go,chrom), mart=ensembl)
\end{verbatim}
\end{small}
\begin{scriptsize}
\begin{verbatim}
  hgnc_symbol
1      PPP1CB
2       SPDYA
3       ACVR1
4        CUL3
5        RCC1
6        CDC7
7        RHOU
\end{verbatim}
\end{scriptsize}
\subsection{Task 4:  Annotate set of idenfiers with INTERPRO protein domain identifiers}

In this example we want to annotate the following two RefSeq identifiers: NM\_005359 and NM\_000546 with INTERPRO protein domain identifiers and a description of the protein domains.

<<echo=TRUE,eval=FALSE>>=
refseqids = c("NM_005359","NM_000546")
ipro = getBM(attributes=c("refseq_dna","interpro","interpro_description"), filters="refseq_dna",values=refseqids, mart=ensembl)
@

\begin{scriptsize}
\begin{verbatim}
ipro
  refseq_dna  interpro             interpro_description
1  NM_000546 IPR002117                p53 tumor antigen
2  NM_000546 IPR010991             p53, tetramerisation
3  NM_000546 IPR011615                 p53, DNA-binding
4  NM_000546 IPR013872 p53 transactivation domain (TAD)
5  NM_000546 IPR000694              Proline-rich region
6  NM_005359 IPR001132     MAD homology 2, Dwarfin-type
7  NM_005359 IPR003619     MAD homology 1, Dwarfin-type
8  NM_005359 IPR013019                MAD homology, MH1
\end{verbatim}
\end{scriptsize}

\subsection{Task 5: Select all Affymetrix identifiers on the hgu133plus2 chip and Ensembl gene identifiers for genes located on chromosome 16 between basepair 1100000 and 1250000.}

In this example we will again use multiple filters: chromosome\_name, start, and end as we filter on these three conditions. Note that when a chromosome name, a start position and an end position are jointly used as filters, the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions.
\begin{scriptsize}
<<>>=
getBM(c('affy_hg_u133_plus_2','ensembl_gene_id'), filters = c('chromosome_name','start','end'),
 values=list(16,1100000,1250000), mart=ensembl)
@
\end{scriptsize}
 
\subsection{Task 6: Retrieve all entrezgene identifiers and HUGO gene symbols of genes which have a "MAP kinase activity" GO term associated with it.}
The GO identifier for MAP kinase activity is GO:0004707.  In our query we will use go as filter and entrezgene and hgnc\_symbol as attributes.  Here's the query:
\begin{scriptsize}
<<echo=TRUE, eval = FALSE>>=
getBM(c('entrezgene','hgnc_symbol'), filters='go', values='GO:0004707', mart=ensembl)
@
\begin{verbatim} 
   entrezgene hgnc_symbol
1        5601       MAPK9
2      225689      MAPK15
3        5599       MAPK8
4        5594       MAPK1
5        6300      MAPK12
\end{verbatim} 
\end{scriptsize}

\subsection{Task 7:  Given a set of EntrezGene identifiers, retrieve 100bp upstream promoter sequences}
 
All sequence related queries to Ensembl are available through the \Rfunction{getSequence} wrapper function. \Rfunction{getBM} can also be used directly to retrieve sequences but this can get complicated so using getSequence is recommended.
Sequences can be retrieved using the \Rfunction{getSequence} function either starting from chromosomal coordinates or identifiers.  The chromosome name can be specified using the \textit{chromosome} argument.  The \textit{start} and \textit{end} arguments are used to specify \textit{start} and \textit{end} positions on the chromosome. The type of sequence returned can be specified by the seqType argument which takes the following values: 'cdna';'peptide' for protein sequences;'3utr' for 3' UTR sequences,'5utr' for 5' UTR sequences; 'gene\_exon' for exon sequences only; 'transcript\_exon' for transcript specific exonic sequences only;'transcript\_exon\_intron' gives the full unspliced transcript, that is exons + introns;'gene\_exon\_intron' gives the exons + introns of a gene;'coding' gives the coding sequence only;'coding\_transcript\_flank' gives the flanking region of the transcript including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute;'coding\_gene\_flank' gives the flanking region of the gene including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute; 'transcript\_flank' gives the flanking region of the transcript exculding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute; 'gene\_flank' gives the flanking region of the gene excluding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute.\\
In MySQL mode the \Rfunction{getSequence} function is more limited and the sequence that is returned is the 5' to 3'+ strand of the genomic sequence, given a chromosome, as start and an end position.\\

Task 4 requires us to retrieve 100bp upstream promoter sequences from a set of EntrzGene identifiers.  The type argument in getSequence can be thought of as the filter in this query and uses the same input names given by \Rfunction{listFilters}. in our query we use entrezgene for the type argument.  Next we have to specify which type of sequences we want to retrieve, here we are interested in the sequences of the promoter region, starting right next to the coding start of the gene.  Setting the seqType to coding\_gene\_flank will give us what we need.  The upstream argument is used to specify how many bp of upstream sequence we want to retrieve, here we'll retrieve a rather short sequence of 100bp.  Putting this all together in getSequence gives:\\

\begin{scriptsize}
<<eval=FALSE>>=
entrez=c("673","7157","837")
getSequence(id = entrez, type="entrezgene",seqType="coding_gene_flank",upstream=100, mart=ensembl) 
@ 
\end{scriptsize}

\subsection{Task 8: Retrieve all 5' UTR sequences of all genes that are located on chromosome 3 between the positions 185514033 and 185535839}

As described in the provious task getSequence can also use chromosomal coordinates to retrieve sequences of all genes that lie in the given region. We also have to specify which type of identifier we want to retrieve together with the sequences, here we choose for entrezgene identifiers.
\begin{scriptsize}
<<echo=TRUE,eval=FALSE>>=
utr5 = getSequence(chromosome=3, start=185514033, end=185535839,
                      type="entrezgene",seqType="5utr", mart=ensembl)
utr5
@ 

\end{scriptsize}
\begin{scriptsize}
\begin{verbatim}
          V1               V2
  .....GAAGCGGTGGC ....   1981
\end{verbatim}
\end{scriptsize}

\subsection{Task 9:  Retrieve protein sequences for a given list of EntrezGene identifiers}

In this task the type argument specifies which type of identifiers we are using.
To get an overview of other valid identifier types we refer to the \Rfunction{listFilters} function.

\begin{scriptsize}
<<echo=TRUE, eval=FALSE>>=
protein = getSequence(id=c(100, 5728),type="entrezgene",
                        seqType="peptide", mart=ensembl)
protein
@ 
\end{scriptsize}
\begin{scriptsize}
\begin{verbatim}
 peptide               entrezgene
 MAQTPAFDKPKVEL ...    100
 MTAIIKEIVSRNKRR ...   5728

\end{verbatim}
\end{scriptsize}


\subsection{Task 10:  Retrieve known SNPs located on the human chromosome 8 between positions 148350 and 148612}

For this example we'll first have to connect to a different BioMart database, namely snp.  
<<echo=TRUE, eval=FALSE>>=
snpmart = useMart("snp", dataset="hsapiens_snp")
@ 

The \Rfunction{listAttributes} and \Rfunction{listFilters} functions give us an overview of the available attributes and filters.  
From these we need: refsnp\_id, allele, chrom\_start and chrom\_strand as attributes; and as filters we'll use: chrom\_start, chrom\_end and chr\_name.  Note that when a chromosome name, a start position and an end position are jointly used as filters, the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions. Putting our selected attributes and filters into getBM gives:

\begin{scriptsize}
<<eval=FALSE, echo=TRUE>>=
getBM(c('refsnp_id','allele','chrom_start','chrom_strand'), filters = c('chr_name','chrom_start','chrom_end'), values = list(8,148350,148612), mart = snpmart)
@ 
\end{scriptsize}
\begin{scriptsize}
\begin{verbatim}
   refsnp_id allele chrom_start chrom_strand
1   rs1134195    G/T      148394           -1
2   rs4046274    C/A      148394            1
3   rs4046275    A/G      148411            1
4     rs13291    C/T      148462            1
5   rs1134192    G/A      148462           -1
6   rs4046276    C/T      148462            1
7  rs12019378    T/G      148471            1
8   rs1134191    C/T      148499           -1
9   rs4046277    G/A      148499            1
10 rs11136408    G/A      148525            1
11  rs1134190    C/T      148533           -1
12  rs4046278    G/A      148533            1
13  rs1134189    G/A      148535           -1
14  rs3965587    C/T      148535            1
15  rs1134187    G/A      148539           -1
16  rs1134186    T/C      148569            1
17  rs4378731    G/A      148601            1
\end{verbatim}
\end{scriptsize}


\subsection{Task 11:  Given the human gene TP53, retrieve the human chromosomal location of this gene and also retrieve the chromosomal location and RefSeq id of it's homolog in mouse. }

The \Rfunction{getLDS} (Get Linked Dataset) function provides functionality to link 2 BioMart datasets which each other and construct a query over the two datasets.  In Ensembl, linking two datasets translates to retrieving homology data across species.
The usage of getLDS is very similar to \Rfunction{getBM}.  The linked dataset is provided by a separate \Robject{Mart} object and one has to specify filters and attributes for the linked dataset.  Filters can either be applied to both datasets or to one of the datasets.  Use the listFilters and listAttributes functions on both \Robject{Mart} objects to find the filters and attributes for each dataset (species in Ensembl).  The attributes and filters of the linked dataset can be specified with the attributesL and filtersL arguments.   Entering all this information into \Rfunction{getLDS} gives:
\begin{scriptsize}
\begin{verbatim}
human = useMart("ensembl", dataset = "hsapiens_gene_ensembl")
mouse = useMart("ensembl", dataset = "mmusculus_gene_ensembl")
getLDS(attributes = c("hgnc_symbol","chromosome_name", "start_position"),
       filters = "hgnc_symbol", values = "TP53",mart = human,
      attributesL = c("refseq_dna","chromosome_name","start_position"), martL = mouse)

    V1 V2      V3        V4 V5       V6
1 TP53 17 7512464 NM_011640 11 69396600
\end{verbatim}
\end{scriptsize}

\section{Using archived versions of Ensembl}

It is possible to query archived versions of Ensembl through \Rpackage{biomaRt}.
There are currently two ways to access archived versions.

\subsection{Using the archive=TRUE }
First we list the available Ensembl archives by using the \Rfunction{listMarts} function and setting the archive attribute to TRUE.
Note that not all archives are available this way and it seems that recently this only gives access to few archives if you don't see the version of the archive you need please look at the 2nd way to access archives.
\begin{scriptsize}
<<>>=
listMarts(archive=TRUE)
@ 
\end{scriptsize}
Next we select the archive we want to use using the \Rfunction{useMart} function, again setting the archive attribute to TRUE and giving the full name of the BioMart e.g. ensembl\_mart\_46.

<<echo = TRUE, eval = FALSE>>=
ensembl = useMart("ensembl_mart_46", dataset="hsapiens_gene_ensembl", archive = TRUE)
@ 

If you don't know the dataset you want to use could first connect to the BioMart using \Rfunction{useMart} and then use the \Rfunction{listDatasets} function on this object.
After you selected the BioMart database and dataset, queries can be performed in the same way as when using the current BioMart versions.

\subsection{Accessing archives through specifying the archive host}

Use the \url{http://www.ensembl.org} website and go down the bottom of the page.  Click on 'view in Archive' and select the archive you need.  Copy the url and use that url as shown below to connect to the specified BioMart database.  The example below shows how to query Ensembl 54. 

\begin{scriptsize}
<<<echo = TRUE, eval = FALSE>>=
listMarts(host='may2009.archive.ensembl.org')
ensembl54=useMart(host='may2009.archive.ensembl.org', biomart='ENSEMBL_MART_ENSEMBL')
ensembl54=useMart(host='may2009.archive.ensembl.org', biomart='ENSEMBL_MART_ENSEMBL', dataset='hsapiens_gene_ensembl')
@
\end{scriptsize}

\section{Using a BioMart other than Ensembl}

To demonstrate the use of the biomaRt package with non-Ensembl databases the next query is performed using the Wormbase BioMart (WormMart).
We connect to Wormbase, select the gene dataset to use and have a look at the available attributes and filters.  Then we use a list of gene names as filter and retrieve associated RNAi identifiers together with a description of the RNAi phenotype.
\begin{scriptsize}
<<echo=TRUE, eval=FALSE>>=
wormbase=useMart("wormbase_current",dataset="wormbase_gene")
listFilters(wormbase)
listAttributes(wormbase)
getBM(attributes=c("name","rnai","rnai_phenotype","phenotype_desc"),
                     filters="gene_name", values=c("unc-26","his-33"),
                     mart=wormbase)
     
@
\end{scriptsize}
\begin{scriptsize}
\begin{verbatim}
     name  rnai               rnai_phenotype                                     phenotype_desc

1  his-33 WBRNAi00000104   Emb | Nmo         embryonic lethal | Nuclear morphology alteration in early embryo
2  his-33 WBRNAi00012233   WT                                             wild type morphology
3  his-33 WBRNAi00024356   Ste                                                          sterile
4  his-33 WBRNAi00025036   Emb                                                 embryonic lethal
5  his-33 WBRNAi00025128   Emb                                                 embryonic lethal
6  his-33 WBRNAi00025393   Emb                                                 embryonic lethal
7  his-33 WBRNAi00025515   Emb | Lva | Unc                 embryonic lethal | larval arrest | uncoordinated
8  his-33 WBRNAi00025632   Gro | Ste                                            slow growth | sterile
9  his-33 WBRNAi00025686   Gro | Ste                                            slow growth | sterile
10 his-33 WBRNAi00025785   Gro | Ste                                            slow growth | sterile
11 his-33 WBRNAi00026259   Emb | Gro | Unc                   embryonic lethal | slow growth | uncoordinated
12 his-33 WBRNAi00026375   Emb                                                 embryonic lethal
13 his-33 WBRNAi00026376   Emb                                                 embryonic lethal
14 his-33 WBRNAi00027053   Emb | Unc                                 embryonic lethal | uncoordinated
15 his-33 WBRNAi00030041   WT                                             wild type morphology
16 his-33 WBRNAi00031078   Emb                                                 embryonic lethal
17 his-33 WBRNAi00032317   Emb                                                 embryonic lethal
18 his-33 WBRNAi00032894   Emb                                                 embryonic lethal
19 his-33 WBRNAi00033648   Emb                                                 embryonic lethal
20 his-33 WBRNAi00035430   Emb                                                 embryonic lethal
21 his-33 WBRNAi00035860   Egl | Emb                             egg laying defect | embryonic lethal
22 his-33 WBRNAi00048335   Emb | Sister Chromatid Separation abnormal (Cross-eyed)   embryonic lethal |
23 his-33 WBRNAi00049266   Emb | Sister Chromatid Separation abnormal (Cross-eyed)     embryonic lethal |
24 his-33 WBRNAi00053026   Emb | Sister Chromatid Separation abnormal (Cross-eyed)     embryonic lethal |
25 unc-26 WBRNAi00021278   WT                                             wild type morphology
26 unc-26 WBRNAi00026915   WT                                             wild type morphology
27 unc-26 WBRNAi00026916   WT                                             wild type morphology
28 unc-26 WBRNAi00027544   Unc                                                    uncoordinated
29 unc-26 WBRNAi00049565   WT                                             wild type morphology
30 unc-26 WBRNAi00049566   WT                                             wild type morphology
\end{verbatim}
\end{scriptsize}

\section{biomaRt helper functions}

This section describes a set of biomaRt helper functions that can be used to export FASTA format sequences, retrieve values for certain filters and exploring the available filters and attributes in a more systematic manner. 
\subsection{exportFASTA}

The data.frames obtained by the getSequence function can be exported to FASTA files using the \Rfunction{exportFASTA} function.  One has to specify the data.frame to export and the filename using the file argument.

\subsection{Finding out more information on filters}

\subsubsection{filterType}

Boolean filters need a value TRUE or FALSE in biomaRt.  Setting the value TRUE will include all information that fulfill the filter requirement.  Setting FALSE will exclude the information that fulfills the filter requirement and will return all values that don't fulfill the filter.
For most of the filters, their name indicates if the type is a boolean or not and they will usually start with "with".  However this is not a rule and to make sure you got the type right you can use the function \Rfunction{filterType} to investigate the type of the filter you want to use.

\begin{small}
<<>>=
filterType("with_affy_hg_u133_plus_2",ensembl)
@
\end{small}

\subsubsection{filterOptions}

Some filters have a limited set of values that can be given to them.  To know which values these are one can use the \Rfunction{filterOptions} function to retrieve the predetermed values of the respective filter.

\begin{small}
<<>>=
filterOptions("biotype",ensembl)
@

\end{small}

If there are no predetermed values e.g. for the entrezgene filter, then \Rfunction{filterOptions} will return the type of filter it is. And most of the times the filter name or it's description will suggest what values one case use for the respective filter (e.g. entrezgene filter will work with enterzgene identifiers as values)


\subsection{Attribute Pages}

For large BioMart databases such as Ensembl, the number of attributes displayed by the \Rfunction{listAttributes} function can be very large. 
In BioMart databases, attributes are put together in pages, such as sequences, features, homologs for Ensembl.
An overview of the attributes pages present in the respective BioMart dataset can be obtained with the \Rfunction{attributePages} function.

\begin{small}
<<>>=
pages = attributePages(ensembl)
pages
@
\end{small}

To show us a smaller list of attributes which belog to a specific page, we can now specify this in the \Rfunction{listAttributes} function as follows:

\begin{small}
<<>>=
listAttributes(ensembl, page="feature_page")
@
\end{small}

We now get a short list of attributes related to the region where the genes are located.


\section{Local BioMart databases}

The biomaRt package can be used with a local install of a public BioMart database or a locally developed BioMart database and web service.
In order for biomaRt to recognize the database as a BioMart, make sure that the local database you create has a name conform with \begin{verbatim} database_mart_version \end{verbatim} where database is the name of the database and version is a version number.  No more underscores than the ones showed should be present in this name. A possible name is for example \begin{verbatim} ensemblLocal_mart_46 \end{verbatim}.
\subsection{Minimum requirements for local database installation}
More information on installing a local copy of a BioMart database or develop your own BioMart database and webservice can be found on \url{http://www.biomart.org}
Once the local database is installed you can use biomaRt on this database by:
\begin{scriptsize}
\begin{verbatim}
listMarts(host="www.myLocalHost.org", path="/myPathToWebservice/martservice")
mart=useMart("nameOfMyMart",dataset="nameOfMyDataset",host="www.myLocalHost.org", path="/myPathToWebservice/martservice")
\end{verbatim}
\end{scriptsize}

For more information on how to install a public BioMart database see:  http://www.biomart.org/install.html and follow link databases.
\section{Session Info}
<<>>=
sessionInfo()
warnings()
@
\end{document}

---
title: "The biomaRt users guide"
author: "Steffen Durinck, Wolfgang Huber, Mike Smith"
package: "`r pkg_ver('biomaRt')`"
output: 
  BiocStyle::html_document:
    md_extensions: "-autolink_bare_uris"
    css: style.css
vignette: >
  %\VignetteIndexEntry{The biomaRt users guide}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r setup, echo = FALSE}
knitr::opts_chunk$set(error = TRUE, cache = FALSE, eval = TRUE)
```

# Introduction

In recent years a wealth of biological data has become available in public data repositories. Easy access to these valuable data resources and firm integration with data analysis is needed for comprehensive bioinformatics data analysis.  The `r Biocpkg("biomaRt")` package,  provides an interface to a growing collection of databases implementing the [BioMart software suite](http://www.biomart.org). The package enables retrieval of large amounts of data in a uniform way without the need to know the underlying database schemas or write complex SQL queries. Examples of BioMart databases are Ensembl, Uniprot and HapMap. These major databases give `r Biocpkg("biomaRt")` users direct access to a diverse set of data and enable a wide range of powerful online queries from R.

# Selecting a BioMart database and dataset

Every analysis with `r Biocpkg("biomaRt")` starts with selecting a BioMart database to use.  A first step is to check which BioMart web services are available.  The function `listMarts()` will display all available BioMart web services   

```{r annotate,echo=FALSE}
options(width=100)
```


```{r biomaRt}
library("biomaRt")
listMarts()
```

The `useMart()` function can now be used to connect to a specified BioMart database, this must be a valid name given by `listMarts()`. In the next example we choose to query the Ensembl BioMart database.

```{r ensembl1}
ensembl <- useMart("ensembl")
```

BioMart databases can contain several datasets, for Ensembl every species is a different dataset.  In a next step we look at which datasets are available in the selected BioMart by using the function `listDatasets()`. *Note: use the function `head()` to display only the first 5 entries as the complete list has `r nrow(listDatasets(ensembl))` entries.*


```{r listDatasets}
datasets <- listDatasets(ensembl)
head(datasets)
```


To select a dataset we can update the `Mart` object using the function `useDataset()`.  In the example below we choose to use the hsapiens dataset.

```{r ensembl2, eval=TRUE}
ensembl = useDataset("hsapiens_gene_ensembl",mart=ensembl)
```

Or alternatively if the dataset one wants to use is known in advance, we can select a BioMart database and dataset in one step by:

```{r ensembl3}
ensembl = useMart("ensembl",dataset="hsapiens_gene_ensembl")
```

# How to build a biomaRt query

The `getBM()` function has three arguments that need to be introduced: filters, attributes and values.
*Filters* define a restriction on the query.  For example you want to restrict the output to all genes located on the human X chromosome then the filter *chromosome_name* can be used with value 'X'. The `listFilters()` function shows you all available filters in the selected dataset.

```{r filters}
filters = listFilters(ensembl)
filters[1:5,]
``` 

*Attributes* define the values we are interested in to retrieve.  For example we want to retrieve the gene symbols or chromosomal coordinates.  The `listAttributes()` function displays all available attributes in the selected dataset.

```{r attributes}
attributes = listAttributes(ensembl)
attributes[1:5,]
```

The `getBM()` function is the main query function in `r Biocpkg("biomaRt")`.  It has four main arguments:

* `attributes`:  is a vector of attributes that one wants to retrieve (= the output of the query).
* `filters`:  is a vector of filters that one wil use as input to the query.
* `values`: a vector of values for the filters.  In case multple filters are in use, the values argument requires a list of values where each position in the list corresponds to the position of the filters in the filters argument (see examples below).
* `mart`: is an object of class `Mart`, which is created by the `useMart()` function.

*Note: for some frequently used queries to Ensembl, wrapper functions are available: `getGene()` and `getSequence()`.  These functions call the `getBM()` function with hard coded filter and attribute names.*

Now that we selected a BioMart database and dataset, and know about attributes, filters, and the values for filters; we can build a `r Biocpkg("biomaRt")` query.  Let's make an easy query for the following problem:  We have a list of Affymetrix identifiers from the u133plus2 platform and we want to retrieve the corresponding EntrezGene identifiers using the Ensembl mappings.

The u133plus2 platform will be the filter for this query and as values for this filter we use our list of Affymetrix identifiers.  As output (attributes) for the query we want to retrieve the EntrezGene and u133plus2 identifiers so we get a mapping of these two identifiers as a result.  The exact names that we will have to use to specify the attributes and filters can be retrieved with the `listAttributes()` and `listFilters()` function respectively.  Let's now run the query:


```{r getBM1, echo=TRUE, eval=TRUE}
affyids=c("202763_at","209310_s_at","207500_at")
getBM(attributes=c('affy_hg_u133_plus_2', 'entrezgene_id'), 
      filters = 'affy_hg_u133_plus_2', 
      values = affyids, 
      mart = ensembl)
```  

## Searching for datasets, filters and attributes

The functions `listDatasets()`, `listAttributes()`, and `listFilters()` will return every available option for their respective types.  However, this can be unwieldy when the list of results is long, involving much scrolling to find the entry you are interested in.   `r Biocpkg("biomaRt")` also provides the functions `searchDatasets()`, `searchAttributes()`, and `searchFilters()` which will try to find any entries matching a specific term or pattern.  For example, if we want to find the details of any datasets in our `ensembl` mart that contain the term '*hsapiens*' we could do the following:

```{r searchDatasets, echo = TRUE, eval = TRUE}
searchDatasets(mart = ensembl, pattern = "hsapiens")
```

You can search in a simlar fashion to find available attributes and filters that you may be interested in.  The example below returns the details for all attributes that contain the pattern '*hgnc*'.

```{r searchAttributes, echo = TRUE, eval = TRUE}
searchAttributes(mart = ensembl, pattern = "hgnc")
```

For advanced use, note that the *pattern* argument takes a regular expression.  This means you can create more complex queries if required.  Imagine, for example, that we have the string *ENST00000577249.1*, which we know is an Ensembl ID of some kind, but we aren't sure what the appropriate filter term is.  The example shown next uses a pattern that will find all filters that contain both the terms '*ensembl*' and '*id*'.  This allows use to reduced the list of filters to only those that might be appropriate for our example.

```{r searchFilters, echo = TRUE, eval = TRUE}
searchFilters(mart = ensembl, pattern = "ensembl.*id")
```

From this we can see that *ENST00000577249.1* is a Transcript ID with version, and the appropriate filter value to use with it is `ensembl_transcript_id_version`.

## Using predefined filter values

Many filters have a predefined list of values that are known to be in the dataset they are associated with.  An common example would be the names of chromosomes when searching a dataset at Ensembl.  In this online interface to BioMart these available options are displayed as a list as shown in Figure \@ref(fig:filtervalues).

```{r filtervalues, fig.cap='The options available to the Chromosome/Scaffold field are limited to a pretermined list based on the values in this dataset.', echo = FALSE}
knitr::include_graphics('filtervalues.png')
```

You can list this in an R session with the function `listFilterValues()`, passing it a mart object and the name of the filter.  For example, to list the possible chromosome names you could run the following:

```{r chromosomeNames, results = FALSE}
listFilterValues(mart = ensembl, filter = "chromosome_name")
```

It is also possible to search the list of available values via `searchFilterValues()`.  In the examples below, the first returns all chromosome names starting with "*GL*", which the second will find any phenotype descriptions that contain the string "*Crohn*".

```{r searchFilterValues, results = FALSE}
searchFilterValues(mart = ensembl, filter = "chromosome_name", pattern = "^GL")
searchFilterValues(mart = ensembl, filter = "phenotype_description", pattern = "Crohn")
```

# Result Caching

To save time and computing resources `r Biocpkg("biomaRt")` will attempt to identify when you are re-running a query you have executed before.  Each time a new query is run, the results will be saved to a cache on your computer. If a query is identified as having been run previously, rather than submitting the query to the server, the results will be loaded from the cache.

You can get some information on the size and location of the cache using the function `biomartCacheInfo()`:

```{r cacheInfo}
biomartCacheInfo()
```

The cache can be deleted using the command `biomartCacheClear()`.  This will remove all cached files.

# Examples of biomaRt queries

In the sections below a variety of example queries are described.  Every example is written as a task, and we have to come up with a `r Biocpkg("biomaRt")` solution to the problem.

##  Annotate a set of Affymetrix identifiers with HUGO symbol and chromosomal locations of corresponding genes

We have a list of Affymetrix hgu133plus2 identifiers and we would like to retrieve the HUGO gene symbols, chromosome names, start and end positions and the bands of the corresponding genes.  The `listAttributes()` and the `listFilters()` functions give us an overview of the available attributes and filters and we look in those lists to find the corresponding attribute and filter names we need.  For this query we'll need the following attributes: hgnc_symbol, chromsome_name, start_position, end_position, band and affy_hg_u133_plus_2 (as we want these in the output to provide a mapping with our original Affymetrix input identifiers.  There is one filter in this query which is the affy_hg_u133_plus_2 filter as we use a list of Affymetrix identifiers as input.  Putting this all together in the `getBM()` and performing the query gives: 

```{r task1, echo=TRUE,eval=TRUE}
affyids=c("202763_at","209310_s_at","207500_at")
getBM(attributes = c('affy_hg_u133_plus_2', 'hgnc_symbol', 'chromosome_name',
                   'start_position', 'end_position', 'band'),
      filters = 'affy_hg_u133_plus_2', 
      values = affyids, 
      mart = ensembl)
``` 


##  Annotate a set of EntrezGene identifiers with GO annotation

In this task we start out with a list of EntrezGene identiers and we want to retrieve GO identifiers related to biological processes that are associated with these entrezgene identifiers.  Again we look at the output of `listAttributes()` and `listFilters()`  to find the filter and attributes we need.  Then we construct the following query:


```{r task2, echo=TRUE,eval=TRUE}
entrez=c("673","837")
goids = getBM(attributes = c('entrezgene_id', 'go_id'), 
              filters = 'entrezgene_id', 
              values = entrez, 
              mart = ensembl)
head(goids)
```

## Retrieve all HUGO gene symbols of genes that are located on chromosomes 17,20 or Y, and are associated with specific GO terms 

The GO terms we are interested in are: **GO:0051330**, **GO:0000080**, **GO:0000114**, **GO:0000082**.  The key to performing this query is to understand that the `getBM()` function enables you to use more than one filter at the same time.  In order to do this, the filter argument should be a vector with the filter names.  The values should be a list, where the first element of the list corresponds to the first filter and the second list element to the second filter and so on.  The elements of this list are vectors containing the possible values for the corresponding filters.

```{r task3, echo=TRUE,eval=TRUE}
 go=c("GO:0051330","GO:0000080","GO:0000114","GO:0000082")
 chrom=c(17,20,"Y")
 getBM(attributes= "hgnc_symbol",
        filters=c("go","chromosome_name"),
        values=list(go, chrom), mart=ensembl)
```


##  Annotate set of idenfiers with INTERPRO protein domain identifiers

In this example we want to annotate the following two RefSeq identifiers: **NM_005359** and **NM_000546** with INTERPRO protein domain identifiers and a description of the protein domains.

```{r task4, echo=TRUE,eval=TRUE}
refseqids = c("NM_005359","NM_000546")
ipro = getBM(attributes=c("refseq_mrna","interpro","interpro_description"), 
             filters="refseq_mrna",
             values=refseqids, 
             mart=ensembl)
ipro
```

## Select all Affymetrix identifiers on the hgu133plus2 chip and Ensembl gene identifiers for genes located on chromosome 16 between basepair 1100000 and 1250000.

In this example we will again use multiple filters: *chromosome_name*, *start*, and *end* as we filter on these three conditions. Note that when a chromosome name, a start position and an end position are jointly used as filters, the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions.

```{r task5, eval = TRUE}
getBM(attributes = c('affy_hg_u133_plus_2','ensembl_gene_id'), 
      filters = c('chromosome_name','start','end'),
      values = list(16,1100000,1250000), 
      mart = ensembl)
```

 
## Retrieve all EntrezGene identifiers and HUGO gene symbols of genes which have a "MAP kinase activity" GO term associated with it.
The GO identifier for MAP kinase activity is **GO:0004707**.  In our query we will use *go_id* as our filter, and *entrezgene_id* and *hgnc_symbol* as attributes.  Here's the query:

```{r task6, echo=TRUE, eval = TRUE}
getBM(attributes = c('entrezgene_id','hgnc_symbol'), 
      filters = 'go', 
      values = 'GO:0004707', 
      mart = ensembl)
```


##  Given a set of EntrezGene identifiers, retrieve 100bp upstream promoter sequences
 
All sequence related queries to Ensembl are available through the `getSequence()` wrapper function. `getBM()` can also be used directly to retrieve sequences but this can get complicated so using getSequence is recommended.

Sequences can be retrieved using the `getSequence()` function either starting from chromosomal coordinates or identifiers.  
The chromosome name can be specified using the *chromosome* argument.  The *start* and *end* arguments are used to specify *start* and *end* positions on the chromosome. 
The type of sequence returned can be specified by the *seqType* argument which takes the following values:

* *cdna*
* *peptide* for protein sequences
* *3utr* for 3' UTR sequences 
* *5utr* for 5' UTR sequences 
* *gene_exon* for exon sequences only
* *transcript_exon* for transcript specific exonic sequences only
* *transcript_exon_intron* gives the full unspliced transcript, that is exons + introns
* *gene_exon_intron* gives the exons + introns of a gene
* *coding* gives the coding sequence only
* *coding_transcript_flank* gives the flanking region of the transcript including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *coding_gene_flank* gives the flanking region of the gene including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *transcript_flank* gives the flanking region of the transcript exculding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *gene_flank* gives the flanking region of the gene excluding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute

In MySQL mode the `getSequence()` function is more limited and the sequence that is returned is the 5' to 3'+ strand of the genomic sequence, given a chromosome, as start and an end position.

This task requires us to retrieve 100bp upstream promoter sequences from a set of EntrezGene identifiers.  The *type* argument in `getSequence()` can be thought of as the filter in this query and uses the same input names given by `listFilters()`. In our query we use `entrezgene_id` for the type argument.  Next we have to specify which type of sequences we want to retrieve, here we are interested in the sequences of the promoter region, starting right next to the coding start of the gene.  Setting the *seqType* to `coding_gene_flank` will give us what we need.  The *upstream* argument is used to specify how many bp of upstream sequence we want to retrieve, here we'll retrieve a rather short sequence of 100bp.  Putting this all together in `getSequence()` gives:


```{r task7, eval=TRUE}
entrez=c("673","7157","837")
getSequence(id = entrez, 
            type="entrezgene_id",
            seqType="coding_gene_flank",
            upstream=100, 
            mart=ensembl) 
``` 


## Retrieve all 5' UTR sequences of all genes that are located on chromosome 3 between the positions 185,514,033 and 185,535,839

As described in the provious task getSequence can also use chromosomal coordinates to retrieve sequences of all genes that lie in the given region. We also have to specify which type of identifier we want to retrieve together with the sequences, here we choose for entrezgene identifiers.

```{r task8, echo=TRUE,eval=TRUE}
utr5 = getSequence(chromosome=3, start=185514033, end=185535839,
                   type="entrezgene_id",
                   seqType="5utr", 
                   mart=ensembl)
utr5
``` 


##  Retrieve protein sequences for a given list of EntrezGene identifiers

In this task the type argument specifies which type of identifiers we are using.
To get an overview of other valid identifier types we refer to the `listFilters()` function.


```{r task9, echo=TRUE, eval=TRUE}
protein = getSequence(id=c(100, 5728),
                      type="entrezgene_id",
                      seqType="peptide", 
                      mart=ensembl)
protein
``` 

##  Retrieve known SNPs located on the human chromosome 8 between positions 148350 and 148612

For this example we'll first have to connect to a different BioMart database, namely snp.  
```{r task10, echo=TRUE, eval=TRUE}
snpmart = useEnsembl(biomart = "snp", dataset="hsapiens_snp")
``` 

The `listAttributes()` and `listFilters()` functions give us an overview of the available attributes and filters.  
From these we need: *refsnp_id*, *allele*, *chrom_start* and *chrom_strand* as attributes; and as filters we'll use: *chrom_start*, *chrom_end* and *chr_name*.  
Note that when a chromosome name, a start position and an end position are jointly used as filters, 
the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions. 
Putting our selected attributes and filters into getBM gives:


```{r task10b}
getBM(attributes = c('refsnp_id','allele','chrom_start','chrom_strand'), 
      filters = c('chr_name','start','end'), 
      values = list(8,148350,148612), 
      mart = snpmart)
``` 


##  Given the human gene TP53, retrieve the human chromosomal location of this gene and also retrieve the chromosomal location and RefSeq id of its homolog in mouse. 

The `getLDS()` (Get Linked Dataset) function provides functionality to link 2 BioMart datasets which each other and construct a query over the two datasets.  In Ensembl, linking two datasets translates to retrieving homology data across species.
The usage of getLDS is very similar to `getBM()`.  The linked dataset is provided by a separate `Mart` object and one has to specify filters and attributes for the linked dataset.  Filters can either be applied to both datasets or to one of the datasets.  Use the listFilters and listAttributes functions on both `Mart` objects to find the filters and attributes for each dataset (species in Ensembl).  The attributes and filters of the linked dataset can be specified with the attributesL and filtersL arguments.   Entering all this information into `getLDS()` gives:

```{r getLDS, cache = TRUE}
human = useMart("ensembl", dataset = "hsapiens_gene_ensembl")
mouse = useMart("ensembl", dataset = "mmusculus_gene_ensembl")
getLDS(attributes = c("hgnc_symbol","chromosome_name", "start_position"),
       filters = "hgnc_symbol", values = "TP53",mart = human,
      attributesL = c("refseq_mrna","chromosome_name","start_position"), martL = mouse)
```


# Using archived versions of Ensembl

It is possible to query archived versions of Ensembl through `r Biocpkg("biomaRt")`.

`r Biocpkg("biomaRt")` provides the function `listEnsemblArchives()` to view the available archives.  This function takes no arguments, and produces a table containing the names of the available archived versions, the date they were first available, and the URL where they can be accessed.

```{r archiveMarts, echo = TRUE, eval = TRUE}
listEnsemblArchives()
```

Alternatively, one can use the <http://www.ensembl.org> website to find archived version.  From the main page scroll down the bottom of the page, click on 'view in Archive' and select the archive you need.  

*You will notice that there is an archive URL even for the current release of Ensembl.  It can be useful to use this if you wish to ensure that script you write now will return exactly the same results in the future.  Using `www.ensembl.org` will always access the current release, and so the data retrieved may change over time as new releases come out.*

Whichever method you use to find the URL of the archive you wish to query, copy the url and use that in the `host` argument as shown below to connect to the specified BioMart database.  The example below shows how to query Ensembl 54. 


```{r archiveMarts3, echo = TRUE, eval = TRUE}
listMarts(host = 'may2009.archive.ensembl.org')
ensembl54 <- useMart(host='may2009.archive.ensembl.org', 
                     biomart='ENSEMBL_MART_ENSEMBL', 
                     dataset='hsapiens_gene_ensembl')
```


# Using a BioMart other than Ensembl

To demonstrate the use of the `r Biocpkg("biomaRt")` package with non-Ensembl databases the next query is performed using the Wormbase ParaSite BioMart.  *Note that we use the `https` address and must provide the port as `443`*
In this example, we use the `listMarts()` function to find the name of the available marts, given the URL of Wormbase.  We use this to connect to Wormbase BioMart, find and select the gene dataset, and print the first 6 available attributes and filters.  Then we use a list of gene names as filter and retrieve associated transcript IDs and the transcript biotype.

```{r wormbase, echo=TRUE, eval=TRUE}
listMarts(host = "parasite.wormbase.org")
wormbase = useMart(biomart = "parasite_mart", 
                   host = "https://parasite.wormbase.org", 
                   port = 443)
listDatasets(wormbase)
wormbase <- useDataset(mart = wormbase, dataset = "wbps_gene")
head(listFilters(wormbase))
head(listAttributes(wormbase))
getBM(attributes = c("external_gene_id", "wbps_transcript_id", "transcript_biotype"), 
      filters="gene_name", 
      values=c("unc-26","his-33"), 
      mart=wormbase)
     
```

# biomaRt helper functions

This section describes a set of `r Biocpkg("biomaRt")` helper functions that can be used to export FASTA format sequences, retrieve values for certain filters and exploring the available filters and attributes in a more systematic manner. 

## exportFASTA

The data.frames obtained by the getSequence function can be exported to FASTA files using the `exportFASTA()` function.  One has to specify the data.frame to export and the filename using the file argument.

## Finding out more information on filters

### filterType

Boolean filters need a value TRUE or FALSE in `r Biocpkg("biomaRt")`.  Setting the value TRUE will include all information that fulfill the filter requirement.  Setting FALSE will exclude the information that fulfills the filter requirement and will return all values that don't fulfill the filter.
For most of the filters, their name indicates if the type is a boolean or not and they will usually start with "with".  However this is not a rule and to make sure you got the type right you can use the function `filterType()` to investigate the type of the filter you want to use.


```{r filterType}
filterType("with_affy_hg_u133_plus_2",ensembl)
```


### filterOptions

Some filters have a limited set of values that can be given to them.  To know which values these are one can use the `filterOptions()` function to retrieve the predetermed values of the respective filter.


```{r filterOptions}
filterOptions("biotype",ensembl)
```



If there are no predetermed values e.g. for the entrezgene filter, then `filterOptions()` will return the type of filter it is. And most of the times the filter name or it's description will suggest what values one case use for the respective filter (e.g. entrezgene filter will work with enterzgene identifiers as values)


## Attribute Pages

For large BioMart databases such as Ensembl, the number of attributes displayed by the `listAttributes()` function can be very large. 
In BioMart databases, attributes are put together in pages, such as sequences, features, homologs for Ensembl.
An overview of the attributes pages present in the respective BioMart dataset can be obtained with the `attributePages()` function.


```{r attributePages}
pages = attributePages(ensembl)
pages
```

To show us a smaller list of attributes which belong to a specific page, we can now specify this in the `listAttributes()` function.  *The set of attributes is still quite long, so we use `head()` to show only the first few items here.*

```{r listAttributes}
head(listAttributes(ensembl, page="feature_page"))
```

We now get a short list of attributes related to the region where the genes are located.


# Local BioMart databases

The `r Biocpkg("biomaRt")` package can be used with a local install of a public BioMart database or a locally developed BioMart database and web service.
In order for `r Biocpkg("biomaRt")` to recognize the database as a BioMart, make sure that the local database you create has a name conform with ` database_mart_version ` where database is the name of the database and version is a version number.  No more underscores than the ones showed should be present in this name. A possible name is for example ` ensemblLocal_mart_46 `.
## Minimum requirements for local database installation
More information on installing a local copy of a BioMart database or develop your own BioMart database and webservice can be found on <http://www.biomart.org>
Once the local database is installed you can use `r Biocpkg("biomaRt")` on this database by:

```{r localCopy, eval = FALSE}
listMarts(host="www.myLocalHost.org", path="/myPathToWebservice/martservice")
mart=useMart("nameOfMyMart",dataset="nameOfMyDataset",host="www.myLocalHost.org", path="/myPathToWebservice/martservice")
```


For more information on how to install a public BioMart database see:  http://www.biomart.org/install.html and follow link databases.

# Using `select()`
In order to provide a more consistent interface to all annotations in
Bioconductor the `select()`, `columns()`,
`keytypes()` and `keys()` have been implemented to wrap
some of the existing functionality above.  These methods can be called
in the same manner that they are used in other parts of the project
except that instead of taking a `AnnotationDb` derived class
they take instead a `Mart` derived class as their 1st argument.
Otherwise usage should be essentially the same.  You still use
`columns()` to discover things that can be extracted from a
`Mart`, and `keytypes()` to discover which things can be
used as keys with `select()`.  

```{r columnsAndKeyTypes}
mart <- useMart(dataset="hsapiens_gene_ensembl",biomart='ensembl')
head(keytypes(mart), n=3)
head(columns(mart), n=3)
``` 

And you still can use `keys()` to extract potential keys, for a
particular key type.  

```{r keys1}
k = keys(mart, keytype="chromosome_name")
head(k, n=3)
``` 

When using `keys()`, you can even take advantage of the extra
arguments that are available for others keys methods.

```{r keys2}
k = keys(mart, keytype="chromosome_name", pattern="LRG")
head(k, n=3)
``` 

Unfortunately the `keys()` method will not work with all key
types because they are not all supported.

But you can still use `select()` here to extract columns of data
that match a particular set of keys (this is basically a wrapper for
`getBM()`).

```{r select}
affy=c("202763_at","209310_s_at","207500_at")
select(mart, keys=affy, columns=c('affy_hg_u133_plus_2','entrezgene_id'),
  keytype='affy_hg_u133_plus_2')
``` 

So why would we want to do this when we already have functions like `getBM()`?  For two reasons: 1) for people who are familiar
with select and it's helper methods, they can now proceed to use `r Biocpkg("biomaRt")` making the same kinds of calls that are already familiar to
them and 2) because the select method is implemented in many places elsewhere, the fact that these methods are shared allows for more
convenient programmatic access of all these resources.  An example of a package that takes advantage of this is the `r Biocpkg("OrganismDbi")` package. Where several packages can be accessed as if they were one resource.

# Connection troubleshooting

Note: if the function `useMart()` runs into proxy problems you should set your proxy first before calling any `r Biocpkg("biomaRt")` functions.  
You can do this using the Sys.putenv command:

```{r putenv, eval = FALSE}
Sys.setenv("http_proxy" = "http://my.proxy.org:9999")
```

Some users have reported that the workaround above does not work, in this case an alternative proxy solution below can be tried: 

```{r rCurlOptions, eval = FALSE}
options(RCurlOptions = list(proxy="uscache.kcc.com:80",proxyuserpwd="------:-------"))
```

# Session Info
```{r sessionInfo}
sessionInfo()
warnings()
```

---
title: "Using a BioMart other than Ensembl"
author: "Steffen Durinck, Wolfgang Huber, Mike Smith"
package: "`r pkg_ver('biomaRt')`"
output: 
  BiocStyle::html_document:
    md_extensions: "-autolink_bare_uris"
    css: style.css
vignette: >
  %\VignetteIndexEntry{Using a BioMart other than Ensembl}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r setup, echo = FALSE}
knitr::opts_chunk$set(error = TRUE, cache = FALSE, eval = TRUE)
options(width=100)
```

# Introduction

In recent years a wealth of biological data has become available in public data repositories. Easy access to these valuable data resources and firm integration with data analysis is needed for comprehensive bioinformatics data analysis.  The `r Biocpkg("biomaRt")` package,  provides an interface to a growing collection of databases implementing the [BioMart software suite](http://www.biomart.org). The package enables retrieval of large amounts of data in a uniform way without the need to know the underlying database schemas or write complex SQL queries. Examples of BioMart databases are Ensembl, Uniprot and HapMap. These major databases give `r Biocpkg("biomaRt")` users direct access to a diverse set of data and enable a wide range of powerful online queries from R.

# Using a BioMart other than Ensembl

There are a small number of non-Ensembl databases that offer a BioMart interface to their data. The `r Biocpkg("biomaRt")` package can be used to access these in a very similar fashion to Ensembl.  The majority of `r Biocpkg("biomaRt")` functions will work in the same manner, but the construction of the initial Mart object requires slightly more setup.  In this section we demonstrate the setting requires to query [Wormbase ParaSite](https://parasite.wormbase.org/index.html) and [Phytozome](https://phytozome.jgi.doe.gov/pz/portal.html).  First we need to load `r Biocpkg("biomaRt")`.

```{r}
library(biomaRt)
```

```{r test-wormbase-ssl, echo = FALSE}
if(grepl(try(httr::GET('https://parasite.wormbase.org'), silent = TRUE)[1], 
         pattern = "sslv3 alert handshake")) {
    httr::set_config(httr::config(ssl_cipher_list = "DEFAULT@SECLEVEL=1"))  
}
```

## Wormbase

To demonstrate the use of the `r Biocpkg("biomaRt")` package with non-Ensembl databases the next query is performed using the Wormbase ParaSite BioMart.  In this example, we use the `listMarts()` function to find the name of the available marts, given the URL of Wormbase.  We use this to connect to Wormbase BioMart using the `useMart()` function.^[Note that we use the `https` address and must provide the port as `443`.  Queries to WormBase will fail without these options.]

```{r wormbase, echo=TRUE, eval=TRUE}
listMarts(host = "parasite.wormbase.org")
wormbase <- useMart(biomart = "parasite_mart", 
                    host = "https://parasite.wormbase.org", 
                    port = 443)
```

We can then use functions described earlier in this vignette to find and select the gene dataset, and print the first 6 available attributes and filters.  Then we use a list of gene names as filter and retrieve associated transcript IDs and the transcript biotype.

```{r wormbase-2, echo=TRUE, eval=TRUE}
listDatasets(wormbase)
wormbase <- useDataset(mart = wormbase, dataset = "wbps_gene")
head(listFilters(wormbase))
head(listAttributes(wormbase))
getBM(attributes = c("external_gene_id", "wbps_transcript_id", "transcript_biotype"), 
      filters = "gene_name", 
      values = c("unc-26","his-33"), 
      mart = wormbase)
     
```

## Phytozome

### Version 12

The Phytozome 12 BioMart was [retired](https://jgi.doe.gov/more-intuitive-phytozome-interface/) in August 2021 and can not longer be accessed.

### Version 13

Version 13 of Phyotozome can be found at https://phytozome-next.jgi.doe.gov/ and if you wish to query that version the URL used to create the Mart object must reflect that.

```{r, phytozome-13, echo = TRUE, eval = TRUE}
phytozome_v13 <- useMart(biomart = "phytozome_mart", 
                dataset = "phytozome", 
                host = "https://phytozome-next.jgi.doe.gov")
```

Once this is set up the usual `r Biocpkg("biomaRt")` functions can be used to interrogate the database options and run queries.

```{r, pytozome-2}
getBM(attributes = c("organism_name", "gene_name1"), 
      filters = "gene_name_filter", 
      values = "82092", 
      mart = phytozome_v13)
```

# Session Info
```{r sessionInfo}
sessionInfo()
warnings()
```

---
title: "Accessing Ensembl annotation with biomaRt"
author: "Mike L. Smith, Steffen Durinck, Wolfgang Huber"
package: "`r pkg_ver('biomaRt')`"
output: 
  BiocStyle::html_document:
    md_extensions: "-autolink_bare_uris"
    css: style.css
vignette: >
  %\VignetteIndexEntry{Accessing Ensembl annotation with biomaRt}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

```{r setup, echo = FALSE}
knitr::opts_chunk$set(error = TRUE, cache = FALSE, eval = TRUE, out.width = "100%")
httr::set_config(httr::config(ssl_verifypeer = FALSE))
options(width=100)
```

# Introduction

Accessing the data available in Ensembl is by far most frequent use of the `r Biocpkg("biomaRt")` package.  With that in mind `r Biocpkg("biomaRt")` provides a number of functions that are tailored to work specifically with the BioMart instances provided by Ensembl.  This vignette details this Ensembl specific functionality and provides a number of example usecases that can be used as the basis for specifying your own queries.

# Selecting an Ensembl BioMart database and dataset

Every analysis with `r Biocpkg("biomaRt")` starts with selecting a BioMart database to use.  The commands below will connect us to Ensembl's most recent version of the Human Genes BioMart.

```{r useEnsembl}
library(biomaRt)
ensembl <- useEnsembl(biomart = "genes", dataset = "hsapiens_gene_ensembl")
```

If this your first time using `r Biocpkg("biomaRt")` , you might wonder how to find the two arguments we supplied to the `useEnsembl()` command.  This is a two step process, but once you know the setting you need you can use the version shown above as a single command.  These initial steps are outlined below.

## Step1: Identifying the database you need

The first step is to find the names of the BioMart services Ensembl is currently providing.  We can do this using the function `listEnsembl()`, which will display all available Ensembl BioMart web services.  The first column gives us the name we should provide to the `biomart` argument in `useEnsembl()`, and the second gives a more comprehensive title for the dataset along with the Ensembl version.

```{r, listEnsembl}
listEnsembl()
```

The `useEnsembl()` function can now be used to connect to the desired BioMart database.  The `biomart` argument should be given a valid name from the output of `listEnsembl()`. In the next example we will select the main Ensembl mart, which provides access to gene annotation information.

```{r ensembl1}
ensembl <- useEnsembl(biomart = "genes")
```

If we print the current `ensembl` object, we can see that the `r ensembl@biomart` database ^[this is how Ensembl name the database on their server] has been selected, but that no dataset has been chosen.

```{r ensembl2}
ensembl
```

## Step 2: Choosing a dataset

BioMart databases can contain several datasets. For example, within the Ensembl genes mart every species is a different dataset.  In the next step we look at which datasets are available in the selected BioMart by using the function `listDatasets()`. *Note: here we use the function `head()` to display only the first 5 entries as the complete list has `r nrow(listDatasets(ensembl))` entries.*

```{r listDatasets}
datasets <- listDatasets(ensembl)
head(datasets)
```

The `listDatasets()` function will return every available option, however this can be unwieldy when the list of results is long, involving much scrolling to find the entry you are interested in.  `r Biocpkg("biomaRt")` also provides the functions `searchDatasets()` which will try to find any entries matching a specific term or pattern.  For example, if we want to find the details of any datasets in our `ensembl` mart that contain the term '*hsapiens*' we could do the following:

```{r searchDatasets, echo = TRUE, eval = TRUE}
searchDatasets(mart = ensembl, pattern = "hsapiens")
```

To use a dataset we can update our `Mart` object using the function `useDataset()`.  In the example below we choose to use the *hsapiens* dataset.

```{r ensembl3, eval=TRUE}
ensembl <- useDataset(dataset = "hsapiens_gene_ensembl", mart = ensembl)
```

As mentioned previously, if the dataset one wants to use is known in advance i.e. you've gone through this process before, we can select a both the database and dataset in one step:

```{r ensembl4, eval = FALSE}
ensembl <- useEnsembl(biomart = "genes", dataset = "hsapiens_gene_ensembl")
```

## Ensembl mirror sites

To improve performance Ensembl provides several mirrors of their site distributed around the globe.  When you use the default settings for `useEnsembl()` your queries will be directed to your closest mirror geographically.  In theory this should give you the best performance, however this is not always the case in practice.  For example, if the nearest mirror is experiencing many queries from other users it may perform poorly for you.  You can use the `mirror` argument to `useEnsembl()` to explicitly request a specific mirror.

```{r, mirrors, eval = FALSE}
ensembl <- useEnsembl(biomart = "ensembl", 
                   dataset = "hsapiens_gene_ensembl", 
                   mirror = "useast")
```

Values for the mirror argument are: `useast`, `asia`, and `www`.

## Using archived versions of Ensembl

It is possible to query archived versions of Ensembl through `r Biocpkg("biomaRt")`, so you can maintain consistent annotation throughout the duration of a project.

`r Biocpkg("biomaRt")` provides the function `listEnsemblArchives()` to view the available Ensembl archives.  This function takes no arguments, and produces a table containing the name and version number of the available archives, the date they were first released, and the URL where they can be accessed.

```{r archiveMarts, echo = TRUE, eval = TRUE}
listEnsemblArchives()
```

Alternatively, one can use the <http://www.ensembl.org> website to find an archived version.  From the main page scroll down the bottom of the page, click on 'view in Archive' and select the archive you need.  

*You will notice that there is an archive URL even for the current release of Ensembl.  It can be useful to use this if you wish to ensure that script you write now will return exactly the same results in the future.  Using `www.ensembl.org` will always access the current release, and so the data retrieved may change over time as new releases come out.*

Whichever method you use to find the URL of the archive you wish to query, copy the url and use that in the `host` argument as shown below to connect to the specified BioMart database.  The example below shows how to query Ensembl 95. 


```{r archiveMarts3, echo = TRUE, eval = TRUE}
listEnsembl(version = 95)
ensembl95 <- useEnsembl(biomart = 'genes', 
                       dataset = 'hsapiens_gene_ensembl',
                       version = 95)
```


## Using Ensembl Genomes

Ensembl Genomes expands the effort to provide annotation from the vertebrate genomes provided by the main Ensembl project across taxonomic space, with separate BioMart interfaces for Protists, Plants, Metazoa and Fungi. ^[Note: Unfortunately there is no BioMart interface to the Ensembl Bacteria data.  The number of bacterial genomes is in the tens of thousands and BioMart does not perform well when providing data on that scale].

You can use the functions `listEnsemblGenomes()` and `useEnsemblGenomes()` in similar fashion to the functions shown previously.  For example first we can list the available Ensembl Genomes marts:

```{r listEnsemblGenomes}
listEnsemblGenomes()
```

We can the select the Ensembl Plants database, and search for the dataset name for Arabidopsis.

```{r, plants1}
ensembl_plants <- useEnsemblGenomes(biomart = "plants_mart")
searchDatasets(ensembl_plants, pattern = "Arabidopsis")
```

We can then use this information to create our `Mart` object that will access the correct database and dataset.

```{r}
ensembl_arabidopsis <- useEnsemblGenomes(biomart = "plants_mart", 
                                         dataset = "athaliana_eg_gene")
```

# How to build a biomaRt query

Once we've selected a dataset to get data from, we need to create a query and send it to the Ensembl BioMart server.  We do this using the `getBM()` function.

The `getBM()` function has three arguments that need to be introduced: *filters*, *values* and *attributes*.

*Filters* and *values* are used to define restrictions on the query.  For example, if you want to restrict the output to all genes located on the human X chromosome then the filter *chromosome_name* can be used with *value* 'X'. The `listFilters()` function shows you all available filters in the selected dataset.

```{r filters}
filters = listFilters(ensembl)
filters[1:5,]
``` 

*Attributes* define the data we are interested in retrieving.  For example, maybe we want to retrieve the gene symbols or chromosomal coordinates.  The `listAttributes()` function displays all available attributes in the selected dataset.

```{r attributes}
attributes = listAttributes(ensembl)
attributes[1:5,]
```

The `getBM()` function is the primary query function in `r Biocpkg("biomaRt")`.  It has four main arguments:

* `attributes`:  is a vector of attributes that one wants to retrieve (= the output of the query).
* `filters`:  is a vector of filters that one wil use as input to the query.
* `values`: a vector of values for the filters.  In case multple filters are in use, the values argument requires a list of values where each position in the list corresponds to the position of the filters in the filters argument (see examples below).
* `mart`: is an object of class `Mart`, which is created by the `useEnsembl()` function.

*Note: for some frequently used queries to Ensembl, wrapper functions are available: `getGene()` and `getSequence()`.  These functions call the `getBM()` function with hard coded filter and attribute names.*

Now that we selected a BioMart database and dataset, and know about attributes, filters, and the values for filters; we can build a `r Biocpkg("biomaRt")` query.  Let's make an easy query for the following problem:  We have a list of Affymetrix identifiers from the u133plus2 platform and we want to retrieve the corresponding EntrezGene identifiers using the Ensembl mappings.

The u133plus2 platform will be the filter for this query and as values for this filter we use our list of Affymetrix identifiers.  As output (attributes) for the query we want to retrieve the EntrezGene and u133plus2 identifiers so we get a mapping of these two identifiers as a result.  The exact names that we will have to use to specify the attributes and filters can be retrieved with the `listAttributes()` and `listFilters()` function respectively.  Let's now run the query:


```{r getBM1, echo=TRUE, eval=TRUE}
affyids <- c("202763_at","209310_s_at","207500_at")
getBM(attributes = c('affy_hg_u133_plus_2', 'entrezgene_id'),
      filters = 'affy_hg_u133_plus_2',
      values = affyids, 
      mart = ensembl)
```  

## Searching for filters and attributes

The functions `listAttributes()` and `listFilters()` will return every available option for their respective types, which can produce a very long output where it is hard to find the value you are interested in.  `r Biocpkg("biomaRt")` also provides the functions `searchAttributes()` and `searchFilters()` which will try to find any entries matching a specific term or pattern, in a similar fashion to `searchDatasets()` seen previously.  You can use these functions to find available attributes and filters that you may be interested in.  The example below returns the details for all attributes that contain the pattern '*hgnc*'.

```{r searchAttributes, echo = TRUE, eval = TRUE}
searchAttributes(mart = ensembl, pattern = "hgnc")
```

For advanced use, note that the *pattern* argument takes a regular expression.  This means you can create more complex queries if required.  Imagine, for example, that we have the string *ENST00000577249.1*, which we know is an Ensembl ID of some kind, but we aren't sure what the appropriate filter term is.  The example shown next uses a pattern that will find all filters that contain the terms '*ensembl*' and '*id*'.  This allows us to reduced the list of filters to only those that might be appropriate for our example.

```{r searchFilters, echo = TRUE, eval = TRUE}
searchFilters(mart = ensembl, pattern = "ensembl.*id")
```

From this we can compare *ENST00000577249.1* with the examples given in the description column, and see it is a Transcript ID with version.  Thus the appropriate filter value to use with it is `ensembl_transcript_id_version`.

## Using predefined filter values

Many filters have a predefined list of values that are known to be in the dataset they are associated with.  A common example would be the names of chromosomes when searching a dataset at Ensembl.  In this online interface to BioMart these available options are displayed as a list as shown in Figure \@ref(fig:filtervalues).

```{r filtervalues, fig.cap='The options available to the Chromosome/Scaffold field are limited to a pretermined list based on the values in this dataset.', echo = FALSE}
knitr::include_graphics('filtervalues.png')
```

You can list this in an R session with the function `listFilterOptions()`, passing it a `Mart` object and the name of the filter.  For example, to list the possible chromosome names you could run the following:

```{r chromosomeNames, results = FALSE}
listFilterOptions(mart = ensembl, filter = "chromosome_name")
```

It is also possible to search the list of available values via `searchFilterOptions()`.  In the two examples below, the first returns all chromosome names starting with "*GL*", while the second will find any phenotype descriptions that contain the string "*Crohn*".

```{r listFilterOptions, results = TRUE}
searchFilterOptions(mart = ensembl, filter = "chromosome_name", 
                    pattern = "^GL")
searchFilterOptions(mart = ensembl, filter = "phenotype_description", 
                    pattern = "Crohn")
```

## Finding out more information on filters

### filterType

Boolean filters need a value TRUE or FALSE in `r Biocpkg("biomaRt")`.  Setting the value TRUE will include all information that fulfil the filter requirement.  Setting FALSE will exclude the information that fulfills the filter requirement and will return all values that don't fulfil the filter. For most of the filters, their name indicates if the type is a boolean or not and they will usually start with "with".  However this is not a rule and to make sure you got the type right you can use the function `filterType()` to investigate the type of the filter you want to use.

```{r filterType}
filterType("with_affy_hg_u133_plus_2", ensembl)
```

## Attribute Pages

For large BioMart databases such as Ensembl, the number of attributes displayed by the `listAttributes()` function can be very large. 
In BioMart databases, attributes are put together in pages, such as sequences, features, homologs for Ensembl.
An overview of the attributes pages present in the respective BioMart dataset can be obtained with the `attributePages()` function.


```{r attributePages}
pages = attributePages(ensembl)
pages
```

To show us a smaller list of attributes which belong to a specific page, we can now specify this in the `listAttributes()` function.^[The set of attributes is still quite long, so we use `head()` to show only the first few items here.]

```{r listAttributes}
head(listAttributes(ensembl, page="feature_page"))
```

We now get a short list of attributes related to the region where the genes are located.

## Using `select()`

In order to provide a more consistent interface to all annotations in Bioconductor the `select()`, `columns()`, `keytypes()` and `keys()` have been implemented to wrap some of the existing functionality above.  These methods can be called in the same manner that they are used in other parts of the project except that instead of taking a `AnnotationDb` derived class they take instead a `Mart` derived class as their 1st argument.  Otherwise usage should be essentially the same.  You still use `columns()` to discover things that can be extracted from a `Mart`, and `keytypes()` to discover which things can be used as keys with `select()`.  

```{r columnsAndKeyTypes}
mart <- useEnsembl(dataset = "hsapiens_gene_ensembl", biomart='ensembl')
head(keytypes(mart), n = 3)
head(columns(mart), n = 3)
``` 

And you still can use `keys()` to extract potential keys, for a
particular key type.  

```{r keys1}
k = keys(mart, keytype="chromosome_name")
head(k, n=3)
``` 

When using `keys()`, you can even take advantage of the extra
arguments that are available for others keys methods.

```{r keys2}
k = keys(mart, keytype="chromosome_name", pattern="LRG")
head(k, n=3)
``` 

Unfortunately the `keys()` method will not work with all key types because they are not all supported.

But you can still use `select()` here to extract columns of data that match a particular set of keys (this is basically a wrapper for `getBM()`).

```{r select}
affy=c("202763_at","209310_s_at","207500_at")
select(mart, keys=affy, columns=c('affy_hg_u133_plus_2','entrezgene_id'),
  keytype='affy_hg_u133_plus_2')
``` 

So why would we want to do this when we already have functions like `getBM()`?  For two reasons: 1) for people who are familiar
with select and it's helper methods, they can now proceed to use `r Biocpkg("biomaRt")` making the same kinds of calls that are already familiar to them and 2) because the select method is implemented in many places elsewhere, the fact that these methods are shared allows for more convenient programmatic access of all these resources.  An example of a package that takes advantage of this is the `r Biocpkg("OrganismDbi")` package. Where several packages can be accessed as if they were one resource.

# Result Caching

To save time and computing resources `r Biocpkg("biomaRt")` will attempt to identify when you are re-running a query you have executed before.  Each time a new query is run, the results will be saved to a cache on your computer. If a query is identified as having been run previously, rather than submitting the query to the server, the results will be loaded from the cache.

You can get some information on the size and location of the cache using the function `biomartCacheInfo()`:

```{r cacheInfo}
biomartCacheInfo()
```

The cache can be deleted using the command `biomartCacheClear()`.  This will remove all cached files.

The default location for the cache is specifc to your computer and operating system.  If you want to use a specific location you can set this via the `BIOMART_CACHE` environment variable.  You can either set this outside of R, or within R via a call to `Sys.setenv(BIOMART_CACHE = "</where/i/store/my/cache>")`.  The code below gives an example where we change the location to a temporary file^[This would not be a sensible choice on your machine, but is convenient on the Bioconductor server.] and then confirm that the location has changed.

```{r cache-location, echo=1:2}
Sys.setenv(BIOMART_CACHE = tempdir())
biomartCacheInfo()
Sys.unsetenv("BIOMART_CACHE")
```


# biomaRt helper functions

This section describes a set of `r Biocpkg("biomaRt")` helper functions that can be used to export FASTA format sequences, retrieve values for certain filters and exploring the available filters and attributes in a more systematic manner. 

## exportFASTA

The data.frames obtained by the `getSequence()` function can be exported to FASTA files using the `exportFASTA()` function.  One has to specify the data.frame to export and the filename using the file argument.


# Examples of biomaRt queries

In the sections below a variety of example queries are described.  Every example is written as a task, and we have to come up with a `r Biocpkg("biomaRt")` solution to the problem.

##  Annotate a set of Affymetrix identifiers with HUGO symbol and chromosomal locations of corresponding genes

We have a list of Affymetrix hgu133plus2 identifiers and we would like to retrieve the HUGO gene symbols, chromosome names, start and end positions and the bands of the corresponding genes.  The `listAttributes()` and the `listFilters()` functions give us an overview of the available attributes and filters and we look in those lists to find the corresponding attribute and filter names we need.  For this query we'll need the following attributes: hgnc_symbol, chromsome_name, start_position, end_position, band and affy_hg_u133_plus_2 (as we want these in the output to provide a mapping with our original Affymetrix input identifiers.  There is one filter in this query which is the affy_hg_u133_plus_2 filter as we use a list of Affymetrix identifiers as input.  Putting this all together in the `getBM()` and performing the query gives: 

```{r task1, echo=TRUE,eval=TRUE}
affyids=c("202763_at","209310_s_at","207500_at")
getBM(attributes = c('affy_hg_u133_plus_2', 'hgnc_symbol', 'chromosome_name',
                   'start_position', 'end_position', 'band'),
      filters = 'affy_hg_u133_plus_2', 
      values = affyids, 
      mart = ensembl)
``` 


## Annotate a set of EntrezGene identifiers with GO annotation

In this task we start out with a list of EntrezGene identiers and we want to retrieve GO identifiers related to biological processes that are associated with these entrezgene identifiers.  Again we look at the output of `listAttributes()` and `listFilters()`  to find the filter and attributes we need.  Then we construct the following query:


```{r task2, echo=TRUE,eval=TRUE}
entrez=c("673","837")
goids = getBM(attributes = c('entrezgene_id', 'go_id'), 
              filters = 'entrezgene_id', 
              values = entrez, 
              mart = ensembl)
head(goids)
```

## Retrieve all HUGO gene symbols of genes that are located on chromosomes 17,20 or Y, and are associated with specific GO terms 

The GO terms we are interested in are: **GO:0051330**, **GO:0000080**, **GO:0000114**, **GO:0000082**.  The key to performing this query is to understand that the `getBM()` function enables you to use more than one filter at the same time.  In order to do this, the filter argument should be a vector with the filter names.  The values should be a list, where the first element of the list corresponds to the first filter and the second list element to the second filter and so on.  The elements of this list are vectors containing the possible values for the corresponding filters.

```{r task3, echo=TRUE,eval=TRUE}
 go=c("GO:0051330","GO:0000080","GO:0000114","GO:0000082")
 chrom=c(17,20,"Y")
 getBM(attributes= "hgnc_symbol",
        filters=c("go","chromosome_name"),
        values=list(go, chrom), mart=ensembl)
```


##  Annotate set of idenfiers with INTERPRO protein domain identifiers

In this example we want to annotate the following two RefSeq identifiers: **NM_005359** and **NM_000546** with INTERPRO protein domain identifiers and a description of the protein domains.

```{r task4, echo=TRUE,eval=TRUE}
refseqids = c("NM_005359","NM_000546")
ipro = getBM(attributes=c("refseq_mrna","interpro","interpro_description"), 
             filters="refseq_mrna",
             values=refseqids, 
             mart=ensembl)
ipro
```

## Select all Affymetrix identifiers on the hgu133plus2 chip and Ensembl gene identifiers for genes located on chromosome 16 between basepair 1100000 and 1250000.

In this example we will again use multiple filters: *chromosome_name*, *start*, and *end* as we filter on these three conditions. Note that when a chromosome name, a start position and an end position are jointly used as filters, the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions.

```{r task5, eval = TRUE}
getBM(attributes = c('affy_hg_u133_plus_2','ensembl_gene_id'), 
      filters = c('chromosome_name','start','end'),
      values = list(16,1100000,1250000), 
      mart = ensembl)
```

 
## Retrieve all EntrezGene identifiers and HUGO gene symbols of genes which have a "MAP kinase activity" GO term associated with it.

The GO identifier for MAP kinase activity is **GO:0004707**.  In our query we will use *go_id* as our filter, and *entrezgene_id* and *hgnc_symbol* as attributes.  Here's the query:

```{r task6, echo=TRUE, eval = TRUE}
getBM(attributes = c('entrezgene_id','hgnc_symbol'), 
      filters = 'go', 
      values = 'GO:0004707', 
      mart = ensembl)
```


##  Given a set of EntrezGene identifiers, retrieve 100bp upstream promoter sequences
 
All sequence related queries to Ensembl are available through the `getSequence()` wrapper function. `getBM()` can also be used directly to retrieve sequences but this can get complicated so using `getSequence()` is provided as a general purpose function suitable for most situtations.

Sequences can be retrieved using the `getSequence()` function either starting from chromosomal coordinates or identifiers.  
The chromosome name can be specified using the *chromosome* argument.  The *start* and *end* arguments are used to specify *start* and *end* positions on the chromosome. 
The type of sequence returned can be specified by the *seqType* argument which takes the following values:

* *cdna*
* *peptide* for protein sequences
* *3utr* for 3' UTR sequences 
* *5utr* for 5' UTR sequences 
* *gene_exon* for exon sequences only
* *transcript_exon* for transcript specific exonic sequences only
* *transcript_exon_intron* gives the full unspliced transcript, that is exons + introns
* *gene_exon_intron* gives the exons + introns of a gene
* *coding* gives the coding sequence only
* *coding_transcript_flank* gives the flanking region of the transcript including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *coding_gene_flank* gives the flanking region of the gene including the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *transcript_flank* gives the flanking region of the transcript exculding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute
* *gene_flank* gives the flanking region of the gene excluding the UTRs, this must be accompanied with a given value for the upstream or downstream attribute


This task requires us to retrieve 100bp upstream promoter sequences from a set of EntrezGene identifiers.  The *type* argument in `getSequence()` can be thought of as the filter in this query and uses the same input names given by `listFilters()`. In our query we use `entrezgene_id` for the type argument.  Next we have to specify which type of sequences we want to retrieve, here we are interested in the sequences of the promoter region, starting right next to the coding start of the gene.  Setting the *seqType* to `coding_gene_flank` will give us what we need.  The *upstream* argument is used to specify how many bp of upstream sequence we want to retrieve, here we'll retrieve a rather short sequence of 100bp.  Putting this all together in `getSequence()` gives:


```{r task7, eval=TRUE}
entrez=c("673","7157","837")
getSequence(id = entrez, 
            type="entrezgene_id",
            seqType="coding_gene_flank",
            upstream=100, 
            mart=ensembl) 
``` 

One further thing to note is that, although we are searching for genes based on their NCBI Gene IDs, Ensembl BioMart doesn't allow some ID types (including NCBI IDs) to be returned directly.  To try and accommodate this `r Biocpkg("biomaRt")` attempts to map the query IDs to Ensembl Gene IDs internally before finding the sequence information.  If no such mapping exists (or at least isn't found in Ensembl) then no sequence will be returned for the affected IDs.


## Retrieve all 5' UTR sequences of all genes that are located on chromosome 3 between the positions 185,514,033 and 185,535,839

As described in the previous task `getSequence()` can also use chromosomal coordinates to retrieve sequences of all genes that lie in the given region. We also have to specify which type of identifier we want to retrieve together with the sequences. Here we choose the NCBI Gene ID^[These were historically called "Entrezgene IDs", hence the name given to the `type` argument.]

```{r task8, echo=TRUE,eval=TRUE}
utr5 = getSequence(chromosome=3, start=185514033, end=185535839,
                   type="entrezgene_id",
                   seqType="5utr", 
                   mart=ensembl)
utr5
``` 


##  Retrieve protein sequences for a given list of EntrezGene identifiers

In this task the type argument specifies which type of identifiers we are using.
To get an overview of other valid identifier types we refer to the `listFilters()` function.


```{r task9, echo=TRUE, eval=TRUE}
protein = getSequence(id=c(100, 5728),
                      type="entrezgene_id",
                      seqType="peptide", 
                      mart=ensembl)
protein
``` 

##  Retrieve known SNPs located on the human chromosome 8 between positions 148350 and 148420

For this example we'll first have to connect to a different BioMart database, namely snp.  
```{r task10, echo=TRUE, eval=TRUE}
snpmart = useEnsembl(biomart = "snp", dataset="hsapiens_snp")
``` 

The `listAttributes()` and `listFilters()` functions give us an overview of the available attributes and filters.  
From these we need: *refsnp_id*, *allele*, *chrom_start* and *chrom_strand* as attributes; and as filters we'll use: *chrom_start*, *chrom_end* and *chr_name*.  
^[Note that when a chromosome name, a start position and an end position are jointly used as filters, 
the BioMart webservice interprets this as return everything from the given chromosome between the given start and end positions.] Putting our selected attributes and filters into `getBM()` gives:


```{r task10b}
getBM(attributes = c('refsnp_id','allele','chrom_start','chrom_strand'), 
      filters = c('chr_name','start','end'), 
      values = list(8, 148350, 148420), 
      mart = snpmart)
``` 


##  Given the human gene TP53, retrieve the human chromosomal location of this gene and also retrieve the chromosomal location and RefSeq id of its homolog in mouse. 

The `getLDS()` (Get Linked Dataset) function provides functionality to link 2 BioMart datasets which each other and construct a query over the two datasets.  In Ensembl, linking two datasets translates to retrieving homology data across species.

The usage of getLDS is very similar to `getBM()`.  The linked dataset is provided by a separate `Mart` object and one has to specify filters and attributes for the linked dataset.  Filters can either be applied to both datasets or to one of the datasets.  Use the listFilters and listAttributes functions on both `Mart` objects to find the filters and attributes for each dataset (species in Ensembl).  The attributes and filters of the linked dataset can be specified with the attributesL and filtersL arguments.   Entering all this information into `getLDS()` gives:

```{r getLDS, cache = TRUE}
human <- useEnsembl("ensembl", dataset = "hsapiens_gene_ensembl")
mouse <- useEnsembl("ensembl", dataset = "mmusculus_gene_ensembl")
getLDS(attributes = c("hgnc_symbol","chromosome_name", "start_position"),
       filters = "hgnc_symbol", values = "TP53",
       mart = human,
       attributesL = c("refseq_mrna","chromosome_name","start_position"), 
       martL = mouse)
```



# Connection troubleshooting

It is not uncommon to encounter connection problems when trying to access online resources such as the Ensembl BioMart. 
In this section we list error messages that have been reported by users, along with suggested code to fix the problem.  If a suggested solution doesn't work, or you have a new error not listed here, please reported it on the [Bioconductor Support Site](https://support.bioconductor.org/). 

## `r Biocpkg("biomaRt")` specific solutions

If you are using `r Biocpkg("biomaRt")` directly make sure you are using `useEnsembl()` to create the **Mart** object, rather than `useMart()`.  `useEnsembl()` is aware of some specific connection details required to connect to Ensembl, and using it may fix any connection problems without requiring you to do anything further.

## Global connection settings 

If you are unable to modify the `r Biocpkg("biomaRt")` code (for example if you are using another package that calls `r Biocpkg("biomaRt")` as part of one if its functions) it's still possible to modify the connection settings for your R session. Below are some reported error messages and code that has been known to resolve them.  You will need to execute this code only once in an R session, but the settings will not persist between R sessions.

### Error: "SSL certificate problem"

**Error message**

```
Error in curl::curl_fetch_memory(url, handle = handle) :
SSL certificate problem: unable to get local issuer certificate
```

**Fix**

```{r, ssl-verifypeer, eval = FALSE}
httr::set_config(httr::config(ssl_verifypeer = FALSE))
```

### Error: "sslv3 alert handshake failure"

**Error message**

```
Error in curl::curl_fetch_memory(url, handle = handle) : 
error:14094410:SSL routines:ssl3_read_bytes:sslv3 alert handshake failure
```

**Fix**

If you're running Ubuntu 20.04 or newer the following command should fix the issue.

```{r, ssl-cipher-list, eval = FALSE}
httr::set_config(httr::config(ssl_cipher_list = "DEFAULT@SECLEVEL=1"))
```

If you encounter this error on Fedora 33, the code above doesn't seem to work.  At the moment, the only workaround we have discovered is to change the security settings at the system level.  Please see more information at [fedoraproject.org](https://fedoraproject.org/wiki/Changes/StrongCryptoSettings2) and trouble shooting discussion at [GitHub](https://github.com/grimbough/biomaRt/issues/42).  This change can be applied by running the following command in a terminal outside of R, but please consider whether this is something you want to change.  You could also consider alerting Ensembl to this issue.

```
update-crypto-policies --set LEGACY
```


# Session Info
```{r sessionInfo}
sessionInfo()
```

# getBM doesn't convert T/F alleles into TRUE/FALSE

    Code
      getBM(attributes = c("refsnp_id", "minor_allele"), filters = c("chr_name",
        "start", "end"), values = list(8, 35127386, 35127386), mart = snp_ensembl)
    Output
        refsnp_id minor_allele
      1 rs1528723            T

# exportFASTA() on gene-sequence data.frame

    Code
      exportFASTA(test_df, stdout())
    Output
      >gene1
      ATCGATCGATCGATCGATCGATCGATCGATCGATCGATCG
      
      >gene2
      GCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTA
      

# exportFASTA() on 4 columns data

    Code
      exportFASTA(test_df, stdout())
    Output
      >chromosome_chr1_start_1_end_41
      ATCGATCGATCGATCGATCGATCGATCGATCGATCGATCG
      
      >chromosome_chr1_start_55_end_95
      GCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTAGCTA
      

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl.R
\name{useEnsembl}
\alias{useEnsembl}
\alias{useEnsemblGenomes}
\title{Connects to the selected BioMart database and dataset hosted by Ensembl}
\usage{
useEnsembl(
  biomart,
  dataset,
  host,
  version = NULL,
  GRCh = NULL,
  mirror = NULL,
  verbose = FALSE
)

useEnsemblGenomes(biomart, dataset, host = NULL)
}
\arguments{
\item{biomart}{BioMart database name you want to connect to. Possible
database names can be retrieved with the function \code{\link[=listEnsembl]{listEnsembl()}}}

\item{dataset}{Dataset you want to use.  To see the different datasets
available within a biomaRt you can e.g. do: mart = useEnsembl('genes'),
followed by listDatasets(mart).}

\item{host}{Host to connect to.  Only needs to be specified if different
from www.ensembl.org.  For \code{\link[=useEnsemblGenomes]{useEnsemblGenomes()}} this argument can be
used to specify an archive site.}

\item{version}{Ensembl version to connect to when wanting to connect to an
archived Ensembl version}

\item{GRCh}{GRCh version to connect to if not the current GRCh38, currently
this can only be 37}

\item{mirror}{Specify an Ensembl mirror to connect to.  The valid options
here are 'www', 'useast', 'asia'.  If no mirror is specified the primary
site at www.ensembl.org will be used.  Mirrors are not available for the
Ensembl Genomes databases.}

\item{verbose}{Give detailed output of what the method is doing while in
use, for debugging}
}
\description{
A first step in using the biomaRt package is to select a BioMart database
and dataset to use.  The \code{\link[=useEnsembl]{useEnsembl()}} function enables one to connect
to a specified BioMart database and dataset hosted by Ensembl without having
to specify the Ensembl URL.  To know which BioMart databases are available
see the \code{\link[=listEnsembl]{listEnsembl()}} and \code{\link[=listEnsemblGenomes]{listEnsemblGenomes()}}
functions.  To know which datasets are available within a BioMart database,
first select the BioMart database using \code{\link[=useEnsembl]{useEnsembl()}} and then use the
\code{\link[=listDatasets]{listDatasets()}} function on the selected Mart object.
}
\details{
The \code{mirror} argument can be considered as a "preferred choice" when
connecting to Ensembl.  If the argument is provided then connectivity to
that mirror will be tested.  If it responds positively then the requested
mirror will be used.  If the response is a failure each of the remaining
mirrors will be selected at random and tested until a working server is
found.  Once identified that Ensembl server will be associated with the
returned \code{Mart} object and will be used for all queries.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useEnsembl("ENSEMBL_MART_ENSEMBL")

## using the US East mirror
us_mart <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL", mirror = "useast")

## using the Arabidopsis thaliana genes dataset in Ensembl Plants
plants_mart <- useEnsemblGenomes(
  biomart = "plants_mart",
  dataset = "athaliana_eg_gene"
)

## using the Cucumis melo genes dataset in the Ensembl Plants 56 archive
plants_mart <- useEnsemblGenomes(
  biomart = "plants_mart",
  dataset = "cmelo_eg_gene",
  host = "https://feb2023-plants.ensembl.org/"
)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck & Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl_wrappers.R
\name{getSequence}
\alias{getSequence}
\title{Retrieves sequences}
\usage{
getSequence(
  chromosome,
  start,
  end,
  id,
  type,
  seqType,
  upstream,
  downstream,
  mart,
  useCache = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{chromosome}{Chromosome name}

\item{start}{start position of sequence on chromosome}

\item{end}{end position of sequence on chromosome}

\item{id}{An identifier or vector of identifiers.}

\item{type}{The type of identifier used.  Supported types are hugo, ensembl,
embl, entrezgene, refseq, ensemblTrans and unigene. Alternatively one can
also use a filter to specify the type. Possible filters are given by the
\code{\link[=listFilters]{listFilters()}} function.}

\item{seqType}{Type of sequence that you want to retrieve.  Allowed seqTypes
are given in the details section.}

\item{upstream}{To add the upstream sequence of a specified number of
basepairs to the output.}

\item{downstream}{To add the downstream sequence of a specified number of
basepairs to the output.}

\item{mart}{object of class Mart created using the \code{\link[=useEnsembl]{useEnsembl()}}
function}

\item{useCache}{If \code{useCache = TRUE} then biomaRt will try to store
succesful query results on disk, and will load these if a query is run
again, rather than contacting the Ensembl server.}

\item{verbose}{If `verbose = TRUE`` then the XML query that was send to the
webservice will be displayed.}
}
\description{
This function retrieves sequences given the chromosome, start and end
position or a list of identifiers. Using getSequence in web service mode
(default) generates 5' to 3' sequences of the requested type on the correct
strand.
}
\details{
The type of sequence returned can be specified by the seqType argument which
takes the following values:
\itemize{
\item 'cdna': for nucleotide sequences
\item 'peptide': for protein sequences
\item '3utr': for 3' UTR sequences
\item '5utr': for 5' UTR sequences
\item 'gene_exon': for exon sequences only
\item 'transcript_exon_intron': gives the full unspliced transcript, that is
exons + introns
\item 'gene_exon_intron' gives the exons + introns of a gene;'coding' gives the
coding sequence only
\item 'coding_transcript_flank': gives the flanking region of the transcript
including the UTRs, this must be accompanied with a given value for the
upstream or downstream attribute
\item 'coding_gene_flank': gives the flanking region of the gene including
the UTRs, this must be accompanied with a given value for the upstream or
downstream attribute
\item 'transcript_flank': gives the flanking region of the transcript excluding
the UTRs, this must be accompanied with a given value for the upstream or
downstream attribute
\item 'gene_flank': gives the flanking region of the gene excluding the UTRs,
this must be accompanied with a given value for the upstream or downstream
attribute
}
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useEnsembl("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")

seq <- getSequence(
  id = "BRCA1",
  type = "hgnc_symbol",
  seqType = "peptide",
  mart = mart
)
show(seq)

seq <- getSequence(
  id = "1939_at",
  type = "affy_hg_u95av2",
  seqType = "gene_flank",
  upstream = 20,
  mart = mart
)
show(seq)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/non-biomart-utils.R
\name{getHomologs}
\alias{getHomologs}
\title{List homologous genes between two species.}
\usage{
getHomologs(ensembl_gene_ids, species_from, species_to)
}
\arguments{
\item{ensembl_gene_ids}{Character vector.  This contains the Ensembl Gene
IDs that you want to find the homologs for.}

\item{species_from, species_to}{Character vectors of length 1.  These
arguments specify the species the input IDs belong to (\code{species_from})
and the species you want to find the homologs in (\code{species_to}).  These
can be Ensembl genomes names e.g. "homo_sapiens" or "canis_lupus_familiaris"
or common names e.g. "human" or "dog".  The function will do it's best to
parse common names, and will report and error if no match to an Ensembl
genome can be made.}
}
\description{
This function simplifies the querying of the Ensembl BioMart if you're
trying to return the homologs for one or more gene IDs between two species.
}
\author{
Mike Smith
}
\concept{non-biomart}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{useDataset}
\alias{useDataset}
\title{Select a dataset to use and updates Mart object}
\usage{
useDataset(dataset, mart, verbose = FALSE)
}
\arguments{
\item{dataset}{Dataset you want to use.  List of possible datasets can be
retrieved using the function \code{\link[=listDatasets]{listDatasets()}}}

\item{mart}{Mart object created with the \code{\link[=useMart]{useMart()}} function}

\item{verbose}{Give detailed output of what the method is doing, for
debugging}
}
\description{
This function selects a dataset and updates the Mart object
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart("ENSEMBL_MART_ENSEMBL")
mart <- useDataset("hsapiens_gene_ensembl", mart = mart)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

\name{filterOptions}
\alias{filterOptions}
\title{Displays the filter options}
\description{Displays a set of predetermed values for the specified filter (if available).}
\usage{filterOptions(filter,mart)}

\arguments{
\item{filter}{A valid filter name.}
\item{mart}{object of class Mar created using the useMart functiont}
}

\author{Steffen Durinck} 

\examples{

if(interactive()){
mart = useMart("ensembl", dataset="hsapiens_gene_ensembl")
filterOptions("chromosome_name", mart)
}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{listMarts}
\alias{listMarts}
\title{lists the available BioMart databases}
\usage{
listMarts(
  mart = NULL,
  host = "https://www.ensembl.org",
  path = "/biomart/martservice",
  port,
  includeHosts = FALSE,
  http_config = list(),
  verbose = FALSE
)
}
\arguments{
\item{mart}{mart object created with the \code{\link[=useMart]{useMart()}} function.
This is optional, as you usually use \code{\link[=listMarts]{listMarts()}} to see which
marts there are to connect to.}

\item{host}{Host to connect to. Defaults to \code{www.ensembl.org}}

\item{path}{path to martservice that should be pasted behind the host to get
to web service URL}

\item{port}{port to use in HTTP communication}

\item{includeHosts}{boolean to indicate if function should return host of
the BioMart databases}

\item{http_config}{Some hosts require specific HTTP settings to be used when
connecting. This argument takes the output of \code{\link[httr:config]{httr::config()}} and
will be used when connecting to \code{host}.  Can be ignored if you
experience no problems accessing \code{host}.}

\item{verbose}{Give detailed output of what the method is doing, for
debugging purposes.}
}
\description{
This function returns a list of BioMart databases to which biomaRt can
connect.  By default the Ensembl BioMart databases are displayed. To
establish a connection use the \code{\link[=useMart]{useMart()}} function.
}
\details{
If you receive an error message saying 'Unexpected format to the list of
available marts', this is often because there is a problem with the BioMart
server you are trying to connect to, and something other than the list of
available marts is being returned - often some like a 'down for
maintenance' page.  If you browse to the provided URL and find a page that
starts with '\verb{<MartRegistry>}' this is the correct listing and you
should report the issue on the Bioconductor support site:
https://support.bioconductor.org

The previously available \code{archive} argument is defunct.
A better alternative is to specify the url of the archived BioMart
you want to access. For Ensembl you can view the list of archives using
\code{\link[=listEnsemblArchives]{listEnsemblArchives()}}.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
listMarts()
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl_ssl_settings.R
\name{setEnsemblSSL}
\alias{setEnsemblSSL}
\title{Save system specific SSL settings for contacting Ensembl}
\usage{
setEnsemblSSL(settings)
}
\arguments{
\item{settings}{A named list. Each entry should be a valid curl option, as
found in \code{\link[curl:curl_options]{curl::curl_options()}}.}
}
\description{
On some systems specific SSL settings have to be applied to allow https
connections to the Ensembl servers.  This function allows these to be saved
in the biomaRt cache, so they will be retrieved each time they are needed.
biomaRt will try to determine them automatically, but this function can be
used to set them manually if required.
}
\examples{
\dontrun{
ssl_settings <- list(
  "ssl_cipher_list" = "DEFAULT@SECLEVEL=1",
  "ssl_verifypeer"  = FALSE
)
setEnsemblSSL(ssl_settings)
}

}
\author{
Mike Smith
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt-package.R
\name{biomaRt-deprecated}
\alias{biomaRt-deprecated}
\alias{filterOptions}
\alias{searchFilterValues}
\alias{listFilterValues}
\title{Deprecated and defunct functions in package \pkg{biomaRt}}
\description{
These functions have been removed from biomaRt and replaced with
alternatives.
}
\details{
The following functions are defunct and no longer work; use the replacement
indicated below:
\itemize{
\item filterOptions: \code{\link[=listFilterOptions]{listFilterOptions()}}
\item listFilterValues: \code{\link[=listFilterOptions]{listFilterOptions()}}
\item searchFilterValues: \code{\link[=searchFilterOptions]{searchFilterOptions()}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt-package.R
\docType{package}
\name{biomaRt-package}
\alias{biomaRt}
\alias{biomaRt-package}
\title{biomaRt: Interface to BioMart databases (i.e. Ensembl)}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

In recent years a wealth of biological data has become available in public data repositories. Easy access to these valuable data resources and firm integration with data analysis is needed for comprehensive bioinformatics data analysis. biomaRt provides an interface to a growing collection of databases implementing the BioMart software suite (\url{https://www.ensembl.org/info/data/biomart/index.html}). The package enables retrieval of large amounts of data in a uniform way without the need to know the underlying database schemas or write complex SQL queries. The most prominent examples of BioMart databases are maintained by Ensembl, which provides biomaRt users direct access to a diverse set of data and enables a wide range of powerful online queries from gene annotation to database mining.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/Huber-group-EMBL/biomaRt}
  \item \url{https://huber-group-embl.github.io/biomaRt/}
  \item Report bugs at \url{https://github.com/Huber-group-EMBL/biomaRt/issues}
}

}
\author{
\strong{Maintainer}: Hugo Gruson \email{hugo.gruson@embl.de} (\href{https://orcid.org/0000-0002-4094-1476}{ORCID}) [contributor]

Authors:
\itemize{
  \item Steffen Durinck \email{biomartdev@gmail.com}
  \item Wolfgang Huber
}

Other contributors:
\itemize{
  \item Sean Davis \email{sdavis2@mail.nih.gov} [contributor]
  \item Francois Pepin [contributor]
  \item Vince S Buffalo [contributor]
  \item Mike Smith \email{grimbough@gmail.com} (\href{https://orcid.org/0000-0002-7800-3848}{ORCID}) [contributor]
  \item German Network for Bioinformatics Infrastructure - de.NBI [funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/caching.R
\name{biomartCache}
\alias{biomartCache}
\alias{biomartCacheClear}
\alias{biomartCacheInfo}
\title{\pkg{biomaRt} result caching}
\usage{
biomartCacheClear()

biomartCacheInfo()
}
\value{
These functions do not return anything and are called for their side
effects. \code{\link[=biomartCacheInfo]{biomartCacheInfo()}} prints the location of the cache, along
with the number of files and their total size on disk.
\code{\link[=biomartCacheClear]{biomartCacheClear()}} will delete the current contents of the cache.
}
\description{
\pkg{biomaRt} makes use of a results cache to speedup execution of queries
that have been run before. These functions provide details on the status of
this cache, and allow it to be deleted.
}
\author{
Mike Smith
}
\keyword{IO}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{useMart}
\alias{useMart}
\title{Connects to the selected BioMart database and dataset}
\usage{
useMart(
  biomart,
  dataset,
  host = "https://www.ensembl.org",
  path = "/biomart/martservice",
  port,
  version,
  verbose = FALSE
)
}
\arguments{
\item{biomart}{BioMart database name you want to connect to. Possible
database names can be retrieved with the function \code{\link[=listMarts]{listMarts()}}}

\item{dataset}{Dataset you want to use.  To see the different datasets
available within a biomaRt you can e.g. do: mart = \href{'ensembl'}{useMart()},
followed by \href{mart}{listDatasets()}.}

\item{host}{Host to connect to. Defaults to \code{www.ensembl.org}}

\item{path}{Path that should be pasted after to host to get access to the
web service URL}

\item{port}{port to connect to, will be pasted between host and path}

\item{version}{Use version name instead of biomart name to specify which
BioMart you want to use}

\item{verbose}{Give detailed output of what the method is doing while in
use, for debugging}
}
\description{
A first step in using the biomaRt package is to select a BioMart database
and dataset to use.  The useMart function enables one to connect to a
specified BioMart database and dataset within this database.  To know which
BioMart databases are available see the \code{\link[=listMarts]{listMarts()}} function.  To know which
datasets are available within a BioMart database, first select the BioMart
database using \code{\link[=useMart]{useMart()}} and then use the \code{\link[=listDatasets]{listDatasets()}} function on the
selected BioMart, see \code{\link[=listDatasets]{listDatasets()}} function.
}
\details{
The previously available \code{archive} argument is defunct.
A better alternative is to specify the url of the archived BioMart
you want to access. For Ensembl you can view the list of archives using
\code{\link[=listEnsemblArchives]{listEnsemblArchives()}}.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart("ENSEMBL_MART_ENSEMBL")
mart <- useMart(
  biomart = "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl"
)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike L. Smith
}
\keyword{methods}

%% actual page name
\alias{select-methods}
\name{select-methods}

%% for methods
\alias{keys,Mart-method}
\alias{columns,Mart-method}
\alias{keytypes,Mart-method}
\alias{select,Mart-method}

%% for convenience
\alias{keys}
\alias{columns}
\alias{keytypes}
\alias{select}


\title{Retrieve information from the BioMart databases}
\description{
  \code{select}, \code{columns} and \code{keys} are used together to
  extract data from a \code{Mart} object.  These functions work much the
  same as the classic biomaRt functions such as \code{getBM} etc. and
  are provide here to make this easier for people who are comfortable
  using these methods from other Annotation packages.  Examples of other
  objects in other packages where you can use these methods include (but
  are not limited to): \code{ChipDb}, \code{OrgDb} \code{GODb},
  \code{InparanoidDb} and \code{ReactomeDb}.

  \code{columns} shows which kinds of data can be returned from the
  \code{Mart} object.
  
  \code{keytypes} allows the user to discover which keytypes can be
  passed in to \code{select} or \code{keys} as the \code{keytype}
  argument.
  
  \code{keys} returns keys from the \code{Mart} of the type specified by
  it's \code{keytype} argument.
  
  \code{select} is meant to be used with these other methods and has
  arguments that take the kinds of values that these other methods
  return.  \code{select} will retrieve the results as a data.frame based
  on parameters for selected \code{keys} and \code{columns} and
  \code{keytype} arguments.
}
\usage{
  columns(x)
  keytypes(x)
  keys(x, keytype, ...)
  select(x, keys, columns, keytype, ...)
}

\arguments{
  \item{x}{the \code{Mart} object. The dataset of the \code{Mart} object
    must already be specified for all of these methods.}
  \item{keys}{the keys to select records for from the database.  Keys
    for some keytypes can be extracted by using the \code{keys} method.}
  \item{columns}{the columns or kinds of things that can be retrieved
    from the database.  As with \code{keys}, all possible columns are
    returned by using the \code{columns} method.}
  \item{keytype}{the keytype that matches the keys used.  For the
    \code{select} methods, this is used to indicate the kind of ID being used
    with the keys argument. For the \code{keys} method this is used to
    indicate which kind of keys are desired from \code{keys}
  }
  \item{...}{other arguments.  These include:
    \describe{
      \item{pattern:}{the pattern to match (used by keys)}
      \item{column:}{the column to search on. This is used by keys and is
        for when the thing you want to pattern match is different from
        the keytype, or when you want to simply want to get keys that
        have a value for the thing specified by the column argument.}
      \item{fuzzy:}{TRUE or FALSE value.  Use fuzzy matching? (this is
        used with pattern by the keys method)}
    }
  }
}

\value{
  \code{keys},\code{columns} and \code{keytypes} each return a character
    vector or possible values.  \code{select} returns a data.frame.
}

\author{Marc Carlson}

\examples{
if(interactive()) {
  ## 1st create a Mart object and specify the dataset
  mart <- useEnsembl(dataset="hsapiens_gene_ensembl",
                     biomart='ensembl')
  ## you can list the keytypes
  keytypes(mart)
  ## you can list the columns
  columns(mart)
  ## And you can extract keys when this is supported for your keytype of interest
  k = keys(mart, keytype="chromosome_name")
  head(k)
  ## You can even do some pattern matching on the keys
  k = keys(mart, keytype="chromosome_name", pattern="LRG")
  head(k)
  ## Finally you can use select to extract records for things that you are
  ## interested in.
  affy=c("202763_at","209310_s_at","207500_at")
  select(mart, keys=affy, columns=c('affy_hg_u133_plus_2','entrezgene_id'),
    keytype='affy_hg_u133_plus_2')
  }
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods-Mart.R
\name{show,Mart-method}
\alias{show,Mart-method}
\alias{Mart-class}
\title{Class Mart}
\usage{
\S4method{show}{Mart}(object)
}
\arguments{
\item{object}{An object of class \code{Mart}}
}
\description{
Represents a Mart class, containing connections to different BioMarts
}
\section{Methods}{
 \describe{\code{show} Print summary of the object}
}

\author{
Steffen Durinck
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl.R
\name{listEnsemblArchives}
\alias{listEnsemblArchives}
\title{Lists the available archived versions of Ensembl}
\usage{
listEnsemblArchives()
}
\description{
Returns a table containing the available archived versions of Ensembl, along
with the dates they were created and the URL used to access them.
}
\examples{
listEnsemblArchives()

}
\author{
Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{attributePages}
\alias{attributePages}
\title{Gives a summary of the attribute pages}
\usage{
attributePages(mart)
}
\arguments{
\item{mart}{object of class Mart, created with the \code{\link[=useMart]{useMart()}} function.}
}
\description{
Attributes in BioMart databases are grouped together in attribute pages.
The \code{\link[=attributePages]{attributePages()}} function gives a summary of the attribute categories and
groups present in the BioMart.  These page names can be used to display only
a subset of the available attributes in the \code{\link[=listAttributes]{listAttributes()}} function.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart(
  "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl"
)
attributePages(mart)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utilityFunctions.R
\name{searchFilterOptions}
\alias{searchFilterOptions}
\alias{listFilterOptions}
\title{List or search the options available for a specified filter.}
\usage{
searchFilterOptions(mart, filter, pattern = ".*")

listFilterOptions(mart, filter)
}
\arguments{
\item{mart}{object of class \code{Mart} created using the
\code{\link[=useMart]{useMart()}}, or \code{\link[=useEnsembl]{useEnsembl()}} functions}

\item{filter}{The name of the filter whose options should be listed or
searched.  You can list available filters via \code{\link[=listFilters]{listFilters()}}}

\item{pattern}{Character vector defining the regular expression
(\link[base:regex]{regex}) to be used for the search.  If left blank the
default is to use ".*" which will match everything.}
}
\description{
Some filters have a predefined list of values that can be used to search
them.  These functions give access to this list of options for a named
filter, so you can check in the case where your biomaRt query is not finding
anything.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
## Use the Ensembl human genes dataset
ensembl <- useEnsembl(
  biomart = "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl"
)

## we can search for the name of a filter we're interested in e.g. 'phenotype'
## we need to use the name of the filter in the next function
searchFilters(ensembl, pattern = "phenotype")

## list all the options available to the 'phenotype_source' filter
listFilterOptions(mart = ensembl, filter = "phenotype_source")

## search the 'phenotype_description' filter for the term 'crohn'
searchFilterOptions(
  mart = ensembl,
  filter = "phenotype_description",
  pattern = "crohn"
)
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=listFilters]{listFilters()}}
}
\author{
Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NP2009code.R
\name{NP2009code}
\alias{NP2009code}
\title{Display the analysis code from the 2009 Nature protocols paper}
\usage{
NP2009code()
}
\description{
This function opens an editor displaying the analysis code of the Nature
Protocols 2009 paper
}
\details{
The \code{\link[=edit]{edit()}} function uses \code{getOption("editor")} to select
the editor. Use, for instance, \code{options(editor="emacs")} to set another
editor.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
NP2009code()
\dontshow{\}) # examplesIf}
}
\seealso{
\code{\link[=edit]{edit()}}
}
\author{
Steffen Durinck, Wolfgang Huber
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R, R/utilityFunctions.R
\name{listAttributes}
\alias{listAttributes}
\alias{searchAttributes}
\title{lists the attributes available in the selected dataset}
\usage{
listAttributes(mart, page, what = c("name", "description", "page"))

searchAttributes(mart, pattern = ".*")
}
\arguments{
\item{mart}{object of class Mart created using the \code{\link[=useMart]{useMart()}} function}

\item{page}{Show only the attributes that belong to the specified attribute
page.}

\item{what}{vector of types of information about the attributes that need to
be displayed.  Can have values like name, description, fullDescription, page}

\item{pattern}{Character vector defining the regular expression
(\link[base:regex]{regex}) to be used for the search.  If left blank the
default is to use ".*" which will match everything.}
}
\description{
Attributes are the outputs of a biomaRt query, they are the information we
want to retrieve.  For example if we want to retrieve all EntrezGene
identifiers of genes located on chromosome X, \code{entrezgene_id} will be
the attribute we use in the query.  The \code{listAttributes} function lists
the available attributes in the selected dataset.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
## list the available Ensembl marts and use Ensembl Genes
listEnsembl()
ensembl <- useEnsembl(
  biomart = "ENSEMBL_MART_ENSEMBL",
  dataset = 'hsapiens_gene_ensembl'
)

## list the available datasets in this Mart
listAttributes(mart = ensembl)

## the list of attributes is very long and gets truncated by R
## we can search for a term of interest to filter this e.g. 'start'
searchAttributes(mart = ensembl, pattern = "start")

## filter the attributes to give only entries containing 'entrez' or 'hgnc'
searchAttributes(mart = ensembl, 'entrez|hgnc')
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{getBM}
\alias{getBM}
\title{Retrieves information from the BioMart database}
\usage{
getBM(
  attributes,
  filters = "",
  values = "",
  mart,
  checkFilters = TRUE,
  verbose = FALSE,
  uniqueRows = TRUE,
  bmHeader = FALSE,
  quote = "\\"",
  useCache = TRUE
)
}
\arguments{
\item{attributes}{Attributes you want to retrieve.  A possible list of
attributes can be retrieved using the function \code{\link[=listAttributes]{listAttributes()}}.}

\item{filters}{Filters (one or more) that should be used in the query.  A
possible list of filters can be retrieved using the function \code{\link[=listFilters]{listFilters()}}.}

\item{values}{Values of the filter, e.g. vector of affy IDs.  If multiple
filters are specified then the argument should be a list of vectors of which
the position of each vector corresponds to the position of the filters in
the filters argument.}

\item{mart}{object of class Mart, created with the \code{\link[=useMart]{useMart()}} function.}

\item{checkFilters}{Sometimes attributes where a value needs to be
specified, for example upstream_flank with value 20 for obtaining upstream
sequence flank regions of length 20bp, are treated as filters in BioMarts.
To enable such a query to work, one must specify the attribute as a filter
and set \code{checkFilters = FALSE} for the query to work.}

\item{verbose}{When using biomaRt in webservice mode and setting verbose to
TRUE, the XML query to the webservice will be printed.}

\item{uniqueRows}{If the result of a query contains multiple identical rows,
setting this argument to \code{TRUE} (default) will result in deleting the
duplicated rows in the query result at the server side.}

\item{bmHeader}{Boolean to indicate if the result retrieved from the BioMart
server should include the data headers or not, defaults to \code{FALSE}.  This
should only be switched on if the default behavior results in errors,
setting to on might still be able to retrieve your data in that case}

\item{quote}{Sometimes parsing of the results fails due to errors in the
Ensembl data fields such as containing a quote, in such cases you can try to
change the value of quote to try to still parse the results.}

\item{useCache}{Boolean indicating whether the results cache should be used.
Setting to \code{FALSE} will disable reading and writing of the cache.  This
argument is likely to disappear after the cache functionality has been
tested more thoroughly.}
}
\value{
A \code{data.frame}. There is no implicit mapping between its rows
and the function arguments (e.g. \code{filters}, \code{values}), therefore
make sure to have the relevant identifier(s) returned by specifying them in
\code{attributes}. See Examples.
}
\description{
This function is the main biomaRt query function.  Given a set of filters
and corresponding values, it retrieves the user specified attributes from
the BioMart database one is connected to.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL",
                   dataset = "hsapiens_gene_ensembl")

getBM(attributes = c("affy_hg_u95av2", "hgnc_symbol", "chromosome_name", "band"),
      filters    = "affy_hg_u95av2",
      values     = c("1939_at","1503_at","1454_at"),
      mart       = mart)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

\name{getXML}
\alias{getXML}
\title{Retrieves information from the BioMart database using an XML query}
\description{DEPRECATED! - This function is a low level query function bypassing lots of biomaRts internal controls.  It allows for a direct XML query to a known BioMart webservice host.}

\usage{getXML(host="http://www.ensembl.org/biomart/martservice?", xmlquery)}

\arguments{
  \item{host}{URL to BioMart webservice, is set to http://www.ensembl.org/biomart/martservice? by default}
  \item{xmlquery}{XML query that needs to be send to the webservice}
}

\details{This function has now been deprecated.  Similar functionality can be 
achieved using the unexported function `\code{biomaRt:::.submitQueryXML}.  If 
you are still using this function and this affects your work, please contact 
the package maintainer at https://github.com/grimbough/biomaRt/issues}

\author{Steffen Durinck, Mike Smith} 

\examples{
if(interactive()){
xmlquery="<?xml version='1.0' encoding='UTF-8'?>
            <!DOCTYPE Query>
            <Query virtualSchemaName = 'default' uniqueRows = '1' 
                   count = '0' datasetConfigVersion = '0.6'>
                <Dataset name = 'hsapiens_gene_ensembl'>
                    <Attribute name = 'ensembl_gene_id'/>
                    <Filter name = 'chromosome_name' value = 'Y' />
                </Dataset>
            </Query>"
getXML(host = "www.ensembl.org/biomart/martservice?", xmlquery = xmlquery)
}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{getLDS}
\alias{getLDS}
\title{Retrieves information from two linked datasets}
\usage{
getLDS(
  attributes,
  filters = "",
  values = "",
  mart,
  attributesL,
  filtersL = "",
  valuesL = "",
  martL,
  verbose = FALSE,
  uniqueRows = TRUE,
  bmHeader = TRUE
)
}
\arguments{
\item{attributes}{Attributes you want to retrieve of primary dataset.  A
possible list of attributes can be retrieved using the function
\code{\link[=listAttributes]{listAttributes()}}.}

\item{filters}{Filters that should be used in the query. These filters will
be applied to primary dataset.  A possible list of filters can be retrieved
using the function \code{\link[=listFilters]{listFilters()}}.}

\item{values}{Values of the filter, e.g. list of affy IDs}

\item{mart}{object of class Mart created with the \code{\link[=useMart]{useMart()}} function.}

\item{attributesL}{Attributes of linked dataset that needs to be retrieved}

\item{filtersL}{Filters to be applied to the linked dataset}

\item{valuesL}{Values for the linked dataset filters}

\item{martL}{Mart object representing linked dataset}

\item{verbose}{When using \pkg{biomaRt} in webservice mode and setting
verbose to \code{TRUE}, the XML query to the webservice will be printed.
Alternatively in MySQL mode the MySQL query will be printed.}

\item{uniqueRows}{Logical to indicate if the BioMart web service should
return unique rows only or not.  Has the value of either \code{TRUE} or \code{FALSE}}

\item{bmHeader}{Boolean to indicate if the result retrieved from the BioMart
server should include the data headers or not, defaults to \code{TRUE}.  This
should only be switched off if the default behavior results in errors,
setting to off might still be able to retrieve your data in that case}
}
\description{
This function is the main biomaRt query function that links 2 datasets and
retrieves information from these linked BioMart datasets.  In Ensembl this
translates to homology mapping.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
human <- useMart(
  "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl",
  host = "https://dec2021.archive.ensembl.org"
)
mouse <- useMart(
  "ENSEMBL_MART_ENSEMBL",
  dataset = "mmusculus_gene_ensembl",
  host = "https://dec2021.archive.ensembl.org"
)
getLDS(
  attributes = c("hgnc_symbol","chromosome_name", "start_position"),
  filters = "hgnc_symbol",
  values = "TP53",
  mart = human,
  attributesL = c("chromosome_name","start_position"),
  martL = mouse
)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportFASTA.R
\name{exportFASTA}
\alias{exportFASTA}
\title{Exports getSequence results to FASTA format}
\usage{
exportFASTA(sequences, file)
}
\arguments{
\item{sequences}{A data.frame that was the output of the \code{\link[=getSequence]{getSequence()}}
function}

\item{file}{File to which you want to write the data}
}
\description{
Exports getSequence results to FASTA format
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")

seq <- getSequence(
  id = "BRCA1",
  type = "hgnc_symbol",
  seqType = "cdna",
  mart = mart
)
exportFASTA(seq, file = "test.fasta")
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck

Hugo Gruson
}
\keyword{methods}

\name{searchFilterValues}
\alias{searchFilterValues}
\alias{listFilterValues}
\title{List or search the options available for a specified filter.}
\description{Some filters have a predefined list of values that can be used
to search them.  These functions give access to this list of options for
a named filter, so you can check in the case where your biomaRt query is 
not finding anything.}

\usage{
    listFilterValues(mart, filter)
    searchFilterValues(mart, filter, pattern)
}

\arguments{
\item{mart}{object of class \code{Mart} created using the \code{\link{useMart}}, 
or \code{\link{useEnsembl}} functions}
\item{filter}{The name of the filter whose options should be listed or searched.  You
can list available filters via \code{\link{listFilters}}}
\item{pattern}{Character vector defining the regular expression (\code{\link[base]{regex})}
to be used for the search.  If left blank the default is to use ".*" which will match everything.}
}

\author{Mike Smith} 

\examples{

if(interactive()){

    ## Use the Ensembl human genes dataset
    ensembl <- useEnsembl(biomart = "ensembl", dataset = "hsapiens_gene_ensembl")

    ## we can search for the name of a filter we're interested in e.g. 'phenotype'
    ## we need to use the name of the filter in the next function
    searchFilters(ensembl, pattern = "phenotype")
    
    ## list all the options available to the 'phenotype_source' filter
    listFilterValues(mart = ensembl, filter = "phenotype_source")
    
    ## search the 'phenotype_description' filter for the term 'crohn'
    searchFilterValues(mart = ensembl, 
                       filter = "phenotype_description", 
                       pattern = "crohn")
}

}

\seealso{
    \code{\link{listFilters}}
}

\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R, R/utilityFunctions.R
\name{listDatasets}
\alias{listDatasets}
\alias{searchDatasets}
\title{List or search the datasets available in the selected BioMart database}
\usage{
listDatasets(mart, verbose = FALSE)

searchDatasets(mart, pattern = ".*")
}
\arguments{
\item{mart}{object of class Mart created with the useMart function}

\item{verbose}{Give detailed output of what the method is doing, for
debugging purposes}

\item{pattern}{Character vector defining the regular expression
(\link[base:regex]{regex}) to be used for the search.  If left blank the
default is to use ".*" which will match everything and return the same as
\code{\link[=listDatasets]{listDatasets()}}.}
}
\description{
Lists or search the datasets available in the selected BioMart database
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
## list the available Ensembl marts and use Ensembl Genes
listEnsembl()
ensembl <- useEnsembl(biomart = "ENSEMBL_MART_ENSEMBL")

## list the available datasets in this Mart
listDatasets(mart = ensembl)

## the list of Ensembl datasets grows ever larger (101 as of Ensembl 93)
## we can search for a term of interest to reduce the length e.g. 'sapiens'
searchDatasets(mart = ensembl, pattern = "sapiens")

## search for any dataset containing the word Rat or rat
searchDatasets(mart = ensembl, pattern = "(R|r)at")
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods-Mart.R
\name{select-methods}
\alias{select-methods}
\alias{keys,Mart-method}
\alias{columns,Mart-method}
\alias{keytypes,Mart-method}
\alias{select,Mart-method}
\alias{keys}
\alias{columns}
\alias{keytypes}
\alias{select}
\title{Retrieve information from the BioMart databases}
\usage{
\S4method{keys}{Mart}(x, keytype, ...)

\S4method{keytypes}{Mart}(x)

\S4method{columns}{Mart}(x)

\S4method{select}{Mart}(x, keys, columns, keytype, ...)
}
\arguments{
\item{x}{the \code{Mart} object. The dataset of the \code{Mart} object must
already be specified for all of these methods.}

\item{keytype}{the keytype that matches the keys used.  For the
\code{select} methods, this is used to indicate the kind of ID being used
with the keys argument. For the \code{keys} method this is used to indicate
which kind of keys are desired from \code{keys}}

\item{...}{other arguments.  These include: \describe{ \item{pattern:}{the
pattern to match (used by keys)} \item{column:}{the column to search on.
This is used by keys and is for when the thing you want to pattern match is
different from the keytype, or when you want to simply want to get keys that
have a value for the thing specified by the column argument.}
\item{fuzzy:}{TRUE or FALSE value.  Use fuzzy matching? (this is used with
pattern by the keys method)} }}

\item{keys}{the keys to select records for from the database.  Keys for some
keytypes can be extracted by using the \code{keys} method.}

\item{columns}{the columns or kinds of things that can be retrieved from the
database.  As with \code{keys}, all possible columns are returned by using
the \code{columns} method.}
}
\value{
\code{keys},\code{columns} and \code{keytypes} each return a
character vector or possible values.  \code{select} returns a data.frame.
}
\description{
\code{select}, \code{columns} and \code{keys} are used together to extract
data from a \code{Mart} object.  These functions work much the same as the
classic biomaRt functions such as \code{\link[=getBM]{getBM()}} etc. and are provide here to
make this easier for people who are comfortable using these methods from
other Annotation packages.  Examples of other objects in other packages
where you can use these methods include (but are not limited to):
\code{ChipDb}, \code{OrgDb} \code{GODb}, \code{InparanoidDb} and
\code{ReactomeDb}.
}
\details{
\code{columns} shows which kinds of data can be returned from the
\code{Mart} object.

\code{keytypes} allows the user to discover which keytypes can be passed in
to \code{select} or \code{keys} as the \code{keytype} argument.

\code{keys} returns keys from the \code{Mart} of the type specified by it's
\code{keytype} argument.

\code{select} is meant to be used with these other methods and has arguments
that take the kinds of values that these other methods return.
\code{select} will retrieve the results as a data.frame based on parameters
for selected \code{keys} and \code{columns} and \code{keytype} arguments.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
## 1st create a Mart object and specify the dataset
mart <- useEnsembl(
  biomart = "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl"
)
## you can list the keytypes
keytypes(mart)
## you can list the columns
columns(mart)
## And you can extract keys when this is supported for your keytype of interest
k <- keys(mart, keytype="chromosome_name")
head(k)
## You can even do some pattern matching on the keys
k <- keys(mart, keytype="chromosome_name", pattern="LRG")
head(k)
## Finally you can use select to extract records for things that you are
## interested in.
affy <- c("202763_at", "209310_s_at", "207500_at")
select(mart, keys=affy, columns=c('affy_hg_u133_plus_2','entrezgene_id'),
  keytype='affy_hg_u133_plus_2')
\dontshow{\}) # examplesIf}
}
\author{
Marc Carlson
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl_wrappers.R
\name{getGene}
\alias{getGene}
\title{Retrieves gene annotation information given a vector of identifiers}
\usage{
getGene(id, type, mart)
}
\arguments{
\item{id}{vector of gene identifiers one wants to annotate}

\item{type}{type of identifier, possible values can be obtained by the
listFilters function.  Examples are entrezgene_id, hgnc_symbol (for hugo
gene symbol), ensembl_gene_id, unigene, agilentprobe, affy_hg_u133_plus_2,
refseq_dna, etc.}

\item{mart}{object of class Mart, containing connections to the BioMart
databases.  You can create such an object using the function \code{\link[=useMart]{useMart()}}.}
}
\description{
This function retrieves gene annotations from Ensembl given a vector of
identifiers.  Annotation includes chromosome name, band, start position, end
position, gene description and gene symbol.  A wide variety of identifiers
is available in Ensembl, these can be found with the listFilters function.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")

# example using affy id
g <- getGene(id = "1939_at", type = "affy_hg_u95av2", mart = mart)
show(g)

# example using Entrez Gene id
g <- getGene(id = "100", type = "entrezgene_id", mart = mart)
show(g)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

\name{getBMlist}
\alias{getBMlist}
\title{Retrieves information from the BioMart database}
\description{This function is the main biomaRt query function.  Given a set of filters and corresponding values, it retrieves the user specified attributes from the BioMart database one is connected to}
\usage{getBMlist(attributes, filters = "", values = "", mart, 
list.names = NULL, na.value = NA, verbose = FALSE, giveWarning = TRUE)}

\arguments{
  \item{attributes}{Attributes you want to retrieve.  A possible list of attributes can be retrieved using the function listAttributes.}
  \item{filters}{Filters (one or more) that should be used in the query.  A possible list of filters can be retrieved using the function listFilters.}
  \item{values}{Values of the filter, e.g. vector of affy IDs.  If multiple filters are specified then the argument should be a list of vectors of which the position of each vector corresponds to the position of the filters in the filters argument.}
  \item{mart}{object of class Mart, created with the useMart function.}
\item{list.names}{names for objects in list}
\item{na.value}{value to give when result is empty}	 
\item{verbose}{When using biomaRt in webservice mode and setting verbose to TRUE, the XML query to the webservice will be printed.}
\item{giveWarning}{Gives a warning about best practices of biomaRt and recommends using getBM instead of getBMlist}
}

\author{Steffen Durinck} 

\examples{
if(interactive()){
mart <- useMart("ensembl")
datasets <- listDatasets(mart)

}
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ensembl.R
\name{listEnsembl}
\alias{listEnsembl}
\alias{listEnsemblGenomes}
\title{lists the available BioMart databases hosted by Ensembl}
\usage{
listEnsembl(
  mart = NULL,
  version = NULL,
  GRCh = NULL,
  mirror = NULL,
  verbose = FALSE
)

listEnsemblGenomes(includeHosts = FALSE, host = NULL)
}
\arguments{
\item{mart}{mart object created with the useEnsembl function.  This is
optional, as you usually use \code{\link[=listMarts]{listMarts()}} to see which marts
there are to connect to.}

\item{version}{Ensembl version to connect to when wanting to connect to an
archived Ensembl version}

\item{GRCh}{GRCh version to connect to if not the current GRCh38, currently
this can only be 37}

\item{mirror}{Specify an Ensembl mirror to connect to.  The valid options
here are 'www', 'useast', 'asia'.  If no mirror is specified the primary
site at www.ensembl.org will be used.}

\item{verbose}{Give detailed output of what the method is doing, for
debugging purposes}

\item{includeHosts}{If this option is set to \code{TRUE} a more detailed
output is produced, including the URL used to access the corresponding mart.}

\item{host}{Host to connect to. Use this argument to specify and archive
site for \code{\link[=listEnsemblGenomes]{listEnsemblGenomes()}} to work with.}
}
\description{
This function returns a list of BioMart databases hosted by Ensembl.  To
establish a connection use the \code{\link[=useEnsembl]{useEnsembl()}} function.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
listEnsembl()

## list the default Ensembl Genomes marts
listEnsemblGenomes()

## list only the marts available in the Ensmbl Plants 56 archive
listEnsemblGenomes(host = "https://eg56-plants.ensembl.org/")
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike L. Smith
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R
\name{filterType}
\alias{filterType}
\title{Displays the filter type}
\usage{
filterType(filter, mart)
}
\arguments{
\item{filter}{A valid filter name. Valid filters are given by the
\code{\link[=listFilters]{listFilters()}} function}

\item{mart}{object of class Mart, created using the \code{\link[=useMart]{useMart()}} function}
}
\description{
Displays the type of the filer given a filter name.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
mart <- useMart("ENSEMBL_MART_ENSEMBL", dataset = "hsapiens_gene_ensembl")
filterType("chromosome_name", mart)
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/biomaRt.R, R/utilityFunctions.R
\name{listFilters}
\alias{listFilters}
\alias{searchFilters}
\title{List or search the filters available in the selected dataset}
\usage{
listFilters(mart, what = c("name", "description"))

searchFilters(mart, pattern = ".*")
}
\arguments{
\item{mart}{object of class \code{Mart} created using the
\code{\link[=useMart]{useMart()}} function}

\item{what}{character vector indicating what information to display about
the available filters.  Valid values are \code{name}, \code{description},
\code{options}, \code{fullDescription}, \code{filters}, \code{type},
\code{operation}, \code{filters8}, \code{filters9}.}

\item{pattern}{Character vector defining the regular expression
(\link[base:regex]{regex}) to be used for the search.  If left blank the
default is to use `".*"`` which will match everything.}
}
\description{
Filters are what we use as inputs for a biomaRt query.  For example, if we
want to retrieve all EntrezGene identifiers on chromosome X,
\code{chromosome} will be the filter, with corresponding value X.
}
\examples{
\dontshow{if (interactive()) withAutoprint(\{ # examplesIf}
## list the available Ensembl marts and use Ensembl Genes
listEnsembl()
ensembl <- useEnsembl(
  biomart = "ENSEMBL_MART_ENSEMBL",
  dataset = "hsapiens_gene_ensembl"
)

## list the available datasets in this Mart
listFilters(mart = ensembl)

## the list of filters is long and not easy to read
## we can search for a term of interest to reduce this e.g. 'gene'
searchFilters(mart = ensembl, pattern = "gene")

## search the available filters to find entries containing 'entrez' or 'hgnc'
searchFilters(mart = ensembl, 'entrez|hgnc')
\dontshow{\}) # examplesIf}
}
\author{
Steffen Durinck, Mike Smith
}
\keyword{methods}
